/*
  ͻ
                                                                         
             DOMAINE     IBM-PC   MS-DOS(3.x+)       
                            PUBLIC                                 
                 Ren   Le protocole de Transfert BBT  
                          Cougnenc est de Jean-Claude Michot.     
                1989   La librairie de Comm.est de    
                                          Jean-Pierre Parisy & R.Gillmann
  Ķ
                                                                          
                    MODULE: BBT.C   INCLUDE BBT V3 COMPRESSED             
                    -------------                                         
    Adaptation du protocole de transfert BBT pour MS-DOS,et fonctions     
    spciales de scanning des sequences de QBBS et de BBT,et autres       
    utilitaires de transfert...                                           
                                                                          
   Compilation: modle mmoire LARGE                                      
  Ķ
   A partir de cette version, le protocole BBT n'est plus disponible en   
   source et vous ne pouvez donc pas disposer de ce module,et par  con-   
   squent lire ce texte...                                               
                                                                          
   Toute utilisation commerciale du protocole BBT est interdite sans au-  
   torisation ecrite de l'auteur, Jean-Claude Michot.                     
                                                                          
   Suit la description du protocole par l'auteur, le source commence     
   La ligne 320.                                                          
  ͼ
  Ŀ
   BbtH 1.2 
  
*/
/*--------------------------------------------------------------------------*\
 *  History: edcode.c   V1.5, 11-Nov-89  2:36:16pm, jcm,	Baseline    *
 *--------------------------------------------------------------------------*
 *                                                                          *
 *           This Module contains Proprietary Information of JCM            *
 *	               and should be treated as Confidential.               *
 *                                                                          *
\*--------------------------------------------------------------------------*/

/*--------------------------------------------------------*/
#ifndef __TURBOC__   /* Borland Turbo-c 1.5               */
#ifndef MSDOS        /* Microsoft C                       */
#error Mfiance ! je ne connais pas ce compilateur l...
#endif
#endif
/*--------------------------------------------------------*/


/*--------------------------------------------------------------------*
 *
 *    BBT Protocole de Transfert de fichier sur le serveur QBBS.
 *
 * BBT, beta version 1.0 :
 *
 * Protocole cree par Jean-Claude MICHOT en Juin 89 pour le transfert
 * de fichiers avec le serveur QBBS. Serveurs ASCII 80 Col accessible
 * par les PAVI (Videotex) Donc 7 Bits.
 *
 *--------------------------------------------------------------------*
 *
 *  Si vous avez un PB de portage ou d'adaptation de BBT vous pouvez
 *  me contacter le soir entre 8h et 22h au 47 88 59 12. [jcm]
 */


/*--------------------------------------------------------------------*
 *
 *    BBT Protocole de Transfert de fichier sur le serveur QBBS.
 *
 * BBT, Version 1.4 :
 *
 * Protocole cree par Jean-Claude MICHOT en Juin 89 pour le transfert
 * de fichiers avec le serveur QBBS. Serveur ASCII 80 Col accessible
 * par les PAVI (Videotex) Donc 7 Bits.
 *
 *
 * TOUTE UTILISATION COMMERCIALE EST STRICTEMENT INTERDITE SANS L'ACCORD
 *                          ECRIT DE L'AUTEUR !
 *
 * A partir de la version 1.5 le protocole n'est plus disponible en
 * source. Donc ce fichier n'est en faite que la version 1.3 mais avec
 * quelques info sur la 1.5.
 * Contacter l'auteur pour toute information a propos de la version 1.5
 *
 * BBT V1.0 : version originale         debit 5,4 Ko / min
 * BBT V1.1 : version date + perm
 * BBT V1.2 : version slide window
 * BBT V1.3 : version CRC
 * BBT V1.4 : version eclate avec plein de goodies
 * BBT V1.5 : version                   debit + important !
 *
 *--------------------------------------------------------------------*/

/*
 * DESCRIPTION DU PROTOCOLE BBT
 * ----------------------------
 *
 * I   Reception de fichier
 *     --------------------
 *
 * a) Detection de debut d'envoi de fichier. C'est la chaine CR+"@@!@@"+CR
 *    fini et commence par un CR ( 0x0d ).
 * b) Reception d'une trame contenant la taille du fichier a recevoir
 *    et son nom suivit d'un CR. La taille et le nom du fichier sont
 *    separe par un espace.
 * c) Envoi de "!" + CR si l'on peu recevoir le fichier.
 *    Envoi de "?" + CR si l'on ne peu pas recevoir le fichier.
 *     par exemple on peu pas ouvrir le fichier. (disk full....)
 * d) Attend de recevoir un paquet de donnee.
 * e) Si le paquet est CR + "@@!@@" + CR alors c'est la fin de
 *    reception du fichier. Envoi "#" + CR pour signaler au
 *    remote bbt que le transfert c'est bien passe. et repart en a)
 * f) Decode le paquet de donnees.
 *    Si le CRC est OK alors on envoi "!" + CR et on l'ecrit sur le
 *     disque.
 *    Si le CRC n'est pas ok alors envoi "?" + CR
 * g) Retourne en d)
 *
 * II  Envoi de fichier pour le serveur
 *     --------------------------------
 *
 * a) Retournement du PAVI (75/1200)
 * b) Envoi CR + "@@!@@" + CR pour signaler le debut de transfert.
 * c) Envoi la taille du fichier + " " + nom du fichier.
 * d) Attend un paquet.
 * e) Si le paquet est different de "!" + CR alors PB... STOP !
 * f) On lit le fichier par bloc de 3072 Octets...
 * g) On encode et envoi le resultat sur le modem.
 * h) On attend un paquet de reponse de status.
 * j) Si tout est ok on recoi "!" + CR sinon on considere qu'il
 *    y a un PB de CRC et on renvoi le paquet.
 * j) Si on n'est pas en fin de fichier retour en f)
 * k) On a donc fini de recevoir le fichier... Mais on envoi
 *    quand meme "#" + CR pour signaler au remote BBT que tout
 *    a ete ok !
 * l) Retournement du PAVI (1200/75) (normal)
 *
 * III Encodage/Decodage de paquet de donnees
 *     --------------------------------------
 *
 *  C'est un encodage/decodage bete et mechant... C'est le meme principe
 *  que pour uuencode/uudecode (utilitaire unix) il me semble meme que
 *  transity utilise le meme principe mais leur fonction est 10 fois plus
 *  longue que celle que j'ai ecrit.
 *  Le principe est simple, On code 3 Octets 8 bits en 4 Octets 7 Bits
 *  d'ascii visualisable.
 *  Les paquets font 3 Ko en 8 bits donc 3 Ko + 1/4 de 3 Ko = 3840 Octets
 *  par paquet code en 7 Bits + les 4 octets en debut de bloc qui
 *  donne la longeur du paquet a recevoir (Ceci est utile pour faire un
 *  decodage 7 bits vers 8 bits sur le bon nombre d'octet) + 4 octets pour
 *  le CRC ce qui fait donc 3Ko + 1/4 de 3Ko + 4 + 4 = 3848 + 1 pour le CR.
 *
 *  --------------------------------------------------------------------
 *  --------------------------------------------------------------------
 *  TRANSACTION ECRITE EN CONTINUUM ALGO A LA SUITE DES DEMANDES
 *
 *  Decodage d'un PAQUET 7 Bits de BBT:
 *  Les paquets de donne ont le format suivant :
 *
 *  TAILLE_DU_PAQUET + DONNEES_EN_7_BITS + CRC ou CHECKSUM
 *
 *  Comment decode un paquet ?
 *
 *  - Il faut savoir que 3 octets 8 bits sont transforme en
 *    4 Octets 7 bits...
 *
 *  Voila grosso modo un exemple de decodage :
 *
 *
 *         12345678 12345678 12345678 12345678    Octet en 7 Bits
 *         -----------------------------------
 *
 *  Phase 1: on retise 32 decimal ou 20 hexa a chaqu'un des 4 octets recu.
 *
 *  Phase 2: on a alors le look suivant au niveau bits
 *
 *         soit 'a' le 1er  octet 8 bits
 *         soit 'b' le 2eme octet 8 bits
 *         soit 'c' le 3eme octet 8 bits
 *
 *         12345678 12345678 12345678 12345678    Octet en 7 Bits
 *         -----------------------------------
 *         00aaaaaa 00aabbbb 00bbbbcc 00cccccc
 *
 *  Phase 3: Passe au format 3 octets.
 *
 *         et apres avoir replace les bits dans 3 octets a la place
 *         de 4 octet on a
 *
 *         12345678 12345678 12345678             Octet en 8 Bits
 *         --------------------------
 *         aaaaaaaa bbbbbbbb cccccccc
 *
 *    En C le passe ce fait par le decalage suivant :
 *
 *    recu1 -= ' '; recu2 -= ' '; recu3 -= ' '; recu4 -= ' ';
 *    r8_1 = (recu1 << 2) | ((recu2 >> 4) & 0x3);
 *    r8_2 = (recu2 << 4) | ((recu3 >> 2) & 0xf);
 *    r8_3 = (recu2 << 6) | recu4;
 *
 *    La meme chose en Francais mathematique ca donne qqchose comme :
 *
 *    - On retire 32 au 4 octet recu,
 *    - Le 1er octet 8 bits est egale au (1er octet recu * par 4)
 *      ou (logique) le ( (2eme octet recu / par 16) et 3 )
 *    - Le 2eme octet 8 bits est egale au (2eme octet recu * par 16)
 *      ou (logique) le ( (3eme octet recu / par 4) et 15 )
 *    - Le 3eme octet 8 bits est egale au (3eme octet recu * par 64)
 *      ou (logique) le ( 4eme octet recu )
 *
 *  J'espere que vous allez arrive a me comprendre... Enfin c'est pas
 *  complique tu tout quand on a compris... Mais moi je suis vraiement
 *  pas pedagogue...
 *  [jcm]
 *  --------------------------------------------------------------------
 *  --------------------------------------------------------------------
 *
 * V   Le calcul du CHECKSUM ou du CRC
 *     -------------------------------
 *
 *  C'est une somme des octets a envoyer... avec un ET sur 0xffff
 *  L'utilite du & 0xffff est de faire en sorte que le CRC ne depasse
 *  pas 65536 soit 16 bits ou 4 digits en hexa !
 *
 *  Suite au demande du peuple, il a ete ajoute un mode CRC qui est
 *  par defaut dans les versions actuel de BBT. Le CRC est question
 *  est assez simple a calcule, il est utilise par de nombreux protocole
 *  tel que Xmodem, ... BBT reste toujours compatible avec les versions
 *  anterieur qui ne supporte par le CRC mais qui ont une simple somme
 *  de controle (Checksum)
 *
 *
 * IV  Portage sous emulateur ou programme de com
 *     ------------------------------------------
 *
 *  Il doit etre assez simple vu la tonne d'explications qui precede...
 *
 *
 * V   Problemes rencontres
 *     --------------------
 *
 *  La plus part de compilo n'ont pas la fonction zero en standard...
 *  aussi j'ai defini une petite macro.. #define zero(a,b) memset(a,0,b)
 *  mais la encore sur mac par exemple la fonction memset() ne semble
 *  pas exister donc voila comment reecrire zero().
 *  zero( char *a, unsigned b ) { int i; for(i=0; i<b; i++) a[i]=0; }
 *  Et pire que tout.. Toujours sur MAC... Pas moyen de trouve les
 *  fonctions atoh() et atoi(), Ascii to hexa et Ascii to integer.
 *  Alors la j'ai fait une grosse ruse (hehe) du style:
 *  atoi( char *a ) { int r; sscanf( a, "%d", &r ); return( r ); }
 *  atoh( char *a ) { int r; sscanf( a, "%x", &r ); return( r ); }
 *
 *
 *  Si vous avez un PB de portage ou d'adaptation de BBT vous pouvez
 *  me contacter le soir entre 8h et 22h au 47 88 59 12. [jcm]
 *
 *  De nombreuse adaption du protocole on deja ete realise sur un
 *  grand nombre de machine. (Atari, Amiga, Mac, PC (MS-DOS), Unix...)
 *  Bien que ce programme ne soit pas clair vu le nombre de modifications
 *  qu'il a subit et la maniere dont il a ete ecrit le protocole reste
 *  par lui meme d'une tres grande simplicite.
 *
 *
 *
 * Aditif: Le 17 Aout 89 a 00h05 (Version 1.1)
 *         J'ajoute la date et les permissions du fichier dans
 *         le 1er bloc du protocole BBT.
 *
 * Aditif: Carnet de bord du Capitain, coefficient espace temps 5000.3.7
 *         Debut de restructuration du programme.
 *         Et Mr Spock a donner quelques info sur les "bugs reports"
 *         (Le 27 Aout 89 a 01h30)
 *
 * Aditif: Base lunaire alfa, Commandant john Quenig au rapport,
 *         Modification des 0 dans "name_locate" par My_nid.
 *
 * Aditif: Ajout des options +fast et s=size_packet -slide. (Version 1.2)
 *         +fast permet les transfers rapide mais charge la ligne x25
 *          ceci est inutile pour les transferts a 1200 Baud mais deviens
 *          tres utile pour quand on arrive a 2400,4800,9600 ou 19200.
 *         s=size_packet permet de modifier la taille de packet qui sont
 *          envoyer par BBT.
 *         bbt devient aussi 'slide windows' dans le sens ou la taille
 *          des packets varie s'il y a des BAD CRC l'option -slide
 *          permet de force le fait de ne pas faire de slide windows.
 *         (Dimanche 10 Septembre 1989)
 *
 * Aditif: Modification pour trouve la cause du BUG reporte par Ldfa
 *          (Pascal Grange) qui a constater que si la taille des paquets
 *          n'etait pas un multiple de 3 on avais de Pb... j'ai modifier
 *          la fonction "decode()".
 *         Timing sur le 1er paquet... On le renvoi 4 fois de suite avec
 *          10 secondes d'interval.
 *         (Jeudi 28 Septembre 1989)
 *
 * Aditif: Suppression du mode +text qui pose des pb car la taille de ce
 *          qui est envoyer est > a la taille du fichier donc a la taille
 *          de ce qui est attendu.
 *         Incorporation d'un vraie CRC qui est calcule tres rapidement.
 *          Le programme reste toujours compatible avec les versions qui
 *          n'utilise pas le CRC mais un simple CHECKSUM.
 *         (Lundi 09 Octobre 1989)
 *
 * Aditif: J'ai modifie la gestion d'index de fichier a downloader,
 *          afin que le fichier le soit plus ouvert tout le temps.
 *         Gestion d'arret de transfert dans 'get_paquet()'.
 *         (Lundi 30 Octobre 1989)
 *
 * Aditif: revison du bazard actuel du protocole, de cette revision est ne
 *          la version 1.5 du protocole. A partir d'ici le source ne sera
 *          plus disponible en raison du pillage intence que certain
 *          concepteur de serveur (3615) on effectue sur ce protocole tout
 *          en disant qu'il etait null en conception et en programmation.
 *         Moi je m'en fout il marche tres bien... hehe...
 *         A titre indicatif la version 1.5 est entierement compatible avec
 *          les precedentes mais elle a un debit de transfert de 7 Ko/ min
 *          et ceci quelquesoit les fichiers transferes !        |
 *         Bientot, les versions PC et ATARI...                  |
 *         (Mercredi 1 Novembre 1989)              T'exqagere un |
 *                                                 peu JC... 56 |
 *                                                   ----------  |
 */
/*---------------------------------------------------------------------------*/


#ifdef __TURBOC__
#include <mem.h>
#else
#include <memory.h>
#include <sys/types.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <math.h>
#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <io.h>


#include "bbth.h"
#include "touches.h"
#include "config.h"
#include "couleurs.h"
#include "clavecra.h"
#include "fonction.h"
#include "bbt.h"
#include "xymodem.h"



byte *SS_TRANS="@@!@@";     /* chaine de depart de BBT en transfert */
byte *SS_START="\r@@!@@\r";
byte Start_len=7;          /* longueur de a    pour pas calculer...*/

byte *SS_STOP ="\r#BREAK#\r";


/*---------------------------------------------------------------------------*/
/*  Ici le numero de version qui sera envoye dans le preier paquet et dans
    le premier acquittement, pour donner l'accord d'une verification CRC     */

              byte *__BbtVersion__="03";

/*----------------------------------------------------------------------------*/

byte rb[ SIZBUF ]; /* tampon reception paquet */
byte de[ SIZBUF ]; /* tampon rb dcod        */

byte BbtFile[80]="\0";
long size;          /* taille du fichier       */
int FileUp  ;       /* Handle Fichier telechargement */
int Vitesse;        /* la vitesse de Transfert       */

byte BbtScanTmp[10]="\0"; /* Pour scanner la chaine de depar transfert */
byte BbtScanIdx = 0;      /* position la dedans                        */
int  UploadBbt =  0;      /* Flag pour ne pas boucler si upload...     */
int  ModeCrc   =  0;      /* Flag pour traiter en Crc ou non           */
int  BbtCompress = 0 ;    /* Flag si compression, large pour garbage:) */

byte QbbsScanTmp[3]="\0"; /* Pour scanner l'identification QBBS        */
byte QbbsScanIdx=0;       /* position la dedans                        */





/* Table de decodage [jcm] */
static char table[128][5] =
	{
	{ 0x20, 0x20, 0x20, 0x20, 0x20 }, { 0x20, 0x20, 0x20, 0x20, 0x40 },
	{ 0x20, 0x20, 0x20, 0x20, 0x60 }, { 0x20, 0x20, 0x20, 0x40, 0x20 },
	{ 0x20, 0x20, 0x20, 0x40, 0x40 }, { 0x20, 0x20, 0x20, 0x40, 0x60 },
	{ 0x20, 0x20, 0x20, 0x60, 0x20 }, { 0x20, 0x20, 0x20, 0x60, 0x40 },
	{ 0x20, 0x20, 0x20, 0x60, 0x60 }, { 0x20, 0x20, 0x40, 0x20, 0x20 },
	{ 0x20, 0x20, 0x40, 0x20, 0x40 }, { 0x20, 0x20, 0x40, 0x20, 0x60 },
	{ 0x20, 0x20, 0x40, 0x40, 0x20 }, { 0x20, 0x20, 0x40, 0x40, 0x40 },
	{ 0x20, 0x20, 0x40, 0x40, 0x60 }, { 0x20, 0x20, 0x40, 0x60, 0x20 },
	{ 0x20, 0x20, 0x40, 0x60, 0x40 }, { 0x20, 0x20, 0x40, 0x60, 0x60 },
	{ 0x20, 0x20, 0x60, 0x20, 0x20 }, { 0x20, 0x20, 0x60, 0x20, 0x40 },
	{ 0x20, 0x20, 0x60, 0x20, 0x60 }, { 0x20, 0x20, 0x60, 0x40, 0x20 },
	{ 0x20, 0x20, 0x60, 0x40, 0x40 }, { 0x20, 0x20, 0x60, 0x40, 0x60 },
	{ 0x20, 0x20, 0x60, 0x60, 0x20 }, { 0x20, 0x20, 0x60, 0x60, 0x40 },
	{ 0x20, 0x20, 0x60, 0x60, 0x60 }, { 0x20, 0x40, 0x20, 0x20, 0x20 },
	{ 0x20, 0x40, 0x20, 0x20, 0x40 }, { 0x20, 0x40, 0x20, 0x20, 0x60 },
	{ 0x20, 0x40, 0x20, 0x40, 0x20 }, { 0x20, 0x40, 0x20, 0x40, 0x40 },
	{ 0x20, 0x40, 0x20, 0x40, 0x60 }, { 0x20, 0x40, 0x20, 0x60, 0x20 },
	{ 0x20, 0x40, 0x20, 0x60, 0x40 }, { 0x20, 0x40, 0x20, 0x60, 0x60 },
	{ 0x20, 0x40, 0x40, 0x20, 0x20 }, { 0x20, 0x40, 0x40, 0x20, 0x40 },
	{ 0x20, 0x40, 0x40, 0x20, 0x60 }, { 0x20, 0x40, 0x40, 0x40, 0x20 },
	{ 0x20, 0x40, 0x40, 0x40, 0x40 }, { 0x20, 0x40, 0x40, 0x40, 0x60 },
	{ 0x20, 0x40, 0x40, 0x60, 0x20 }, { 0x20, 0x40, 0x40, 0x60, 0x40 },
	{ 0x20, 0x40, 0x40, 0x60, 0x60 }, { 0x20, 0x40, 0x60, 0x20, 0x20 },
	{ 0x20, 0x40, 0x60, 0x20, 0x40 }, { 0x20, 0x40, 0x60, 0x20, 0x60 },
	{ 0x20, 0x40, 0x60, 0x40, 0x20 }, { 0x20, 0x40, 0x60, 0x40, 0x40 },
	{ 0x20, 0x40, 0x60, 0x40, 0x60 }, { 0x20, 0x40, 0x60, 0x60, 0x20 },
	{ 0x20, 0x40, 0x60, 0x60, 0x40 }, { 0x20, 0x40, 0x60, 0x60, 0x60 },
	{ 0x20, 0x60, 0x20, 0x20, 0x20 }, { 0x20, 0x60, 0x20, 0x20, 0x40 },
	{ 0x20, 0x60, 0x20, 0x20, 0x60 }, { 0x20, 0x60, 0x20, 0x40, 0x20 },
	{ 0x20, 0x60, 0x20, 0x40, 0x40 }, { 0x20, 0x60, 0x20, 0x40, 0x60 },
	{ 0x20, 0x60, 0x20, 0x60, 0x20 }, { 0x20, 0x60, 0x20, 0x60, 0x40 },
	{ 0x20, 0x60, 0x20, 0x60, 0x60 }, { 0x20, 0x60, 0x40, 0x20, 0x20 },
	{ 0x20, 0x60, 0x40, 0x20, 0x40 }, { 0x20, 0x60, 0x40, 0x20, 0x60 },
	{ 0x20, 0x60, 0x40, 0x40, 0x20 }, { 0x20, 0x60, 0x40, 0x40, 0x40 },
	{ 0x20, 0x60, 0x40, 0x40, 0x60 }, { 0x20, 0x60, 0x40, 0x60, 0x20 },
	{ 0x20, 0x60, 0x40, 0x60, 0x40 }, { 0x20, 0x60, 0x40, 0x60, 0x60 },
	{ 0x20, 0x60, 0x60, 0x20, 0x20 }, { 0x20, 0x60, 0x60, 0x20, 0x40 },
	{ 0x20, 0x60, 0x60, 0x20, 0x60 }, { 0x20, 0x60, 0x60, 0x40, 0x20 },
	{ 0x20, 0x60, 0x60, 0x40, 0x40 }, { 0x20, 0x60, 0x60, 0x40, 0x60 },
	{ 0x20, 0x60, 0x60, 0x60, 0x20 }, { 0x20, 0x60, 0x60, 0x60, 0x40 },
	{ 0x20, 0x60, 0x60, 0x60, 0x60 }, { 0x40, 0x20, 0x20, 0x20, 0x20 },
	{ 0x40, 0x20, 0x20, 0x20, 0x40 }, { 0x40, 0x20, 0x20, 0x20, 0x60 },
	{ 0x40, 0x20, 0x20, 0x40, 0x20 }, { 0x40, 0x20, 0x20, 0x40, 0x40 },
	{ 0x40, 0x20, 0x20, 0x40, 0x60 }, { 0x40, 0x20, 0x20, 0x60, 0x20 },
	{ 0x40, 0x20, 0x20, 0x60, 0x40 }, { 0x40, 0x20, 0x20, 0x60, 0x60 },
	{ 0x40, 0x20, 0x40, 0x20, 0x20 }, { 0x40, 0x20, 0x40, 0x20, 0x40 },
	{ 0x40, 0x20, 0x40, 0x20, 0x60 }, { 0x40, 0x20, 0x40, 0x40, 0x20 },
	{ 0x40, 0x20, 0x40, 0x40, 0x40 }, { 0x40, 0x20, 0x40, 0x40, 0x60 },
	{ 0x40, 0x20, 0x40, 0x60, 0x20 }, { 0x40, 0x20, 0x40, 0x60, 0x40 },
	{ 0x40, 0x20, 0x40, 0x60, 0x60 }, { 0x40, 0x20, 0x60, 0x20, 0x20 },
	{ 0x40, 0x20, 0x60, 0x20, 0x40 }, { 0x40, 0x20, 0x60, 0x20, 0x60 },
	{ 0x40, 0x20, 0x60, 0x40, 0x20 }, { 0x40, 0x20, 0x60, 0x40, 0x40 },
	{ 0x40, 0x20, 0x60, 0x40, 0x60 }, { 0x40, 0x20, 0x60, 0x60, 0x20 },
	{ 0x40, 0x20, 0x60, 0x60, 0x40 }, { 0x40, 0x20, 0x60, 0x60, 0x60 },
	{ 0x40, 0x40, 0x20, 0x20, 0x20 }, { 0x40, 0x40, 0x20, 0x20, 0x40 },
	{ 0x40, 0x40, 0x20, 0x20, 0x60 }, { 0x40, 0x40, 0x20, 0x40, 0x20 },
	{ 0x40, 0x40, 0x20, 0x40, 0x40 }, { 0x40, 0x40, 0x20, 0x40, 0x60 },
	{ 0x40, 0x40, 0x20, 0x60, 0x20 }, { 0x40, 0x40, 0x20, 0x60, 0x40 },
	{ 0x40, 0x40, 0x20, 0x60, 0x60 }, { 0x40, 0x40, 0x40, 0x20, 0x20 },
	{ 0x40, 0x40, 0x40, 0x20, 0x40 }, { 0x40, 0x40, 0x40, 0x20, 0x60 },
	{ 0x40, 0x40, 0x40, 0x40, 0x20 }, { 0x40, 0x40, 0x40, 0x40, 0x40 },
	{ 0x40, 0x40, 0x40, 0x40, 0x60 }, { 0x40, 0x40, 0x40, 0x60, 0x20 },
	{ 0x40, 0x40, 0x40, 0x60, 0x40 }, { 0x40, 0x40, 0x40, 0x60, 0x60 },
	{ 0x40, 0x40, 0x60, 0x20, 0x20 }, { 0x40, 0x40, 0x60, 0x20, 0x40 },
	};


/*-------------------------------------------------------------------------*/
/*     Recherche  chaque caractere entr sur le port d'un dpart BBT      */
/*-------------------------------------------------------------------------*/
/*
   Ce qui fera un transfert automatique command par le serveur.
*/

void BbtScan(byte ch)
   {
   if(UploadBbt != 0 )return;
   if( (ch==0x0D)&&(BbtScanIdx <2) ) /* Pour tenir compte du fait qu'il  */
              {                      /* Peut y avoir plusieurs RC avant  */
               BbtScanIdx=1;
               return;
              }
   if(ch==*(SS_START+BbtScanIdx))BbtScanIdx++;
   else
      {
        BbtScanIdx=0;
        return;
      }
   if(BbtScanIdx==Start_len)
      {
       BbtScanIdx=0;          /* Pour le prochain coup */
        sauvecran();
        curseur(0);
        Bbt_Receive();      /* Hop,au travail donc.  */
        curseur(1);
      rendecran();
      }
   }
/*-------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------*/
/*     Recherche de ESC CNTRL-E pour indiquer le terminal sur QBBS         */
/*-------------------------------------------------------------------------*/
/*
   Avant le login,QBBS envoie ESC-CNTRL E.
   En reponse il attend "T01\r" pour un terminal ANsi sous DOS.

   Si simplement CNTRL-E est recu, c'es traite comme un ENQ normal
   et la chaine TermId est envoyee. (mise en place par le repertoire).
*/

void QbbsScan(byte ch)
   {
   if(ch==27)
     {
       QbbsScanIdx=1;
       return;
     }

   if(!QbbsScanIdx)
      {
       if(ch==5)SendCommand(TermId);
      }
   else
      {
      if(ch==5)
         {
          SendCommand(Config.QbbsIdent);
          QbbsScanIdx=0;
          /* La classe,passe en qnx tout seul sur Qbbs! :*/

          if(strchr(Config.QbbsIdent,'T') )  Fonctions(ALT_A) ; /* T01 | T43 */
          if(strchr(Config.QbbsIdent,'V') )  Fonctions(ALT_A) ; /* VT-100... */
          if(strchr(Config.QbbsIdent,'C') )  Fonctions(ALT_A) ; /* VT COLOR  */
          if(strchr(Config.QbbsIdent,'q') )  Fonctions(ALT_Q) ; /* Qnx       */
          if(strchr(Config.QbbsIdent,'Q') )  Fonctions(ALT_Q) ;
          return;
         }
      QbbsScanIdx=0;
      }
   }
/*-------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------*/
/*     Affichage de la fenetre de transfert BBT                            */
/*-------------------------------------------------------------------------*/
void BbtBox(byte mode)  /* la fenetre en elle meme */
{
      box(20,10,45,22,Cyan_vert);
      mwrite(25,10,"   ENVOI  BBT   ",Inverse);
      mwrite(22,12,"Fichier:"             ,Jaune_vert);
      mwrite(22,13,"Taille :       Octets",Jaune_vert);
      mwrite(22,14,"Reste  :       Octets",Jaune_vert);
      mwrite(22,15,"Vitesse:       Cps"   ,Jaune_vert);
      mwrite(22,16,"Encore :"             ,Jaune_vert);
      mwrite(22,17,"Verif. :"             ,Jaune_vert);

      mwrite(25,19,"Dernier Message: ",Inverse);

   if(mode==RECEPTION)
      {
        mwrite(25,10," RECEPTION  BBT ",Inverse);
      }

   if(mode==EMISSION)
      {
        mwrite(25,10,"   ENVOI  BBT   ",Inverse);
      }

}
                     /*-----------------------------*/

void BbtMsg(byte *texte) /* message affich dans la fenetre */
{
  mwrite(22,21,"                      ",Blanc_vert);/* efface ancien message */
  mwrite(22,21,texte,Blanc_vert);
}
/*-------------------------------------------------------------------------*/




/*-------------------------------------------------------------------------*/
/*               RECEPTION PROTOCOLE BBT                                   */
/*-------------------------------------------------------------------------*/

void Bbt_Receive(void)
   {
   byte TextBuf[256];
   byte RecFich[63];
   int ch;
   int fichier;
   int l=0;  /* taille du paquet decode prvue */
   long dt=0L;
   long UnixDate=0;
   int NumPaquet=0;
   int UnixPerm;
   int RemoteVer=0;
   long Time0,Time;
   long SizeExist=0;

   BbtCompress = 0;
   BbtBox(RECEPTION);                /* affiche le cadre traditionnel download*/
   BbtMsg("Rception Entte");
   if( !get_paquet(0))return;         /* prend le premier paquet:nom&taille */
   sscanf( rb, "%ld %s %lx %x %x %d",
          &size, TextBuf ,&UnixDate,&UnixPerm,&RemoteVer,&BbtCompress);
   filtre_filename(RecFich,TextBuf);
   strcpy(TextBuf,Config.DownDir);
   strcat(TextBuf,RecFich);          /* Rajout de l'ventuel path download*/
   strcpy(BbtFile,TextBuf);
   ltoa(size,TextBuf,10);
   mwrite(30,12,RecFich,Blanc_vert);/*Affichage dans la fenetre nom & taille*/
   mwrite(30,13,TextBuf,Blanc_vert);/*Sans le path download                 */

   if(Config.BbtReprise)
        SizeExist =  FileExist(BbtFile); /* le fichier existe dj  ?       */
   else
   if(SizeExist !=0L)
     {
        RenameFile(BbtFile);  /*Protege l'ancien si pas reprise transfert   */
        SizeExist = 0L     ;  /*en le renommant subtilement...              */
     }

   if( SizeExist > MINRECUP )
     {
      dt = SizeExist;
      mwrite(20,23,"*  Reprise du Transfert  *",Rouge);
      ltoa(size - dt,TextBuf,10);   /* affiche compte restant */
      mwrite(30,14,TextBuf,Blanc_vert);
      sprintf(TextBuf," %ld",SizeExist);
     }
   if(NotPlace(size-SizeExist))
      {
        Send(NumPort,63);                   /* Demande abandon*/
        Send(NumPort,13);                   /* ?\r            */
        BbtMsg("Pas de place disque !");
        beep(2);
        delay(2000);          /* laisse 2 secondes le message */
        return;
      }
   if(SizeExist > MINRECUP)
     fichier=open(BbtFile,O_RDWR|O_BINARY|O_CREAT|O_APPEND,S_IREAD|S_IWRITE);
   else
     fichier=open(BbtFile,O_RDWR|O_BINARY|O_CREAT|O_TRUNC,S_IREAD|S_IWRITE);
   if(fichier==-1)
      {
        Send(NumPort,63);                   /* Demande abandon*/
        Send(NumPort,13);                   /* ?\r            */
        BbtMsg("Pas pu crer Fichier!");
        beep(2);
        delay(2000);          /* laisse 2 secondes le message */
        return;
      }


 if(RemoteVer >0)
      {
        ModeCrc=1;
        mwrite(30,17,"CRC ",Blanc_vert);
         if(RemoteVer == 2)   /* Version Rapide V2 ou +  detectee */
           {
             mwrite(30,17,"CRC + bbt II",Blanc_vert);
#ifdef BBTH
             CopyRight(2);    /* WARNING PROPRIETE DE JEAN CLAUDE */
#endif
           }
         if(RemoteVer == 3)   /* Version Rapide V2 ou +  detectee */
           {
             mwrite(30,17,"CRC + bbt III",Blanc_vert);
#ifdef BBTH
             CopyRight(3);    /* WARNING PROPRIETE DE JEAN CLAUDE */
#endif
           }
      }
      else
      {
        ModeCrc=0;
        mwrite(30,17,"CheckSum",Blanc_vert);
      }

   if(BbtCompress) mwrite(35,22," Compress ",112);

   Send(NumPort,33);                  /* Tout va bien,acquitement,on y va. */
   if(ModeCrc)
     SendCommand(__BbtVersion__);     /* on peut recevoir en CRC           */
   if(SizeExist > MINRECUP )
     SendCommand(TextBuf);            /* On en a deja un bout du fichier   */
   Send(NumPort,13);                  /* !\r                               */

   if((Mode_V23)&&(BaudRate==75))    /* Premiere Estime de la vitesse BBT  */
     Vitesse=87;                     /* C'est une Kx-TEl en V23!           */
   else
       {
        Vitesse=21*(BaudRate/300);
       }
   TraTime(Vitesse,size-SizeExist,0); /* calcul du temps de transfert      */

   time(&Time0);
   while (1)                 /*------- Boucle de reception                */
      {
      NumPaquet++;
      sprintf(TextBuf," Reoit le Paquet N%d",NumPaquet);
      BbtMsg(TextBuf);
      if(!get_paquet(0))
         {
           close(fichier);
           return;
         }

      if(kbhit())
         {
         ch=getch();
         if(ch==24)              /* Abort par CNTRL-X */
            {
              BbtMsg("Abandon utilisateur");
              beep(1);
              delay(2000);
              close(fichier);
              return;
            }
         }
      /* Fin de Transmission ?       */
      if ( strcmp( rb, SS_TRANS ) == 0 )
         {
           if(UnixDate !=0L) SetUnixTime(fichier,UnixDate);
            close( fichier );
            Send(NumPort,35);           /* Envoie acquittement correct */
            Send(NumPort,13);           /* #\r                         */
            BbtMsg("Rception Parfaite !");
            beep(3);
            delay(2000);
           return;
         }

      l=decode(RemoteVer);                        /* Decode le paquet ! */
      if(l)
         {
           Send(NumPort,33); /* C'est ok,on continue */
           Send(NumPort,13); /* !\r                   */
                             /* Et traite on pendant que le buffer  */
                             /* de comm se remplit a nouveau...     */
           time(&Time);
           if ( (dt+l) > size ) l =(int) ( size - dt);  /* Ah ? */
           write( fichier,de, l );
           dt += l ;
           ltoa(size - dt,TextBuf,10);   /* affiche compte restant */
           mwrite(30,14,TextBuf,Blanc_vert);
           Vitesse=TraSpeed(Time0,Time,dt-SizeExist);
           TraTime(Vitesse,size-dt,0);
         }
      else                        /* y'a eu un probleme de crc...  */
         {
           Send(NumPort,63); /* Demande reemission   */
           Send(NumPort,13); /* ?\r                               */
           sprintf(TextBuf, "Paquet %d Redemand",NumPaquet );
           BbtMsg(TextBuf);
           NumPaquet--;      /* pas malin,hein... */
         }
      }
   }
/*---------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------*/
/*               EMISSION  PROTOCOLE BBT                                   */
/*-------------------------------------------------------------------------*/

void Bbt_Send(int galere)
   {
   byte TextBuf[40];
   static byte NomFichier[20]="";
   byte *ptr=de;
   int i,Paquet;
   int retry=0;
   int NumPaquet=1;
   int RemoteVer=0;
   long Reste,Time0,Time;
   long UnixTime=0;
   long SizeExist=0;

   UploadBbt=1;                      /* bloque la detection down automatique */
   sauvecran();
   BbtBox(EMISSION);

   switch(galere)
         {
           case 1: Paquet=PETIPAQUET;  break;
           case2 : Paquet=MOYENPAQUET; break;
           default: Paquet=PAQUET;
         }

   size=filelength(FileUp);          /* prend la taille */
   Reste=size;
   UnixTime=GetUnixTime(FileUp);     /* prend la date   */
   ltoa(size,TextBuf,10);

   filtre_filename(NomFichier,BbtFile);     /* recup du nom seul du fichier */

   if(!Is_Compressed(NomFichier))            /*    compresse que les fichiers*/
     BbtCompress = 1;                        /* qui ne le sont pas dj      */

   sprintf(ptr,"\r%s\r%ld %s %lx 666 %s %d\r\0",
   SS_TRANS,size,NomFichier,UnixTime,__BbtVersion__,BbtCompress);
                                         /* prepare entte une chaine com*/
                                         /* posee de la sequence de start*/
                                         /* encadree par des CR puis de  */
                                         /* la taille,un espace et le nom*/
                                         /* du fichier,un espace puis la */
                                         /* date fichier, un space puis  */
                                         /* permission 666 pour Unix,et  */
                                         /* enfin du No de version BBT   */
                                         /* Et flag si compression paquet*/

   mwrite(30,12,NomFichier,Blanc_vert);/*Affichage dans la fenetre nom & taille*/
   mwrite(30,13,TextBuf,Blanc_vert);

   if((Mode_V23)&&(BaudRate==75))    /* Premiere Estime de la vitesse BBT  */
     Vitesse=87;                     /* C'est une Kx-TEl en V23!           */
   else
       {
        Vitesse=21*(BaudRate/300);
       }
   TraTime(Vitesse,Reste,0);        /* calcul du temps de transfert        */

   BbtMsg("Envoi de l'entte");

   while(*ptr)                              /* et envoi du header au remote*/
      {
        Send(NumPort,*ptr);
        ptr++;
      }

   if(!get_paquet(5))
      {
        close(FileUp);
        delay(2000);
        rendecran();
        UploadBbt=0;
        return;
      }
                                  /* l'entete est parti,maintenant on    */
   if( rb[0] != 33)               /* Attend autorisation serveur:chr '!' */
      {
        BbtMsg("Pas de rponse l bas!");
        beep(2);
        close(FileUp);
        delay(2000);
        rendecran();
        UploadBbt=0;
        return;
      }                       /* Ok, on peut y aller.                 */

   sscanf(rb+1,"%x",&RemoteVer);  /* test version Bbt pour voir si    */
   if(RemoteVer > 0)              /* l'autre cote connait le CRC      */
       {
          ModeCrc=1;
          mwrite(30,17,"CRC",Blanc_vert);
          if(RemoteVer == 3)
            {
              mwrite(30,17,"CRC + bbt III",Blanc_vert);
#ifdef BBTH
              CopyRight(3);    /* WARNING PROPRIETE DE JEAN CLAUDE */
#endif
            }
          if(RemoteVer == 2)
            {
              mwrite(30,17,"CRC + bbt II",Blanc_vert);
#ifdef BBTH
              CopyRight(2);    /* WARNING PROPRIETE DE JEAN CLAUDE */
#endif
              BbtCompress = 0; /* Pas de compression dans cette version */
            }
       }
     else
       {
         ModeCrc=0;
         BbtCompress = 0; /* Pas de compression dans cette version */
         mwrite(30,17,"CheckSum",Blanc_vert);
       }

    if (BbtCompress) mwrite(35,22," Compress ",112);
    if( RemoteVer > 1)
      {
       sscanf(rb+3,"%ld",&SizeExist);  /* Recup Transfert aborte si Ver=02 */
       if( SizeExist > 0L)
         {
           mwrite(20,23,"*  Reprise du Transfert  *",Rouge);
           sprintf(TextBuf," %ld",size - SizeExist);
           mwrite(30,14,TextBuf,Blanc_vert);
           if(SizeExist > size )
             {
              close(FileUp);
               BbtMsg("Erreur de taille !!!");
               beep(3);
               delay(2000);
               rendecran();
               UploadBbt=0;
              return;
             }
           lseek(FileUp,SizeExist,SEEK_SET);
           Reste-=SizeExist;
          TraTime(Vitesse,Reste,0);  /* Re-calcul du temps de transfert  */
         }
      }

   time(&Time0);
   while(1)                   /*----------Boucle d'mission           */
      {
      memset(rb,0,SIZBUF);
      if(!retry)
         {
           i=read(FileUp,rb,Paquet);
           if(i==0)break; /* fin de fichier */
           encode(i,RemoteVer);
           sprintf(TextBuf," Envoi du Paquet N%d",NumPaquet);
           BbtMsg(TextBuf);
         }

      if( !envoi_paquet(galere))
         {
           rendecran();
           UploadBbt=0;
           return;
         }

       sprintf(TextBuf," Attente acquittement",NumPaquet);
       BbtMsg(TextBuf);
      if(! get_paquet(60))
         {                          /* Attend aquitement */
           rendecran();
           UploadBbt=0;
           return;
         }

      if ( rb[0] != 33 )
         {
         sprintf(TextBuf, "Paquet %d Redemand",NumPaquet );
         BbtMsg(TextBuf);
         retry++;
         if(retry > MAXRETRY)/* trop mauvaise ligne,stop */
            {
              BbtMsg("Plus de 5 Retries !");
              beep(3);
              close(FileUp);
              delay(2000);
              rendecran();
              UploadBbt=0;
              return;
            }
         }
      else
         {
           time(&Time);
           Reste-=(long)i;
           retry=0;
           NumPaquet++;
           ltoa(Reste,TextBuf,10);  /* affiche ce qui reste */
           mwrite(30,14,"      ",Blanc_vert);
           mwrite(30,14,TextBuf,Blanc_vert);
           Vitesse=TraSpeed(Time0,Time,(size-SizeExist)-Reste);
           TraTime(Vitesse,Reste,0);       /* temps restant reel  */
         }
      }

   close(FileUp);                     /* Fin de transmission.*/
   sprintf(TextBuf,"%s\r\0",SS_TRANS);/* On l'indique au remote bbt */
   ptr=TextBuf;
   while(*ptr)
      {
        Send(NumPort,*ptr);
        ptr++;
      }
   get_paquet(60);                      /* Attend acquittement       */
   if ( rb[0] == 35 )
      BbtMsg("Transfert Reussi !");
   else
       BbtMsg("Fichier Envoy.");
   beep(3);
   delay(2000);
   rendecran();
   UploadBbt=0;     /* autorise de nouveau la reception automatique */
   }
/*---------------------------------------------------------------------------*/




/*---------------------------------------------------------------------------*/
/*         envoi du paquet encode au modem                                   */
/*---------------------------------------------------------------------------*/

int envoi_paquet(int galere)
   {
   byte *ptr;
   byte ch;
   register int i=0;

   ptr=de;         /* L'encod est la dedans */
   while(*ptr)    /* On l'envoie au modem   */
      {
      while(XFree(NumPort)<2) /* attend un peu de place buffer...*/
         {
         if(kbhit())
            {
            ch=getch();      /* arret par cntrl-x pour    */
            if(ch==24)      /* ne pas rester coinc l...*/
               {
                 beep(1);
                 BbtMsg("Envoi stopp par User !");
                 close(FileUp);
                 delay(2000); /* affiche 2 secondes */
                 ptr=SS_STOP;
                 while(*ptr)
                  {
                    Send(NumPort,*ptr);
                    ptr++;
                  }
               return(0);
               }
            }
         }
      if(galere==1)delay(120); /* Reduction  75 bauds pour les fous*/
      Send(NumPort,*ptr);      /* avec un petit buffer modem...     */
      ptr++;
      i++;
      if(i>MESURE)             /* Calcul du temps restant tous les 127 bytes*/
              {
                i=0;
                TraTime(Vitesse,0,(MESURE*2)/3);
              }
      }
   Send(NumPort,13);      /* suivi d'un RC */
   return(1);
   }
/*--------------------------------------------------------------------------*/






/*---------------------------------------------------------------------------*/
/*           reception d'un paquet de donnes                                */
/*---------------------------------------------------------------------------*/

int get_paquet(int DelaySend)
   {
   byte *ptr=rb;
   byte ch=0;
   register int compte=0,i=0;
   long Time0,Time1;

   memset(rb,0,SIZBUF);
   Time0 = 0L;
   while(compte<SIZBUF)  /* sait-on jamais... */
      {
      if(PortReady(NumPort))
         {
           Time0 = 0L;
           ch=Receive(NumPort);
           if(ch==13)
             {
               if(strncmp(rb,"#BREAK#",7)==0)
                 {
                   BbtMsg("Abandon du Remote.");
                   beep(1);
                   delay(2000);
                   return(0);
                 }
               return(compte);
             }
           *ptr=ch;
           ptr++;
           compte++;
           i++;
           if( i> MESURE)
             {
               i=0;
               TraTime(Vitesse,0,(MESURE * 2)/3);
             }
         }
      if(kbhit())
         {
           ch=getch();
           if(ch==24)  /* abort par Cntrl-X */
              {
                BbtMsg("Abandon utilisateur");
                beep(1);
                delay(2000);
                return(0);
              }
         }
      if (DelaySend != 0) {
         if (Time0 == 0L)
            time(&Time0);
         time(&Time1);
         if (Time1 < Time0)
            Time0 = Time1;
         if ((int) (Time1-Time0) > DelaySend)
                 {
                   BbtMsg("Time out");
                   beep(1);
                   delay(2000);
                   return(0);
                 }
         }
      }
   return(compte);
   }
/*---------------------------------------------------------------------------*/




/*---------------------------------------------------------------------------*/
/* ENCODAGE de rb[] en de[]                                                  */
/*---------------------------------------------------------------------------*/

encode(int l,int version)
{
	unsigned int crc;
	int i,j;
        byte trash[20];

        if( BbtCompress)     /* Compression du module JMODEM...:-)  */
          {
            l = J_encode(l, rb, de);
            memcpy(&rb[0] , &de[0] ,l);
          }

	memset( de,0, 8192 );
	sprintf( de, "%04d", l );
	j = 4;
	crc = 0;

	if ( version < 2 )
		{
		for( i=0; i<l; i+=3 )
			{
			de[j++] = ' ' + ((rb[i] >> 2) & 0x3f);
			de[j++] = ' ' + (((rb[i] << 4) & 0x30)   | ((rb[i+1] >> 4) & 0xf));
			de[j++] = ' ' + (((rb[i+1] << 2) & 0x3c) | ((rb[i+2] >> 6) & 0x3));
			de[j++] = ' ' + (rb[i+2] & 0x3f);
			}
		}
	else
		{
		char *cp,ct;

		for ( cp=&rb[0]; cp < (&rb[0]+l); cp+=4 )
			{
			ct = cp[3] & 0x7F;
			de[j++] = ( ((cp[0]&0xF8) >> 3)						| table[ct][0] );
			de[j++] = ( ((cp[0]&0x07) << 2)|((cp[1]&0xC0)>>6)	| table[ct][1] );
			de[j++] = ( ((cp[1]&0x3E) >> 1)						| table[ct][2] );
			de[j++] = ( ((cp[1]&0x01) << 4)|((cp[2]&0xF0)>>4)	| table[ct][3] );
			de[j++] = ( ((cp[2]&0x0F) << 1)|((cp[3]&0x80)>>7)	| table[ct][4] );
			}
		}

      if(ModeCrc) crc = calcrc( de, strlen( de ) ); /* crc du x modem */
      else  crc = CheckSum( de, strlen( de ) );    /* checksum       */

	sprintf( trash, "%04X", crc );
	strcat( de, trash );

	return (crc);
}
/*---------------------------------------------------------------------------*/




/*--------------------------------------------------------------------------*/
/* DECODAGE de rb[]  en de[]                                                */
/*--------------------------------------------------------------------------*/
/*
  La taille du paquet decode est en ascii dans les 4 premiers octets.
*/

decode(int version)
{	int l,s;	/* retourne la longeur du paquet decode ou 0 si pb CRC */
	int i,j,k;
	unsigned int crc,rcrc;
        byte trash[20];

	memset( trash,0, 9 );			/* Met a 0 lng[] */
	strncpy( trash, rb, 4 );		/* Copie les 4 1er caract. de rb[] */
	l = s = atoi( trash );			/* Convertion en numerique */
	i=0;

       rcrc = atoh( rb + strlen(rb) - 4 );
       if(ModeCrc) crc = calcrc( rb, strlen(rb) - 4 ); /* Crc du x-modem */
         else      crc = CheckSum( rb, strlen(rb) - 4 ); /*  somme&0xffff */

	if ( crc != rcrc ) return(0);	/* Erreur de CRC */

	if ( version < 2 )
		{
		for( k=4; l>0; k+= 4)
			{
			for(j=0;j<4;j++) rb[k+j] -= ' ';
			de[i++] = ((rb[k] << 2) | ((rb[k+1] >> 4) & 0x3));
			if(--l >= 0) de[i++] = ((rb[k+1] << 4) | ((rb[k+2] >> 2) & 0xf));
			if(--l >= 0) de[i++] = ((rb[k+2] << 6) | rb[k+3]);
			l--;
			}
		}
	else
		{
		char *cp;
		int	table;

		l = strlen( rb ) - 4;

		for( j=0, cp=&rb[4]; cp < (&rb[4]+l); cp+=5 )
			{
			de[ i++ ] = ((cp[0]&0x1f)<<3) | ((cp[1]&0x1C)>>2);
			de[ i++ ] = ((cp[1]&0x03)<<6) | ((cp[2]&0x1F)<<1)|((cp[3]&0x10)>>4);
			de[ i++ ] = ((cp[3]&0x0f)<<4) | ((cp[4]&0x1E)>>1);
			for( table=0,k=0; k<5; k++ ) table=table*3+((cp[k]&0x60)>>5)-1;
			de[ i++ ] = ((cp[4]&1)<<7) | table;
			j+=4;
			};
		}

         if(BbtCompress)
           {
             s= J_decode( s, &de[0], &rb[0] );
             memcpy( & de[0], &rb[0], s);
           }
	return ( s );
}
/*---------------------------------------------------------------------------*/




/*---------------------------------------------------------------------------*/
/*            Calcul du CheckSum d'un paquet msg[] de taille l               */
/*---------------------------------------------------------------------------*/

int CheckSum(byte *msg,int l)
   {
   register int i,crc=0;

   for( i=0; i<l; i++ ) crc = (crc + msg[i]) & 0xffff;
   return ( crc );
   }
/*---------------------------------------------------------------------------*/



/*-----------------transfo hexa ascii en entier -------------------------*/
/* faudra voir j'ai ecrit a un jour,mais en attendant que je trouve..   */
/* le truc de jcm est trs bien...                                       */

int atoh( char *a )
   {
   int r;
   sscanf( a, "%x", &r );
   return( r );
   }
/*------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------*/
/* Recuperation d'un nom de fichier sans chemin d'acces ms-dos             */
/*-------------------------------------------------------------------------*/


byte *last(byte *arg)
   {
   int r;

   r=strlen(arg);
   while (r>=0)
      {
        if((arg[r]==92)||(arg[r]==58))return(&arg[r+1]);
        r--;
      }
   return(arg);
   }
/*---------------------------------------------------------------------------*/
/*  Extraction du nom de fichier seul sans le chemin sous Dos                */
/*---------------------------------------------------------------------------*/

void filtre_filename( byte *cible,byte *source )
   {
   int r;
   byte *ptr = source ;

   while( *ptr )  /* Passe Unix en DOS ... */
   {
       if( *ptr == '/')
         *ptr = 92  ;
       ptr++ ;
   }
   r=strlen(source);
   while (r>=0)
      {
      if((source[r]==92)||(source[r]==58))
         {
           strcpy(cible,&source[r+1]);
           strlwr(cible);
           return;
         }
      r--;
      }
   strcpy(cible,source);
   strlwr(cible);
   }

/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*  Verification si il y a de la place sur le disque download                */
/*---------------------------------------------------------------------------*/
/*
       Retourne 0 si tout va bien, ou 1 s'il n'y a pas assez de place
       sur le disque indiqu dans la config.
       En fait,il faudrait calculer au niveau Cluster pour que ce soit
       exact mais bon...
*/
int NotPlace(long taille)
   {
   byte unite=0;                    /* disque courant par defaut */
   long reste;

   if( Config.DownDir[1]==58 && Config.DownDir[0] > 64) /*sinon,A=1,B=2,etc..*/
      unite=Config.DownDir[0]-64;

   reste=DiskSpace(unite);

   if(reste<taille)return(1);
   return(0);
   }
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*  Calcul et affichage de la vitesse de transfert                           */
/*---------------------------------------------------------------------------*/
/*
     Dans send et receive, la vitesse est calculee d'aprs la taille
     reelle decodee de ce que l'on a recu.
*/
int TraSpeed(long Time1,long Time2,long taille)
{
   long diff,speed;
   byte buff[10];


   if(taille==0L)return(0);
   diff=Time2-Time1;
   if(diff==0L)return(0);

   speed=(int)(taille/diff);

   itoa((int)speed,buff,10);
   mwrite(30,15,"    ",Blanc_vert); /* efface */
   mwrite(30,15,buff,Blanc_vert);
   return((int)speed);
 }
/*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/*     Mesure et affichage du temps de transfert approximatif restant       */
/*--------------------------------------------------------------------------*/
/*
     Si la variable mode est nulle, le temps restant est calcule a partir
     de la taille restante.
     Si mode est non nulle, le temps restant est calcule a partir de la
     taille precedente moins la valeur de mode.
     Ruse ruse quand tu nous tiens !
*/

void TraTime(int speed,long TailleReste,int Calibre)
{
  long temps;
  static long Reste;
  int Minutes,Secondes;
  byte buff[30];

  if(!speed)return;                  /* sinon divide error,pas joli ca...*/
  if(Calibre > 0) Reste-=(long)Calibre;
     else Reste=TailleReste;
       if(Reste < 0L) return; /* Pas afficher de negatif...*/
     ltoa(Reste,buff,10);               /* affiche ce qui reste d'octets */
     mwrite(30,14,"      ",Blanc_vert);
     mwrite(30,14,buff,Blanc_vert);

        temps=Reste/speed;
        Minutes=(int)(temps/60);
        Secondes=(int)  ( temps-(Minutes * 60) );

    itoa(Minutes,&buff[0],10);           /* Affiche le temps restant estim*/
    strcat(buff," mn ");
    itoa(Secondes,buff+strlen(buff),10);
    strcat(buff," sec.  ");
    mwrite(30,16,(byte *)buff,Blanc_vert);
}
/*--------------------------------------------------------------------------*/

#ifdef BBTH
/*--------------------------------------------------------------------------*/
/* Previent le monde que ce n'est plus du vrai domaine PUBLIC BBT 2 !       */
/*--------------------------------------------------------------------------*/
CopyRight(int version)
{
 byte X,Y;

if(MaxY > 30 )
  {
    X = MaxX -33 ;
    Y = MaxY -10  ;
  }
  else
  {
    X = 1 ;
    Y = 1 ;
  }

  box(X,Y,X+33,Y+8,Jaune_rouge);
  if( version == 2)
   mwrite(X +3,Y+1," Protocole Bbt V II Dtect "   ,Inverse    );
  if( version == 3)
   mwrite(X +3,Y+1," Protocole Bbt V III Dtect "   ,Inverse    );
  mwrite(X +2,Y+3,"Attention:"                     ,Jaune_rouge);
  mwrite(X +2,Y+4,"Toute utilisation  Commerciale" ,Blanc_rouge);
  mwrite(X +2,Y+5,"de ce protocole doit faire  l'" ,Blanc_rouge);
  mwrite(X +2,Y+6,"objet d'une autorisation de l'" ,Blanc_rouge);
  mwrite(X +2,Y+7,"auteur: J.C. Michot."           ,Blanc_rouge);
}
/*--------------------------------------------------------------------------*/
#endif
