
/*
  ͻ
                                                                         
             DOMAINE     IBM-PC   MS-DOS(3.x+)       
                            PUBLIC                                 
                 Ren   Le protocole de Transfert BBT  
                          Cougnenc est de Jean-Claude Michot.     
                1989   La librairie de Comm.est de    
                                          Jean-Pierre Parisy & R.Gillmann
  Ķ
                                                                          
                    MODULE: J-MODEM.C                                     
                    -----------------                                     
                                                                          
     Protocole de transfert J-Modem, d'aprs les sources de l'auteur.     
     Une gestion d'erreurs et de time-out bien plus pousse.              
     Tout fichier dj existant sera cras,le systme de renommage du    
     protocole original a t supprim.                                   
                                                                          
   Compilation: modle mmoire LARGE                                      
  Ķ
                                                                          
   Ces sources remanies de l'auteur de Jmodem, ne sont pas dans le       
   domaine public malgr tout.                                            
                                                                          
   Voir ce qui est dit  dans les autres modules  ce propos....           
  ͼ
  Ŀ
   BbtH 1.2 
  
*/
/*--------------------------------------------------------*/
#ifndef __TURBOC__   /* Borland Turbo-c 1.5               */
#ifndef MSDOS        /* Microsoft C                       */
#error Mfiance ! je ne connais pas ce compilateur l...
#endif
#endif
/*--------------------------------------------------------*/

/****************************************************************************/
/*                                                                          */
/*    The JMODEM protocol            MicroSoft (r)  'C' V5.1                */
/*    Created 03-FEB-1990            Richard B. Johnson                     */
/*                                   405 Broughton Drive                    */
/*                                   Beverly, Massachusetts 01915           */
/*                                   BBS (508) 922-3166                     */
/*                                                                          */
/*    An external protocol for high-speed data transmission.                */
/*                                                                          */
/****************************************************************************/
#include <stdlib.h>                     /* Used for _free()                */
#include <stdio.h>                      /* Used for NULL value             */
#include <string.h>                     /* Used for _memcpy()              */
#include <time.h>                       /* Used for absolute time          */
#include <io.h>
#ifdef __TURBOC__
#include <alloc.h>
#include <mem.h>
#else
#include <malloc.h>
#include <memory.h>
#endif
#include "jmodem.h"                     /* JMODEM primatives               */
#include "bbth.h"
#include "couleurs.h"
#include "config.h"



/****************************************************************************/
/*                   Global pointers and allocation                         */
/****************************************************************************/
short  handle;                          /* For file I/O                     */
SYS syst;                               /* Structure for JMODEM status      */
unsigned short user_abort = 0;          /* User abort flag                  */
unsigned short *buf_len;                /* Used to get/set block length     */
JBUF *buff;                             /* A pointer for the JMODEM block   */



/*-------------------------------------------------------------------------*/
/*              Affichage de la fenetre de transfert Jmodem                */
/*-------------------------------------------------------------------------*/
void JmodemBox(byte mode)
{
 static byte NomFichier[20]="";

   box(20,10,45,23,Cyan_vert);
   mwrite(22,12,"Fichier:"             ,Jaune_vert);
   mwrite(22,15,"Vitesse:       Cps"   ,Jaune_vert);
   mwrite(22,16,"Bloc N:"             ,Jaune_vert);
   mwrite(22,17,"Long de:       Octets",Jaune_vert);
   mwrite(22,18,"Compress:"           ,Jaune_vert);

 if(mode==RECEPTION)
  {
   mwrite(23,10," RECEPTION   JMODEM "  ,Inverse);
   mwrite(22,14,"Reu   :       Octets",Jaune_vert);
  }

 if(mode==EMISSION)
  {
   mwrite(23,10," EMISSION    JMODEM " ,Inverse);
   mwrite(22,13,"Taille :       Octets",Jaune_vert);
   mwrite(22,14,"Reste  :       Octets",Jaune_vert);
  }
   mwrite(24,20," Dernier Message: ",Inverse);
  filtre_filename(NomFichier,BbtFile);
 mwrite(30,12,NomFichier,Blanc_vert);

/* Auteur_Jmodem(); */
}
                      /*-----------------------------*/

void JmodemMsg(byte *texte) /* message affich dans la fenetre */
{
  mwrite(22,22,"                      ",Blanc_vert);/* efface ancien message */
  mwrite(22,22,texte,Blanc_vert);
}
/*-------------------------------------------------------------------------*/


/****************************************************************************/
/*                          Receive JMODEM file                             */
/****************************************************************************/

void Jmodem_Receive(int handle)
{

 unsigned short status=0;            /* TX and RX status                 */
 unsigned short tries;               /* Attempts to send a file          */
 unsigned short cmp_size;            /* Size after compression           */
 unsigned short data_written;        /* Data written to the file         */
 unsigned short data_read;           /* Data read from the file          */
 long start;                         /* Start time                       */
 long finish;                        /* End time                         */

 byte in_buffer[DAT_LEN];             /* Pointer to input buffer          */
 byte comp_buffer[DAT_LEN];           /* Pointer to compression buffer    */
 byte file_buffer[DAT_LEN];           /* Pointer to file buffer           */
 byte BufTxt[50];                     /* Pour les sprintf ...             */

    user_abort = 0;                       /* Initialisation !!!!!        */
    buff = (JBUF *) in_buffer;            /* Assign type JBUF   */
    syst.s_len = BLK_SIZ;
    syst.s_byt = 0;
    syst.s_blk = 0;
    syst.s_fil = 0L; /* On se fout de ses messages*/
    syst.s_ope = RECEPTION;

    JmodemBox(RECEPTION);                 /* Affiche fenetre de Transfert*/
    status = rx_sync();                   /* Synchronize        */
    if (!status)
        JmodemMsg("Rception en cours...");
    data_written = 0xFFFF;
    tries = 10;			                      /* Attempts to receive */

    while (    (data_written)             /* Write file okay   */
            && (!user_abort )             /* No break key      */
            && (!status     )             /* Recev block okay  */
            && (tries--)    )             /* 10 retries        */
         {
                    time(&start);                     /* Get starting time */
                    JmodemStatus();
                    status = recv_blk (               /* Receive data-block*/
                             &syst.s_len,             /* Block length      */
                             in_buffer);              /* Input buffer      */
                    if (status)                       /* If bad            */
                        break;                        /* Abort the WHILE   */
                    if( (!(Jm_Crc(GET_CRC,            /* Calculate CRC     */
                          syst.s_len,                 /* Amount to check   */
                          in_buffer) ))               /* Receiver buffer   */
		      && ( buff->blk_num ==           /* Check             */
                         (unsigned char)
                         (syst.s_blk +1)))            /* Block number      */
                    {
                        JmodemMsg("Bloc OK.");
                        tries=10;                     /* Reset count       */
                        syst.s_len -= OVRHD;          /* Subtract overhead */
                        Send(NumPort,ACK);            /* Send the ACK      */

                        /* If data was compressed                          */
			if ( (buff->blk_typ & COMP) == COMP)
                        {
                             mwrite(32,18,"OUI",Blanc_vert);
                             syst.s_len = J_decode (    /* Decode the data   */
                                      syst.s_len,     /* Data-block length */
				     &buff->blk_dat,  /* Where to start    */
                                     file_buffer);    /* Where to put data */
                        }
                        else
                        /* Data was normal (not compressed, just copy )    */
                        {
                            mwrite(32,18,"Non",Blanc_vert);
                            memcpy (file_buffer,&buff->blk_dat,syst.s_len);
                        }
                        /* Write to the file                                */

                        data_written = write(handle,     /* Function        */
                                         &file_buffer ,  /* Where data is   */
                                         syst.s_len   ); /* Amount to write */
                        if(data_written != syst.s_len)  /* Disque plein ???*/
                          {
                           JmodemMsg(" Erreur d'criture.");
                           beep(3);
                           status = 1;
                           continue;  /* sortira illico...*/
                          }
                        syst.s_byt += data_written;      /* Total bytes     */
                        syst.s_blk++;                    /* Block number    */
                        time(&finish);                   /* Get end time    */
                        if (finish - start)              /* Check div/0     */
                            syst.s_cps = (short)         /* Calc Block CPS  */
                            (data_written / (finish - start) );

                            /* Check for end-of-file                        */
                        if ( (buff->blk_typ & EOF_) == EOF_)
                        {                       /* This was the end of file */
                            close(handle);               /* Function        */
                            Send(NumPort,ACK);           /* Send the ACK    */
                            status = JM_NRM;             /* Set status      */
                            JmodemMsg(" Transfert Russi !");
                            return;                     /* Fin du truc      */
                        }
                    }
                    else
                    {
                        sprintf(BufTxt,"Mauvais CRC,Retry N%d",10-tries);
                        JmodemMsg(BufTxt);
                        Send(NumPort,NAK);              /* Send the NAK     */
                     }
                }
                close(handle);
                unlink(BbtFile); /* Dtruit le fichier incomplet */
                status = JM_ABT;
      JmodemMsg("Rat! Fichier dtruit.");
}
/*-------------------------FIN DE JMODEM_RECEIVE----------------------------*/


/****************************************************************************/
/*                          Send JMODEM file                                */
/****************************************************************************/
void Jmodem_Send(int handle)
{

 unsigned short status=0;            /* TX and RX status                 */
 unsigned short tries;               /* Attempts to send a file          */
 unsigned short cmp_size;            /* Size after compression           */
 unsigned short data_written;        /* Data written to the file         */
 unsigned short data_read;           /* Data read from the file          */
 long start;                         /* Start time                       */
 long finish;                        /* End time                         */
 byte out_buffer[DAT_LEN];           /* Pointer to output buffer         */
 byte comp_buffer[DAT_LEN];          /* Pointer to compression buffer    */
 byte file_buffer[DAT_LEN];          /* Pointer to file buffer           */
 byte BufTxt[20];


 user_abort = 0;                       /* Initialisation !!!!!        */
 buff = (JBUF *)out_buffer;            /* Assign type JBUF   */
 syst.s_len = BLK_SIZ;
 syst.s_byt = 0;
 syst.s_blk = 0;
 syst.s_fil = 0L;
 syst.s_ope = EMISSION;
 buf_len=(unsigned short *)out_buffer; /* A WORD pointer     */
 data_read  = 0xFFFF;                   /* Initialize         */
 syst.s_fil = filelength(handle);
 JmodemBox(EMISSION);
 sprintf(BufTxt,"%ld",syst.s_fil);     /* Affiche la taille */
 mwrite(30,13,BufTxt,Blanc_vert);
 status = tx_sync();                   /* Synchronize        */
 if (!status)
     JmodemMsg(" Envoi en cours...");
    while  (  (!user_abort)               /* Ctrl - X           */
             && (!status) )               /* sent okay          */
                {
                    time(&start);                     /* Get starting time  */
                    data_read = read(handle,          /* Read a record      */
                                       &file_buffer , /* Where to put       */
                                      syst.s_len  );  /* Amount to read     */
                    if (!data_read)                   /* Past end of file   */
                        break;
                    syst.s_byt += (long) data_read;   /* Running count      */
                    JmodemStatus();                   /* Show status block  */
                    buff->blk_num = (unsigned char)
                                     ++syst.s_blk;    /* Block number       */

                    if (data_read != syst.s_len)      /* Byte request       */
                        buff->blk_typ = EOF_;         /* Into control-byte  */
                    else
                        buff->blk_typ = NULL;         /* Normal block       */

                    cmp_size = J_encode (data_read,     /* Encode size        */
                                      file_buffer,    /* Source             */
                                      comp_buffer);   /* Destination        */
                    if ( cmp_size  < data_read  )     /* If compressed      */
                    {
                        mwrite(32,18,"OUI",Blanc_vert);
			*buf_len = (cmp_size+OVRHD);  /* Length of block    */
                        buff->blk_typ |= COMP;        /* Show compressed    */
                        memcpy (&buff->blk_dat,       /* Start of data      */
                                   comp_buffer,       /* From here          */
                                   cmp_size);         /* This much          */

                        Jm_Crc(SET_CRC,               /* Calculate CRC      */
                                cmp_size + OVRHD,     /* Length of block    */
                                out_buffer);          /* Where data is      */
                        status = send_blk(            /* Send block         */
                                (cmp_size + OVRHD),   /* Block length       */
				 &syst,               /* Read block ptr.    */
                                 out_buffer);         /* Buffer pointer     */
                    }
                    else                              /* Not compressed     */
                    {
                        mwrite(32,18,"NON",Blanc_vert);
			*buf_len = (data_read+OVRHD); /* Length of block    */
                        buff->blk_typ |= NORM;        /* Show normal data   */
                        memcpy (&buff->blk_dat,       /* Copy to            */
                                   file_buffer,       /* Copy from          */
                                   data_read);        /* This amount        */
                        Jm_Crc(SET_CRC,               /* Calculate CRC      */
                                (data_read + OVRHD),  /* Block length       */
                                 out_buffer);         /* Buffer pointer     */
                        status = send_blk(            /* Send the block     */
                                 (data_read + OVRHD), /* Size of block      */
                                 &syst,               /* Read size ptr      */
                                 out_buffer);         /* Ptr to buffer      */
                    }
                    time(&finish);                    /* Get end time       */
                    if (finish - start)               /* Guard div/zero     */
                        syst.s_cps = (short)          /* Calc Block CPS     */
                        (data_read / (finish - start) );
                    if ( buff->blk_typ == EOF_)       /* Last record        */
                        break;
                }
                if (status)
                    {
                      if(! user_abort)               /* Sinon message dja.*/
                      JmodemMsg("Transfert Loup!");
                    }
                else
                    JmodemMsg("Transfert Russi !");
                JmodemStatus();
                close(handle);                        /* Close the file     */
                if( !user_abort)beep(3);            /* dej beep sinon.    */

}
/*----------------------------FIN DE JMODEM_SEND----------------------------*/





/****************************************************************************/
/*                          Send the JMODEM block                           */
/****************************************************************************/
unsigned short send_blk (blk_len, sys_ptr, buffer)
unsigned short blk_len;
SYS *sys_ptr;
unsigned char *buffer;
{
    unsigned char ack_buf;                  /* Buffer for ACK/NAK         */
    unsigned short tries = 10;              /* Attempts to send the block */
    byte BufTxt[50];

    while ((tries--) && (!user_abort))
    {
        write_chan(blk_len,buffer);          /* Send the JMODEM block      */
        RFlush(NumPort);                     /* Clear back channel noise   */
        do
        {
            ack_buf = NULL;                  /* Clear the return buffer    */
            read_chan(1,&ack_buf);           /* Receive a response         */
        } while ( (ack_buf != ACK)           /* Stay in loop until we      */
               && (ack_buf != CAN)           /*  ... get something useful  */
               && (ack_buf != NAK)           /* This helps re-sync in noise*/
               && (ack_buf !=NULL)
               && (!user_abort) );

        if (ack_buf == CAN)                  /* Check for an abort         */
            break;                           /* User aborted               */
        if (ack_buf == ACK)                  /* If good block              */
        {
            if (tries == 9)                  /* If no retries              */
            {
		sys_ptr->s_len += 512;        /* Increase block-size       */
		if (sys_ptr->s_len > DAT_MAX) /* If too large              */
		    sys_ptr->s_len = DAT_MAX;
            }
            else
            {
	    sys_ptr->s_len = sys_ptr->s_len >> 1; /* Div by two             */
	    if (sys_ptr->s_len  < 0x40)       /* If less than minimum       */
		sys_ptr->s_len = 0x40;        /* Set to minimum             */
            }
        JmodemMsg(" Bloc OK.");
        return JM_NRM;                        /* Show good                  */
        }
    sprintf(BufTxt,"    Retry N%d",10-tries);
    JmodemMsg(BufTxt);                       /* Show pas good du tout...   */
   }
        for (tries = 0; tries <6; tries++)    /* Six CNTRL-X pour aborter   */
            Send(NumPort,CAN);
   return JM_ABT;                             /* Abort local program        */
}



/****************************************************************************/
/*                        Receive the JMODEM block                          */
/****************************************************************************/
unsigned short recv_blk (blk_len, buffer)
unsigned short *blk_len;                  /* Pointer to the block-length   */
unsigned char *buffer;                    /* Pointer to the buffer         */
{
    BLK *buff;                            /* Pointer type BLK              */
    unsigned char nak_buf;                /* Buffer for ACK/NAK            */
    unsigned short tries = 10;            /* Attempts to receive the block */
    unsigned short ret_val;               /* Block length returned         */
    byte BufTxt[50];
    buff = (BLK * )buffer;                /* Need pointer to 3rd BYTE      */
    buf_len = (unsigned short * )buffer;  /* Need pointer to first WORD    */

    while ((tries--) && (!user_abort))
    {
        ret_val = read_chan(2,buffer);    /* Receive the block size        */
        if (ret_val == 2)                 /* If we received the length     */
        {
            *blk_len = *buf_len;          /* So caller knows size          */
            ret_val = read_chan(          /* Get more data                 */
                      (*blk_len)-2,       /* Size to read                  */
                      &buff->blok_dat);   /* Where to put it               */
	    if (ret_val == (*blk_len)-2)  /* If we got what we requested */
		return JM_NRM;
        }

                       /*----- Ici le bloc n'est pas ce qu'on voulait------*/
    Send(NumPort,NAK);                      /* Envoie un NAK               */
    RFlush(NumPort);                       /* Flush the buffer            */
    sprintf(BufTxt,"    Retry N%d",10-tries);
    JmodemMsg(BufTxt);                       /* Affiche ce qui va pas...    */
    }

                       /*----- Ici l'utilisateur a abandonne (user_abort) -*/
                       /*      Ou le nombre d'essais est suprieur  10    */

    for (tries = 0; tries <6; tries++)      /* Envoie 6 CAN pour aborter   */
        Send(NumPort,CAN);
    return JM_ABT;                          /* Abort local program        */
}

/****************************************************************************/
/*                         Synchronize during receive                       */
/****************************************************************************/
unsigned short rx_sync()
{
    short i;
    unsigned char ack_nak;              /* Single byte buffer for ACK/NAK  */
    int essais = 10;                    /* Une Minute de Time-Out          */

    RFlush(NumPort);                    /* Clear the interrupt buffer      */
    JmodemMsg(" Synchro Tx/Rx...");
    while (!user_abort && essais--)
    {
        ack_nak = NULL;                 /* Clear the buffer                */
        read_chan(1,&ack_nak);          /* Receive ACK, NAK, or SYN        */
        if (ack_nak == CAN)             /* If a ^X                         */
           {
            JmodemMsg("Annul par l'autre.");
            break;
           }
        if ( ack_nak == ACK )           /* If a good response              */
            return JM_NRM;              /* Show handshake                  */
        if ( ack_nak == NAK )           /* If a good response              */
        {
            Send(NumPort,ACK);          /* Send a ACK response             */
	    return JM_NRM;
         }
         Send(NumPort,NAK);             /* Keep sending NAKs               */
    }
    if(user_abort) JmodemMsg("Abandon Utilisateur");
    if(!essais)    JmodemMsg("Time-Out!!!! STOP. ");
    beep(2);
    for (i=0; i<8; i++)
        Send(NumPort,CAN);              /* Aborte Transfert avec 8 Cntrl-X */
    return JM_ABT;
}


/****************************************************************************/
/*                         Synchronize during transmit                      */
/****************************************************************************/
unsigned short tx_sync()
{
    unsigned short ret_val;
    ret_val = rx_sync();                /* Call same routine for receive    */
    if (ret_val)                        /* If no success                    */
        return ret_val;                 /* Abort routines                   */
    RFlush(NumPort);                    /* Else flush the input buffer      */
    delay(1000);                        /* 5 timer-ticks to wait            */
    return JM_NRM;                      /* Normal return                    */
}
/****************************************************************************/


/****************************************************************************/
/*                   Encode (compress) the input string.                    */
/*   The routine looks for groups of identical characters and replaces them */
/*   with the character  0xBB, a word denoting the number of characters to  */
/*   duplicate, followed by the character to duplicate.                     */
/*                                                                          */
/****************************************************************************/

unsigned short J_encode(len, in_buffer, out_buffer)
unsigned short len;                     /* Length of input string           */
unsigned char *in_buffer;               /* Pointer to input buffer          */
unsigned char *out_buffer;              /* Pointer to outpup buffer         */
{
    register unsigned short i=0;
    register unsigned short j=0;
    unsigned char c;                    /* Character to replace             */
    unsigned char *in_limit;            /* End of the input string          */
    unsigned char *out_limit;           /* End of the output buffer         */

    in_limit = in_buffer + len;         /* Calc buffer end only once        */
    out_limit = out_buffer + DAT_LEN;   /* Calculate output buffer once     */
    while (in_buffer < in_limit)        /* While more bytes in the buffer   */
    {
        if (out_buffer > out_limit)     /* If we exceeded the buffer size   */
            return JM_MAX;              /* Show no compression possible     */
        if (*in_buffer == 0xBB || *in_buffer == *(in_buffer+1) )
        {
            *out_buffer++ = 0xBB;       /* Insert token, bump pointer       */
            c = *in_buffer;             /* Save duplicate character         */
            i = 0;                      /* Start duplicate char count       */
            while (*in_buffer++ == c)   /* Count occurances of duplicates   */
                i++;                    /* Count identical characters       */
            in_buffer--;                /* Backup to dissimilar character   */
            *out_buffer++ =
               (unsigned char) i;       /* Character count, low byte        */
            *out_buffer++ =
              (unsigned char) (i >> 8); /* Character count, high byte       */
            *out_buffer++ = c;          /* The duplicate character          */
            j += 4;                     /* Adjust char count                */
        }
        else                            /* Else, just copy                  */
        {
            *out_buffer++ = *in_buffer++;
            j++;                        /* Character count                  */
        }
    }
    return j;                           /* New length                       */
}


/****************************************************************************/
/*                     Decode (expand) the encoded string.                  */
/*    Routine checks for a sentinel byte, 0xBB, and if found, takes the     */
/*    following word as the number of identical bytes to add. The actual    */
/*    byte to add is located following the length-word.                     */
/*                                                                          */
/****************************************************************************/
unsigned short J_decode(len, in_buffer, out_buffer)
unsigned short len;                             /* Length to input string   */
unsigned char *in_buffer;                       /* Pointer to input buffer  */
unsigned char *out_buffer;                      /* Pointer to output buffer */
{
    register unsigned short i=0;
    register unsigned short j=0;
    unsigned char c;
    unsigned char *limit;                       /* Length of input buffer   */

    limit = in_buffer + len;                    /* Set end pointer once     */
        while (in_buffer < limit)
    {
        if (*in_buffer == 0xBB )                /* If the sentinel byte     */
        {
             in_buffer ++;                      /* Next character           */
             i = (unsigned short) *in_buffer++; /* Get low byte, incr       */
             i = i | (unsigned short)
                 (*in_buffer++) << 8;           /* Get high byte, incr      */
             c = *in_buffer++;                  /* Get byte, incr           */
             for ( ; i >0; i--)                 /* Don't alter i at start   */
             {
                 *out_buffer++ = c;             /* Expand byte              */
                 j++;                           /* Character count          */
             }
        }
        else                                    /* Else, just copy          */
        {
            *out_buffer++ = *in_buffer++;
            j++;                                /* Character count          */
        }
    }
    return j;                                   /* New string length        */
}
/*--------------------------------------------------------------------------*/

/****************************************************************************/
/*                  Calculate the simple JMODEM CRC                         */
/*    Routine obtains a pointer to the buffer of characters to be checked.  */
/*    The first passed parameter is the length of the buffer. The CRC is    */
/*    returned.                                                             */
/*                                                                          */
/****************************************************************************/
unsigned short Jm_Crc(command, length, buffer)
unsigned short command;                     /* Set or Check CRC             */
unsigned short length;                      /* Buffer length                */
unsigned char *buffer;                      /* Pointer to the buffer        */
{
    register unsigned short crc=0;          /* Start at zero                */
    register unsigned short i;              /* Byte count                   */

    length -=2;                             /* Don't CRC the CRC            */
    do
    {
    crc += (unsigned short) *buffer++;      /* Sum first                    */
    i = length & 0x07;                      /* 7 bits max to rotate         */
    crc  = _rotl(crc,i);                    /* Rotate i bits left           */
    } while (--length);

    switch (command)
    {
        case GET_CRC:
        {
            i = (unsigned short) *buffer++;
            i = i |  (unsigned short) (*buffer << 8 );
            return (crc - i);               /* Return AX = 0 if CRC okay    */
        }
        case SET_CRC:
        {
            *buffer++ = (unsigned char) crc;
            *buffer   = (unsigned char) (crc >> 8);
            return crc;                     /* Return CRC though ignored    */
        }
        default:
            return JM_MAX;                  /* Bad data, buffer overflow    */
    }
}
/****************************************************************************/




/*-------------------------------------------------------------------------*/
/*                     Lecture Jmodem du port serie.                       */
/*-------------------------------------------------------------------------*/
/*
           Utilise la routine RecupChar de Xmodem pour simplifier.

           Tente de lire 'nombre' caracteres et de les placer dans le
           buffer 'Pointeur'.

           Si un time-out d'une seconde arrive, retourne le nombre de
           caractres reus rellement.

           Si L'utilisateur a frapp Cntrl-X, place le flag user_abort,
           et retourne le nombre de caractres recus avant.
*/

unsigned short
read_chan(unsigned nombre,byte *Pointeur)
{
int ch;
register unsigned int comptage;
comptage = 0;
 while(1)
      {
        *Pointeur = 0;
        ch = RecupChar(1,1);
           if( ch == -2) user_abort=0xFFFF;     /* un ^X a t frapp...  */
           if( ch < 0  ) return(comptage);      /* Time out               */
       *Pointeur =(byte) ch;
       comptage++;
       Pointeur++;
       if ( comptage >= nombre) return(nombre);
      }
}
/*-------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------*/
/*                    Ecriture Jmodem du port serie.                       */
/*-------------------------------------------------------------------------*/
/*

           Si L'utilisateur a frapp Cntrl-X, place le flag user_abort,
           et retourne la valeur JM_ABT.
           Retourne  JM_NRM si tout a pu etre envoy.
*/

unsigned short
write_chan(unsigned nombre,byte *Pointeur)
{
register unsigned int comptage;
int ch;

comptage = 1;
 while(1)
      {
        while(XFree(NumPort) < 2)
             {
              mwrite(1,1," Port Plein ",Inverse);
             }
        mwrite(1,1,"            ",Inverse);
        Send(NumPort,(byte) *Pointeur);
        comptage++;
        if( comptage > nombre) return(JM_NRM);
        Pointeur++;
        if(kbhit())
          {
           ch = getch();
           if( ch == 24)              /* CNTRL-X frapp */
             {
              user_abort = 0xFFFF;
              return (JM_ABT);
             }
          }
      }
}
/*-------------------------------------------------------------------------*/

/*-------------------------------------------------------------------------*/
/*           Affichage des valeurs dans la fenetre Jmodem                  */
/*-------------------------------------------------------------------------*/
 void JmodemStatus(void)
 {
 char BufTxt[20];

  if(syst.s_ope == RECEPTION)
    sprintf(BufTxt,"%ld ",syst.s_byt);          /* Octets recus,    */
  else
    sprintf(BufTxt,"%ld ",syst.s_fil - syst.s_byt);

  mwrite(30,14,BufTxt,Blanc_vert);              /* ou Restants.     */

  sprintf(BufTxt,"%d ",syst.s_cps);
  mwrite(30,15,BufTxt,Blanc_vert);              /* Vitesse actuelle  */

  sprintf(BufTxt,"%d ",syst.s_blk);
  mwrite(30,16,BufTxt,Blanc_vert);              /* Numero du bloc    */

  sprintf(BufTxt,"%d ",syst.s_len);
  mwrite(30,17,BufTxt,Blanc_vert);              /* Taille de ce bloc */

 }
/*-------------------------------------------------------------------------*/

#ifdef CACACA
/*-------------------------------------------------------------------------*/
   void Auteur_Jmodem(void)
   {
     mwrite(MaxX-24,"A propos",cyan_bleu);
     mwrite(MaxX-26 ,  MinY  ,"          Ŀ",blanc_bleu);
     mwrite(MaxX-26 ,  MinY+1," Le  protocole  J-MODEM ",blanc_bleu);
     mwrite(MaxX-26 ,  MinY+2," a t cr en 1988 par ",blanc_bleu);
     mwrite(MaxX-26 ,  MinY+3,"   Richard B. Johnson.  ",blanc_bleu);
     mwrite(MaxX-26 ,  MinY+4,"",blanc_bleu);
   }
/*-------------------------------------------------------------------------*/
#endif
