
/*
  ͻ
                                                                         
             DOMAINE     IBM-PC   MS-DOS(3.x+)       
                            PUBLIC                                 
                 Ren   Le protocole de Transfert BBT  
                          Cougnenc est de Jean-Claude Michot.     
                1989   La librairie de Comm.est de    
                                          Jean-Pierre Parisy & R.Gillmann
  Ķ
                                                                          
                    MODULE:  QNXTERM.C                                    
                    -------------------                                   
                                                                          
   Emulation de terminal Qnx Couleurs et fonctions associes.             
   Peut gerer jusqu' 196 colonnes et 255 lignes.                         
                                                                          
   Compilation: modle mmoire LARGE                                      
  Ķ
   Ce module n'est pas freeware,vous n'avez pas le droit de le diffuser   
   a quiconque ni mme de l'utiliser.                                     
                                                                          
   D'ailleurs, vous ne pouvez mme pas le lire puisque vous ne le posse-  
   dez pas... !                                                           
                                                                          
   Y'en a marre de bosser pour que les autres pompent btement sans faire 
   d'effort et s'approprient le boulot a leur nom.                        
                                                                          
  ͼ
  Ŀ
   BbtH 1.2 
  
*/

/*--------------------------------------------------------*/
#ifndef __TURBOC__   /* Borland Turbo-c 1.5               */
#ifndef MSDOS        /* Microsoft C                       */
#error Mfiance ! je ne connais pas ce compilateur l...
#endif
#endif
/*--------------------------------------------------------*/



#include<ctype.h>
#include<stdlib.h>
#include "bbth.h"
#include "config.h"
#include "touches.h"
#include "couleurs.h"
#include "clavecra.h"
#include "fonction.h"
#include "qnxterm.h"

byte qnxseq[50];                       /* Stockage sequence qnx    */
byte qnxcount     = 0,                 /* index pour ci-dessus     */
     Qinversion   = 0,                 /* Flag d'inversion video   */
     QnxScrollAttr= 7,                 /* attribut de scrolling    */
     QnxSaveAttr  = 7;                 /* sauvegarde curseurs ansi */


/*-- Attributs couleur du caractere en fonction de la valeur qnx: --*/

byte qnx_color[]={
                    /*---- couleurs de FORME:    */
    0x00,           /* Noir    0                 */
    0x01,           /* Bleu    1                 */
    0x02,           /* Vert    2                 */
    0x03,           /* Cyan    3                 */
    0x04,           /* Rouge   4                 */
    0x05,           /* Magenta 5                 */
    0x06,           /* Brun    6                 */
    0x07,           /* Blanc   7                 */
                    /*---- couleurs de FOND:     */
    0x00,           /* Noir    0                 */
    0x10,           /* Bleu    1                 */
    0x20,           /* Vert    2                 */
    0x30,           /* Cyan    3                 */
    0x40,           /* Rouge   4                 */
    0x50,           /* Magenta 5                 */
    0x60,           /* Brun    6                 */
    0x70 };         /* Blanc   7                 */




/*--------------------------------------------------------------------------*/
/*          Simulation terminal QNX Couleurs                                */
/*--------------------------------------------------------------------------*/

void Terminal_QNX(void)
   {
   if (kbhit ())
      {
      outchar = touche();
      if (QnxFct(outchar))
         return;
      if (outchar >0xFF)
         {
           Fonctions(outchar); /* touche de fonction */
           return;
         }
      else
         {
           if (Data<8)  NoAccent((byte *)&outchar);
             Send (NumPort,(byte) outchar);
           if (echo) tty(outchar); /* half duplex */
         }
      }
   if (PortReady (NumPort))
      {
       ch=(Receive (NumPort));
       if(logtrace== 1) LogPutc(ch); /* fichier Log Actif         */
       BbtScan(ch);                  /* Recherche depart transfert BBT */
       QbbsScan(ch);                 /* Recherche identification QBBS  */
       ZmodemScan(ch);               /* Recherche depart Zmodem        */


      switch(ch)      /* traitement normal */
         {

          case 12:    /* FormFeed efface l'ecran */
              cls_win(QnxScrollAttr);
              locate(MinX,MinY);
          return;

          case 0x1E:     /* Le nouvelle ligne sous QNX et oui.... */
              tty(13);
              tty(10);
          return;

          case 127: /* DELETE->BACK */
            tty(8);
          return;


          case 27: /* Escape,sequence  possible */
              *qnxseq=27;
               qnxcount=1;
          return;

          case 40: /* '(' Inversion video */
           if(qnxcount==1)
             {
               if(!Qinversion)
                 {
                   InverseColor(&CurAttr);
                   Qinversion=1;
                 }
               qnxcount=0;
               return;
             }
          break;

          case 41: /* ')' Fin d'inversion video */
           if(qnxcount==1)
             {
              if(Qinversion)
                {
                  InverseColor(&CurAttr);
                  Qinversion=0;
                }
               qnxcount=0;
               return;
             }
          break;


          case 49:  /* 1  8, changement de console.    */
          case 50:  /* Je ne peux bien sur pas traiter  */
          case 51:  /* ce cas moi,ca serait trop galere */
          case 52:
          case 53:
          case 54:
          case 55:
          case 56:
            if(qnxcount==1)
              {
                qnxcount=0;
                return;
              }
          break;




          case 57:   /* '9': tiens, du minitel!!!  */
            if (qnxcount == 1)
            {
              delay (180);
              ch = Receive (NumPort);
              if(logtrace== 1) LogPutc(ch); /* fichier Log Actif         */
              QbbsScan(ch);                 /* Recherche identification QBBS  */
               if (ch == 'l')
                   Set_1200_75 ();  /* on retourne le modem  */
               qnxcount = 0;
             return;
            }
          break;


          case 60: /* '<' haute intensite en route */
          if(qnxcount==1)
            {
              CurAttr |= 8;
              qnxcount=0;
              return;
            }
          break;

          case 62: /* '>' haute intensite vire */
          if(qnxcount==1)
            {
               CurAttr &= ~8;
               qnxcount=0;
               return;
            }
          break;


          case 61: /* '=',debut de sequence positionnement */
          case 89: /* 'Y', meme chose.                     */
          if(qnxcount==1)
            {
              *(qnxseq+qnxcount)=ch;
              qnxcount++;
              return;
            }
          break;


          case 64: /* '@',debut de sequence couleur */
          case 33: /* '!',pour l'attr. de scroll    */
          if(qnxcount==1)
            {
              *(qnxseq+qnxcount)=ch;
              qnxcount++;
              return;
            }
          break;



          case 65:           /* 'A', en haut sous qnx */
           if(qnxcount==1)
             {
               if(CurY >MinY) cur_up();
               qnxcount=0;
               return;
             }
          break;


          case 66:           /* 'B', en haut bas sous qnx */
           if(qnxcount==1)
             {
               if(CurY<MaxY-1) cur_dn();
               qnxcount=0;
               return;
             }
          break;


          case 67:           /* 'C', a droite  sous qnx */
           if(qnxcount==1)
             {
               if(CurX < MaxX) cur_right();
               qnxcount=0;
               return;
             }
          break;


          case 68:           /* 'D', a gauche  sous qnx */
           if(qnxcount==1)
             {
               if(CurX > MinX) cur_left();
               qnxcount=0;
               return;
             }
          break;



          case 69:           /* 'E', Insertion de ligne */
           if(qnxcount==1)
             {
               if(QnxScrollAttr !=0)
                  InsertLine(1,QnxScrollAttr);
                else
                  InsertLine(1,Normal);
               qnxcount=0;
               curseur(1);
               return;
             }
          break;

          case 70:           /* 'F', Suppression de ligne */
           if(qnxcount==1)
             {
                if(QnxScrollAttr !=0)
                  DeleteLine(1,QnxScrollAttr);
                else
                  DeleteLine(1,Normal);
               qnxcount=0;
               curseur(1);
               return;
             }
          break;


          case 72:           /* 'H', home  sous qnx */
           if(qnxcount==1)
             {
               locate(MinX,MinY);
               qnxcount=0;
               return;
             }
          break;


          case 73:          /* 'I', reverse line feed */
           if(qnxcount==1)
             {
               cur_up();
               qnxcount=0;
               return;
             }
          break;


          case 74:          /* 'J', Clear to end of screen */
           if(qnxcount==1)
             {
               DelEos(QnxScrollAttr);
               qnxcount=0;
               return;
             }
          break;

          case 75:          /* 'K', Clear to end of line */
           if(qnxcount==1)
             {
               DelEol(QnxScrollAttr);
               qnxcount=0;
               return;
             }
          break;



          case 83: /* S,  sauve attributs */
          if(qnxcount==1)
             {
                QnxSaveAttr=CurAttr;
                qnxcount=0;
                return;
             }
          break;


          case 82: /* R,  restaure attributs */
          if(qnxcount==1)
             {
                CurAttr=QnxSaveAttr;
                qnxcount=0;
                return;
             }
          break;


          case 91: /* '[' debut soulignement */
           if(qnxcount==1)
             {
               CurAttr |= 1;
               qnxcount=0;
               return;
             }
          break;


          case 93: /* ']' fin soulignement */
           if(qnxcount==1)
             {
                CurAttr &= ~1;
                qnxcount=0;
                return;
             }
          break;


          case 123: /* '{' debut clignotement */
           if(qnxcount==1)
             {
               CurAttr |= 128;
               qnxcount=0;
               return;
             }
          break;


          case 125: /* '}' fin clignotement */
           if(qnxcount==1)
             {
                CurAttr &= ~128;
                qnxcount=0;
                return;
             }
          break;
                             /* A partir d'ici ca ne marche qu'en */
                             /* liaison 8 bits.                   */
          case 160 :
            locate(MinX,MinY);
          return;

          case 161 :
            cur_up();
          return;

          case 164 :
            cur_left();
          return;

          case 166 :
            cur_right();
          return;

          case 169 :
            cur_dn();
          return;
         } /* fin du switch */


      if(qnxcount<2)   /* si on est pas en sequence qnx,on */
         {             /* affiche tel quel,                 */
           tty(ch);
           qnxcount=0;
         }
      else
         {
           *(qnxseq+qnxcount)=ch;  /* sinon on le met a la suite de */
           qnxcount++;             /* la sequence qnx...            */
           if(qnxcount >=4)
             {
               gereqnx();
             }
           return;
         }
      }
   }
/*---------------------------------------------------------------------------*/



/*---------------------------------------------------------------------------*/
/*    Envoi des sequences correspondant aux touches fleches du pave          */
/*---------------------------------------------------------------------------*/
/*
       Certaines touches envoient du 8bits, et ne seront donc operationnelles
       qu'en terminal 8 bits, neanmoins je fais comme Qterm j'envoie tout
       de meme betement, meme en 7 bits.
*/
int   QnxFct(int ch)
{
 if( (ch >= F1 ) && (ch <= F10 ) )
    {
     Send(NumPort,129+(ch - F1) ); /* envoi des touches de fonction */
     return(1);
    }

 if( (ch >= SHIFT_F1 ) && (ch <= SHIFT_F10 ) )
    {
     Send(NumPort,139+(ch - SHIFT_F1) ); /* envoi des touches de fonction */
     return(1);
    }

 if( (ch >= CNTRL_F1 ) && (ch <= CNTRL_F10 ) )
    {
     Send(NumPort,149+(ch - CNTRL_F1) ); /* envoi des touches de fonction */
     return(1);
    }

 if( (ch >= ALT_F1 ) && (ch <= ALT_F10 ) )
    {
     Send(NumPort,209+(ch - ALT_F1) ); /* envoi des touches de fonction */
     return(1);
    }


 switch(ch)
      {
         case HAUT:   /*----------  -----------*/
              Send(NumPort,161);
         return(1);

         case BAS:    /*----------  -----------*/
              Send(NumPort,169);
         return(1);


         case DROITE: /*----------  -----------*/
              Send(NumPort,166);
              FlagDel=0;  /* voir ci-dessous */
         return(1);

         case GAUCHE: /*----------  -----------*/
              Send(NumPort,164);
              FlagDel=0;  /* le back suivant ne doit pas */
         return(1);   /* effacer le caractere        */

         case HOME:  /*----------  -----------*/
              Send(NumPort,160);
         return(1);

         case END:   /*----------  -----------*/
              Send(NumPort,168);
         return(1);


         case CNTRL_PGUP:  /*---remplace PgUp utilise pur upload --*/
              Send(NumPort,162);
         return(1);

         case CNTRL_PGDN:  /*---remplace PgDn utilise pour download----*/
              Send(NumPort,170);
         return(1);

         case DELETE:
              Send(NumPort,172);
         return(1);

         case INSERT:
              Send(NumPort,171);
         return(1);

         case 43 :               /* Gros '+' du pave numrique ? */
           if(__ScanCode__== 78) /* Oui, ->fonction alors.       */
             {
               Send(NumPort,167);
               return(1);
             }
         break;

       case 45 :                 /* Gros '-' du pave numrique ? */
           if(__ScanCode__== 74) /* Oui, ->fonction alors.       */
             {
               Send(NumPort,163);
               return(1);
             }
         break;
      }
 return(0);
}
/*---------------------------------------------------------------------------*/




/*---------------------------------------------------------------------------*/
/*              Tri et xcution des squences qnx  reconnues:               */
/*---------------------------------------------------------------------------*/

void   gereqnx(void)
   {
   byte commande;

   commande=*(qnxseq +1 );
   switch(commande)
      {

       case 61:   /*-------------- '=',positionnement y x      */
       case 89:   /*-------------- 'Y',meme chose...           */

               if(qnxcount !=4)
                  {
                    return; /* pas la bonne seq.   */
                  }

               if((*(qnxseq+2) < 0x20)||(*(qnxseq+3) < 0x20))
                 {
                   qnxcount=0;      /* Coordonnees negatives */
                   return;          /* impossible... erreur..*/
                 }

               locate(*(qnxseq +3)-0x20, *(qnxseq + 2)-0x20);
               qnxcount=0;
       break;


       case 64:  /*-------------- @,couleur des caracteres  */
          SetQnxColor(&CurAttr);
       break;

       case 33:  /*-------------- !,attribut de scrolling   */
          SetQnxColor(&QnxScrollAttr);
          if(QnxScrollAttr == 0 )
             QnxScrollAttr = Normal;  /* non mais alors */
       break;

      }
   qnxcount=0; /* et on repart pour de nouvelles aventures...  */
   }
/*---------------------------------------------------------------------------*/





/*---------------------------------------------------------------------------*/
/*           fonctions video de mouvements curseur                           */
/*---------------------------------------------------------------------------*/
void   cur_up() /* Commande A */
{
   if(CurY>MinY)
     {
       CurY--;
       locate(CurX,CurY);
     }
     else
     {
        Scroll_down(1,MinX,MinY,MaxX,MaxY-1);
        locate(CurX,MinY);
     }
}


void   cur_dn() /* Commande B */
{

   CurY=CurY++;
   if(CurY >MaxY-1)
      {
         CurY=MaxY-1; /*non mais alors ! */
         Scroll_up(1,MinX,MinY,MaxX,MaxY-1);
      }
  locate(CurX,CurY);
 }


void   cur_right() /* Commande C */
{
       CurX++;
       if(CurX >MaxX)
         {
           if(CurY==MaxY-1)
             {
               CurX=MaxX;
             }
           else
             {
              CurX=0;
              CurY++;
             }
         }

  locate(CurX,CurY);
}


void   cur_left() /* Commande D */
{
       if(CurX==0)
         {
           if(CurY==0)return;
           CurY--;
           CurX=MaxX;
         }
         else
           CurX--;

 locate(CurX,CurY);
}
/*---------------------------------------------------------------------------*/





/*---------------------------------------------------------------------------*/
/*  Modif de l'attribut couleur qnx->DOS                                     */
/*---------------------------------------------------------------------------*/
/*
      Attention c'est l'adresse de l'attribut que ca demande,ca prend les
      valeurs dans la chaine qnxseq voila voila.
*/

void   SetQnxColor(byte *Attribut)
{
   byte attrib=*Attribut;
   byte coul;                              /* Couleur de forme,transfo */
                                           /* ascii -> nombre, etc.... */
              coul=*(qnxseq+2)-48 ;
              if( ( coul < 8)&&(coul >=0) )
                {
                   attrib &= 0xF8;
                   attrib |= qnx_color[coul];
                }

              coul=*(qnxseq+3)-48 ;         /* Meme combat pour le fond.*/
              if( ( coul < 8)&&(coul >=0) )
                {
                   attrib &= 0x8F;
                   attrib |= qnx_color[coul+8];
                }
    if((Qinversion)&&(*(qnxseq+1)!=33) )   /* Inversion video ok sauf pour */
      InverseColor(&attrib);               /* Attribut de scroll */
 *Attribut=attrib;
}
/*---------------------------------------------------------------------------*/




/*---------------------------------------------------------------------------*/
/*     Inversion des couleurs d'affichage du pc.                             */
/*---------------------------------------------------------------------------*/
/*
       Inversion des 3 bits de forme et des 3 bits de fond.
       C'est lourd ca, faudra que je fasse des decalages un jour tout
       de meme moi.
*/
void InverseColor(byte *Attribut)
{
byte attrib =*Attribut;
byte temp   =*Attribut;

  if(attrib & 1) attrib |= 16 ; else attrib &= ~16 ;
  if(attrib & 2) attrib |= 32 ; else attrib &= ~32 ;
  if(attrib & 4) attrib |= 64 ; else attrib &= ~64 ;

  if(temp  & 16) attrib |= 1  ; else attrib &= ~1 ;
  if(temp  & 32) attrib |= 2  ; else attrib &= ~2 ;
  if(temp  & 64) attrib |= 4  ; else attrib &= ~4 ;

 *Attribut=attrib;
}
/*---------------------------------------------------------------------------*/

