
/*
  ͻ
                                                                         
             DOMAINE     IBM-PC   MS-DOS(3.x+)       
                            PUBLIC                                 
                 Ren   Le protocole de Transfert BBT  
                          Cougnenc est de Jean-Claude Michot.     
                1989   La librairie de Comm.est de    
                                          Jean-Pierre Parisy & R.Gillmann
  Ķ
                                                                          
                    MODULE: ZMODEM.H                                      
                    ----------------                                      
                                                                          
      Dfinitions pour les modules Zmodem.                                
                                                                          
  Ķ
                                                                          
   Ces sources ne sont plus dans le domaine public,vu le boulot faudrait  
   pas dconner.                                                          
                                                                          
   Ceux qui voudraient un zmodem  eux n'ont qu' aller chercher les      
   sources unix de Forsberg et se taper tout le boulot comme les copains! 
                                                                          
  ͼ
  Ŀ
   BbtH 1.2 
  
*/
/*--------------------------------------------------------*/
#ifndef __TURBOC__   /* Borland Turbo-c 1.5               */
#ifndef MSDOS        /* Microsoft C                       */
#error Mfiance ! je ne connais pas ce compilateur l...
#endif
#endif
/*--------------------------------------------------------*/

/*
 *   Z M O D E M . H     Manifest constants for ZMODEM
 *    application to application file transfer protocol
 *    04-17-89  Chuck Forsberg Omen Technology Inc
 */

#define xsendline(X) sendline(X)
/* #define TXBSIZE  16384  */      /* Doit tre une puissance de 2, */
                                   /* infrieure  MAXINT           */
/* ^^^ Je n'utilise pas, ca fout la merde a cause de mes modifs.. ? */

/*
 * updcrc macro derived from article Copyright (C) 1986 Stephen Satchell.
 *  NOTE: First srgument must be in range 0 to 255.
 *        Second argument is referenced twice.
 *
 * Programmers may incorporate any or all code into their programs,
 * giving proper credit within the source. Publication of the
 * source routines is permitted so long as proper credit is given
 * to Stephen Satchell, Satchell Evaluations and Chuck Forsberg,
 * Omen Technology.
 */

#define updcrc(cp, crc) ( crctab[((crc >> 8) & 255)] ^ (crc << 8) ^ cp)
#define UPDC32(b, c) (cr3tab[((int)c ^ b) & 0xff] ^ ((c >> 8) & 0x00FFFFFF))

extern unsigned short	crctab[256];
extern unsigned long	cr3tab[256];




                 /*-------------------------------------*/
                 /*      Dfinitions pour RZ.C          */
                 /*-------------------------------------*/

#define LOGFILE		"rzlog"
#define OK		0
#define FALSE		0
#define TRUE		1
#define ERROR		(-1)

#define ENQ 005
#define CAN ('X'&037)
#define XOFF ('s'&037)
#define XON ('q'&037)
#define SOH 1
#define STX 2
#define EOT 4
#define ACK 6
#define NAK 025
#define CPMEOF 032
#define WANTCRC 0103		/* send C not NAK to get crc not checksum */
#define WANTG 0107		/* Send G not NAK to get nonstop batch xmsn */
#define TIMEOUT (-2)
#define RCDO (-3)
#define GCOUNT (-4)
#define ERRORMAX 5
#define RETRYMAX 10
#define WCEOT (-10)
#define SECSIZ 128		/* cp/m's Magic Number record size */
#define PATHLEN 257		/* ready for 4.2 bsd ? */
#define KSIZE 1024		/* record size with k option */
#define UNIXFILE 0x8000		/* happens to the the S_IFREG file mask bit for stat */

#define DEFBYTL 2000000000L     /* default rx file size */




                 /*-------------------------------------*/
                 /*       Dfinitions pour Zmodem       */
                 /*-------------------------------------*/


#define ZPAD '*'	/* 052 Padding character begins frames */
#define ZDLE 030	/* Ctrl-X Zmodem escape - `ala BISYNC DLE */
#define ZDLEE (ZDLE^0100)	/* Escaped ZDLE as transmitted */
#define ZBIN 'A'	/* Binary frame indicator (CRC-16) */
#define ZHEX 'B'	/* HEX frame indicator */
#define ZBIN32 'C'	/* Binary frame with 32 bit FCS */
#define ZBINR32 'D'	/* RLE packed Binary frame with 32 bit FCS */
#define ZVBIN 'a'	/* Binary frame indicator (CRC-16) */
#define ZVHEX 'b'	/* HEX frame indicator */
#define ZVBIN32 'c'	/* Binary frame with 32 bit FCS */
#define ZVBINR32 'd'	/* RLE packed Binary frame with 32 bit FCS */
#define ZRESC	0176	/* RLE flag/escape character */
#define ZMAXHLEN 16	/* Max header information length  NEVER CHANGE */
#define ZMAXSPLEN 1024	/* Max subpacket length  NEVER CHANGE */



          /*----------------------------------------------*/
          /* Frame types (see array "frametypes" in zm.c) */
          /*----------------------------------------------*/

#define ZRQINIT	0	/* Request receive init */
#define ZRINIT	1	/* Receive init */
#define ZSINIT 2	/* Send init sequence (optional) */
#define ZACK 3		/* ACK to above */
#define ZFILE 4		/* File name from sender */
#define ZSKIP 5		/* To sender: skip this file */
#define ZNAK 6		/* Last packet was garbled */
#define ZABORT 7	/* Abort batch transfers */
#define ZFIN 8		/* Finish session */
#define ZRPOS 9		/* Resume data trans at this position */
#define ZDATA 10	/* Data packet(s) follow */
#define ZEOF 11		/* End of file */
#define ZFERR 12	/* Fatal Read or Write error Detected */
#define ZCRC 13		/* Request for file CRC and response */
#define ZCHALLENGE 14	/* Receiver's Challenge */
#define ZCOMPL 15	/* Request is complete */
#define ZCAN 16		/* Other end canned session with CAN*5 */
#define ZFREECNT 17	/* Request for free bytes on filesystem */
#define ZCOMMAND 18	/* Command from sending program */
#define ZSTDERR 19	/* Output to standard error, data follows */



                 /*-------------------------------------*/
                 /*           ZDLE sequences            */
                 /*-------------------------------------*/

#define ZCRCE 'h'	/* CRC next, frame ends, header packet follows */
#define ZCRCG 'i'	/* CRC next, frame continues nonstop */
#define ZCRCQ 'j'	/* CRC next, frame continues, ZACK expected */
#define ZCRCW 'k'	/* CRC next, ZACK expected, end of frame */
#define ZRUB0 'l'	/* Translate to rubout 0177 */
#define ZRUB1 'm'	/* Translate to rubout 0377 */

/* zdlread return values (internal) */
/* -1 is general error, -2 is timeout */
#define GOTOR 0400
#define GOTCRCE (ZCRCE|GOTOR)	/* ZDLE-ZCRCE received */
#define GOTCRCG (ZCRCG|GOTOR)	/* ZDLE-ZCRCG received */
#define GOTCRCQ (ZCRCQ|GOTOR)	/* ZDLE-ZCRCQ received */
#define GOTCRCW (ZCRCW|GOTOR)	/* ZDLE-ZCRCW received */
#define GOTCAN	(GOTOR|030)	/* CAN*5 seen */



                 /*-------------------------------------*/
                 /* Byte positions within header array  */
                 /*-------------------------------------*/

#define ZF0	3	/* First flags byte */
#define ZF1	2
#define ZF2	1
#define ZF3	0
#define ZP0	0	/* Low order 8 bits of position */
#define ZP1	1
#define ZP2	2
#define ZP3	3	/* High order 8 bits of file position */



                  /*-------------------------------------*/
                  /* Bit Masks for ZRINIT flags byte ZF0 */
                  /*-------------------------------------*/

#define CANFDX	01	/* Rx can send and receive true FDX */
#define CANOVIO	02	/* Rx can receive data during disk I/O */
#define CANBRK	04	/* Rx can send a break signal */
#define CANRLE	010	/* Receiver can decode RLE */
#define CANLZW	020	/* Receiver can uncompress */
#define CANFC32	040	/* Receiver can use 32 bit Frame Check */
#define ESCCTL 0100	/* Receiver expects ctl chars to be escaped */
#define ESC8   0200	/* Receiver expects 8th bit to be escaped */



                 /*-------------------------------------*/
                 /* Bit Masks for ZRINIT flags byte ZF1 */
                 /*-------------------------------------*/

#define CANVHDR	01	/* Variable headers OK */



                 /*-------------------------------------*/
                 /*      Parameters for ZSINIT frame    */
                 /*-------------------------------------*/

#define ZATTNLEN 32	/* Max length of attention string */
#define ALTCOFF ZF1	/* Offset to alternate canit string, 0 if not used */


                 /*-------------------------------------*/
                 /* Bit Masks for ZSINIT flags byte ZF0 */
                 /*-------------------------------------*/

#define TESCCTL 0100	/* Transmitter expects ctl chars to be escaped */
#define TESC8   0200	/* Transmitter expects 8th bit to be escaped */


                /*----------------------------------------*/
                /*    Parameters for ZFILE frame          */
                /* Conversion options one of these in ZF0 */
                /*----------------------------------------*/

#define ZCBIN	1	/* Binary transfer - inhibit conversion */
#define ZCNL	2	/* Convert NL to local end of line convention */
#define ZCRESUM	3	/* Resume interrupted file transfer */


                /*--------------------------------------*/
                /*       Management include options     */
                /*       one of these ored in ZF1       */
                /*--------------------------------------*/

#define ZMSKNOLOC	0200	/* Skip file if not present at rx */
#define ZMMASK	037	/* Mask for the choices below */
#define ZMNEWL	1	/* Transfer if source newer or longer */
#define ZMCRC	2	/* Transfer if different file CRC or length */
#define ZMAPND	3	/* Append contents to existing file (if any) */
#define ZMCLOB	4	/* Replace existing file */
#define ZMNEW	5	/* Transfer if source newer */
                        /* Number 5 is alive ... */
#define ZMDIFF	6	/* Transfer if dates or lengths different */
#define ZMPROT	7	/* Protect destination file */


                /*--------------------------------------*/
                /*        Transport options             */
                /*       one of these in ZF2            */
                /*--------------------------------------*/

#define ZTLZW	1	/* Lempel-Ziv compression */
#define ZTRLE	3	/* Run Length encoding */

               /* Extended options for ZF3, bit encoded */

#define ZXSPARS	64	/* Encoding for sparse file operations */
#define ZCANVHDR	01	/* Variable headers OK */

              /*    Receiver window size override      */

#define ZRWOVR 4	/* byte position for receive window override/256 */

             /* Parameters for ZCOMMAND frame ZF0 (otherwise 0) */

#define ZCACK1	1	/* Acknowledge, then do command */

long rclhdr();



                  /*--------------------------------------*/
                  /*  Globals used by ZMODEM functions    */
                  /*--------------------------------------*/


extern Rxframeind;	/* ZBIN ZBIN32, or ZHEX type of frame */
extern Rxtype;		/* Type of header received */
extern Rxcount;		/* Count of data bytes received */
extern Rxtimeout;	/* Tenths of seconds to wait for something */
extern long Rxpos;	/* Received file position */
extern long Txpos;	/* Transmitted file position */
extern Txfcs32;		/* TURE means send binary frames with 32 bit FCS */
extern Crc32r;		/* Indicates/controls 32 bit CRC being received */
			/* 0 == CRC16,  1 == CRC32,  2 == CRC32 + RLE */
extern Crc32t;		/* Display flag indicating 32 bit CRC being sent */
extern Crc32;		/* Display flag indicating 32 bit CRC being received */
extern Znulls;		/* Number of nulls to send at beginning of ZDATA hdr */
extern char Attn[ZATTNLEN+1];	/* Attention string rx sends to tx on err */
extern char *Altcan;	/* Alternate canit string */
extern Usevhdrs;        /* On utilise headers taille variable */

extern Zrwindow;		/* RX window size (controls garbage count) */
extern char Rxhdr[];		/* Received header */
extern char Txhdr[];		/* Transmitted header */
extern short do_send;		/* TRUE si on emet */



                  /*--------------------------------------*/
                  /*   Globals used  by RZ.C  functions   */
                  /*     (some are also used by SZ.C)     */
                  /*--------------------------------------*/


extern int	Zmodem,		/* ZMODEM protocol requested */
		Nozmodem;	/* If invoked as "rb"        */
extern unsigned int
		Baudrate;       /* Vitesse dans BBTH         */

extern FILE	*fout;

extern int	Lastrx;
extern int	Crcflg;		/* Need Crc ? */
extern int	Firstsec;
extern int	Eofseen;	/* indicates cpm eof (^Z) has been received */
extern int	errors;
extern int	tot_errors;
extern long	rxbytes;
extern long	txbytes;	/* octets envoyes */
extern int	Restricted;	/* restricted; no /.. or ../ in filenames */
extern long	Bytesleft;	/* number of bytes of incoming file left */

extern long	Modtime;	/* Unix style mod time for incoming file */
extern short	Filemode;	/* Unix style mode for incoming file */
extern char	Pathname[PATHLEN];
extern int	Batch;
extern int	Wcsmask;
extern int	Verbose;
extern int	Rxbinary;	/* receive all files in bin mode */
extern int	Rxascii;	/* receive files in ascii (translate) mode */
extern int	Thisbinary;	/* current file is to be received in bin mode */
extern int	Blklen;		/* record length of received packets */
extern int      blklen;         /* heu ? */
extern char	secbuf[KSIZE+1];
extern int	Lleft;		/* number of characters in linbuf */
extern char	Lzmanag;	/* Local file management request */
extern char	zconv;		/* ZMODEM file conversion request */
extern char	zmanag;		/* ZMODEM file management request */
extern char	ztrans;		/* ZMODEM file transport request */
extern int	Zctlesc;	/* Encode control characters */

extern jmp_buf tohere;		/* For the interrupt on RX timeout */
extern jmp_buf abrtjmp;

extern int	tryzhdrtype;	/* Header type to send corresponding */
				/* to Last rx close                  */



                  /*--------------------------------------*/
                  /*   Globals used  by SZ.C  functions   */
                  /*     (some are also used by RZ.C)     */
                  /*--------------------------------------*/

extern int	Ascii;		/* Add CR's for brain damaged programs */
extern int	Fullname;	/* transmit full pathname */
extern int	Unlinkafter;	/* Unlink file after it is sent */
extern int	Dottoslash;	/* Change foo.bar.baz to foo/bar/baz */
extern int	errcnt;		/* number of files unreadable */
extern int	Optiong;	/* Let it rip no wait for sector ACK's */
extern int	Noeofseen;
extern int	Totsecs;	/* total number of sectors this file */
extern int	Filcnt;		/* count of number of files opened */
extern int	Lfseen;
extern unsigned Rxbuflen;	/* Receiver's max buffer length */
extern int	Tframlen;	/* Override for tx frame length */
extern int	blkopt;		/* Override value for zmodem blklen */
extern int	Rxflags;
extern long	bytcnt;
extern int	Wantfcs32;	/* want to send 32 bit FCS */
extern char	Lzconv;		/* Local ZMODEM file conversion request */
extern int	Lskipnocor;
extern char	Lztrans;
extern int	Command;	/* Send a command, then exit. */
extern char	*Cmdstr;	/* Pointer to the command string */
extern int	Cmdtries;
extern int	Cmdack1;	/* Rx ACKs command, then do it */
extern int	Exitcode;
extern int	Testattn;	/* Force receiver to send Attn, etc with qbf. */
extern long	Lastread;	/* Beginning offset of last buffer read */
extern int	Lastn;		/* Count of last buffer read or -1 */
extern int	Dontread;	/* Don't read the buffer, it's still there */
extern long	Lastsync;	/* Last offset to which we got a ZRPOS */
extern int	Beenhereb4;	/* How many times we've been ZRPOS'd same place */
extern unsigned short Txwindow;	/* Control the size of the transmitted window */
extern unsigned short Txwspac;	/* Spacing between zcrcq requests */
extern unsigned short Txwcnt;	/* Counter used to space ack requests */
extern long	Lrxpos;		/* Receiver's last reported offset */
extern char	Myattn[];
extern long     vpos ;
extern int      BEofseen;

#ifdef TXBSIZE
#define TXBMASK (TXBSIZE-1)
extern char Txb[TXBSIZE];       /* Circular buffer for file reads */
extern char *txbuf ;            /* Pointer to current file segment */
#else
extern char txbuf[1024];
#endif

extern FILE	*in;		/* fichier lu */


/* Xmodem special variables */	/* (added by [fp]) */
extern short	DoXmodem;	/* <>0 to do a Xmodem transfert */
extern char	XmodFile[80];	/* pathname du fichier Xmodem a recevoir */

extern long     total_oct;      /* Taille du fichier                   */
extern long     Time_Start;     /* Heure debut transfert  pour vitesse */
extern long     Recover;        /* Taille deja recue en crash recovery */



#ifdef AVIRER
/* Protos provisoires, faut les refaire */
void            ZmodemMsg(char *texte);
void            ZmodemBox(void);
void            sendline(unsigned char c);
void            zputhex(unsigned char  c);

void		dorz( short type),
		canit( void ),
		chkinvok( char *s ),
		zmputs( char *s ),
		ackbibi( void ),
		xmr_etat( char *s ),
		xmr_err( void ),
		xmr_oct( void ),
		zmr_etat( char *s ),
		zmr_err( void );
                noxrd7(void);

#endif




/*---------- Dclaration des fonctions de ZMPRIM.C ---------------------*/

extern  int zsbhdr(int len,int type,char *hdr);
extern  int zsbh32(int len,char *hdr,int type,int flavour);
extern  int zshhdr(int len,int type,char *hdr);
extern  int zsdata(char *buf,int length,int frameend);
extern  int zsda32(char *buf,int length,int frameend);
extern  int zrdata(char *buf,int length);
extern  int zrdat32(char *buf,int length);
extern  int zsdar32(char *buf,int length,int frameend);
extern  int zrdatr32(char *buf,int length);
extern  int zgethdr(char *hdr,int eflag);
extern  int zrbhdr(char *hdr);
extern  int zrbhd32(char *hdr);
extern  int zrhhdr(char *hdr);
extern  void zputhex(unsigned char c);
extern  int zsendline(int c);
extern  int zgethex(void );
extern  int zgeth1(void );
extern  int zdlread(void );
extern  int noxrd7(void );
extern  void stohdr(unsigned long pos);
extern  long rclhdr(char *hdr);
extern  void zmputs(char *s);
extern  void ready_next(void );
extern  void sendline(unsigned char c);
extern  int readline(int maxtemps);
extern  void ZmodemBox(void );
extern  void ZmodemMsg(char *texte);
extern  int Is_Compressed(char *Fname);


/*---------- Dclaration des fonctions de ZMENVOI.C ---------------------*/

extern  void dosz(short type);
extern  int wcsend(short argc);
extern  int wcs(char *oname);
extern  int wctxpn(char *name);
extern  int getnak(void );
extern  int wctx(long flen);
extern  int wcputsec(char *buf,int sectnum,int cseclen);
extern  int filbuf(char *buf,short count);
extern  int zfilbuf(void );
extern  int readock(short timeout,short count);
extern  int getzrxinit(void );
extern  int sendzsinit(void );
extern  int zsendfile(char *buf,short blen);
extern  int zsendfdata(void );
extern  int getinsync(int flag);
extern  int saybibi(void );
extern  int zsendcmd(char *buf,int blen);


/*---------- Dclaration des fonctions de ZMENVOI.C ---------------------*/

extern  void dorz(short type);
extern  int wcreceive(void );
extern  int wcrxpn(char *rpn);
extern  int wcrx(void );
extern  int wcgetsec(char *rxbuf,int maxtime);
extern  int procheader(char *name);
extern  int putsec(char *buf,short n);
extern  int IsAnyLower(char *s);
extern  void canit(void );
extern  int tryz(void );
extern  int rzfiles(void );
extern  int rzfile(void );
extern  int closeit(void );
extern  void ackbibi(void );
extern  int sys2(char *s);
extern  void xmr_err(void );
extern  void xmr_oct(void );
extern  void zmr_err(void );
extern  void ZmodemScan(unsigned char ch);

/*-----------------------------------------------------------------------*/
/*                       * End of ZMODEM.H                               */
/*-----------------------------------------------------------------------*/





