
/*
  ͻ
                                                                         
             DOMAINE     IBM-PC   MS-DOS(3.x+)       
                            PUBLIC                                 
                 Ren   Le protocole de Transfert BBT  
                          Cougnenc est de Jean-Claude Michot.     
                1989   La librairie de Comm.est de    
                                          Jean-Pierre Parisy & R.Gillmann
  Ķ
                                                                          
                    MODULE: ZMPRIM.C: PRimitives Z-Modem                  
                    -------------------------------------                 
                                                                          
      Ce fichier contient les variables globales utilises par Forsberg   
      pour Zmodem et Ymodem Batch, et toutes les primitives de   ces      
      protocoles.                                                         
      Il est donc compos de plusieurs fichiers du pack original des      
      sources Unix.                                                       
      Comprend la gestion des Variable Length Headers et du Run Length    
      Encoding des sous paquets.                                          
                                                                          
      Un Grand merci  Florent Pillet qui a port les sources de la ver-  
      sion 1987 sur Atari, ce qui m'a permis de piger plein de trucs :-)  
                                                                          
   Compilation: modle mmoire LARGE                                      
  Ķ
                                                                          
   Ces sources ne sont plus dans le domaine public,vu le boulot faudrait  
   pas dconner.(quoi que ce module,c'est pratiquement que du Forsberg:-) 
                                                                          
   Ceux qui voudraient un zmodem  eux n'ont qu' aller chercher les      
   sources unix de Forsberg et se taper tout le boulot comme les copains! 
                                                                          
  ͼ
  Ŀ
   BbtH 1.2 
  
*/
/*--------------------------------------------------------*/
#ifndef __TURBOC__   /* Borland Turbo-c 1.5               */
#ifndef MSDOS        /* Microsoft C                       */
#error Mfiance ! je ne connais pas ce compilateur l...
#endif
#endif
/*--------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
/*
                     Primitives  et variables globales pour Z-modem
*/

/*
 *   Z M . C
 *    ZMODEM protocol primitives
 *    07-28-87  Chuck Forsberg Omen Technology Inc
 *
 * Entry point Functions:
 *      zsbhdr(type, hdr)               send binary header
 *      zshhdr(type, hdr)               send hex header
 *      zgethdr(hdr)                    receive header - binary or hex
 *      zsdata(buf, len, frameend)      send data
 *      zrdata(buf, len)                receive data
 *      stohdr(pos)                     store position data in Txhdr
 *      long rclhdr(hdr)                recover position offset from header
 *
 * Added functions:
 *      rsmode(n)                               change serial port mode
 *      sendbrk()                       send a 1 second break signal
 * -------------------------------------------------------------------------
 */
/*
 * Z M V A R . C
 *
 * variables pour RZ.C et SZ.C, reception et emission ZMODEM.
 *
 * debut:       14/09/1989 -- florent pillet
 * -----------------------------------------------------------
 */
#include <stdio.h>
#include <setjmp.h>
#include <time.h>
#include <dos.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include <io.h>
#include "bbth.h"
#include "zmodem.h"
#include "couleurs.h"
#include "config.h"


/* Globals used by RZ.C and some used by SZ.C */

int     Zmodem = 0;             /* ZMODEM protocol requested */
int     Nozmodem = 0;           /* If invoked as "rb" */
unsigned int
        Baudrate;

FILE    *fout;

int     Lastrx;
int     Crcflg;                 /* <>0 = use CRC, otherwise use 8 bit Checksum */
int     Firstsec;
int     Eofseen;                /* indicates cpm eof (^Z) has been received */
int     errors;
int     tot_errors;             /* total des erreurs */
long    rxbytes;                /* total bytes received */
long    txbytes;                /* total bytes sent */
int     Restricted = 0;         /* restricted; no /.. or ../ in filenames */

long    Bytesleft;              /* number of bytes of incoming file left */
long    total_oct;              /* Taille du fichier                     */
long    Modtime;                /* Unix style mod time for incoming file */
short   Filemode;               /* Unix style mode for incoming file */
char    Pathname[PATHLEN];
char    *Progname;              /* the name by which we were called */

int     Batch = 0;
int     Wcsmask = 0xff;
int     Verbose = 0;
int     Rxbinary = FALSE;       /* receive all files in bin mode */
int     Rxascii = FALSE;        /* receive files in ascii (translate) mode */
int     Thisbinary;             /* current file is to be received in bin mode */
int     Blklen;                 /* record length of received packets */
int     blklen=128;             /* Heu ???? */
char    secbuf[KSIZE+1];
int     Lleft = 0;              /* number of characters in linbuf */
char    Lzmanag;                /* Local file management request */
char    zconv;                  /* ZMODEM file conversion request */
char    zmanag;                 /* ZMODEM file management request */
char    ztrans;                 /* ZMODEM file transport request */
int     Zctlesc;                /* Encode control characters */
int     Zrwindow = 1400;        /* RX window size (controls garbage count) */

jmp_buf tohere;                 /* For the interrupt on RX timeout */
jmp_buf abrtjmp;                /* for force abort */

int     tryzhdrtype = ZRINIT;   /* Header type to send corresponding */
                                /* to Last rx close */


/* Globals used by SZ.C */

#ifdef TXBSIZE
char Txb[TXBSIZE];  		/* Circular buffer for file reads */
char *txbuf = Txb;		/* Pointer to current file segment */
#else
char txbuf[1024];
#endif

int     Ascii=0;                /* Add CR's for brain damaged programs */
int     Fullname=0;             /* transmit full pathname */
int     Unlinkafter=0;          /* Unlink file after it is sent */
int     Dottoslash=0;           /* Change foo.bar.baz to foo/bar/baz */
int     errcnt=0;               /* number of files unreadable */
int     Optiong;                /* Let it rip no wait for sector ACK's */
int     Noeofseen;
int     Totsecs;                /* total number of sectors this file */
int     Filcnt=0;               /* count of number of files opened */
int     Lfseen=0;
unsigned Rxbuflen = 16384;      /* Receiver's max buffer length */
int     Tframlen = 0;           /* Override for tx frame length */
int     blkopt=0;               /* Override value for zmodem blklen */
int     Rxflags = 0;
long    bytcnt;
int     Wantfcs32 = TRUE;       /* want to send 32 bit FCS */
char    Lzconv;                 /* Local ZMODEM file conversion request */
int     Lskipnocor;
char    Lztrans;
int     Command;                /* Send a command, then exit. */
char    *Cmdstr;                /* Pointer to the command string */
int     Cmdtries = 11;
int     Cmdack1;                /* Rx ACKs command, then do it */
int     Exitcode;
int     Testattn;               /* Force receiver to send Attn, etc with qbf. */
long    Lastread;               /* Beginning offset of last buffer read */
int     Lastn;                  /* Count of last buffer read or -1 */
int     Dontread;               /* Don't read the buffer, it's still there */
long    Lastsync;               /* Last offset to which we got a ZRPOS */
int     Beenhereb4;             /* How many times we've been ZRPOS'd same place */
unsigned short Txwindow;        /* Control the size of the transmitted window */
unsigned short Txwspac;         /* Spacing between zcrcq requests */
unsigned short Txwcnt;          /* Counter used to space ack requests */
long    Lrxpos;                 /* Receiver's last reported offset */
long    vpos ;
int     BEofseen;

FILE    *in;                    /* fichier lu */


/*
 * Attention string to be executed by receiver to interrupt streaming data
 *  when an error is detected.  A pause (0336) may be needed before the
 *  ^C (03) or after it.
 */
char    Myattn[] = { 0 };





/* Globals used by ZMODEM functions (coming from ZM.C) */

int     Rxframeind;             /* ZBIN ZBIN32, or ZHEX type of frame received */
int     Rxtype;                 /* Type of header received */
int     Rxcount;                /* Count of data bytes received */

char Rxhdr[ZMAXHLEN];	/* Received header */
char Txhdr[ZMAXHLEN];	/* Transmitted header */

long    Rxpos;                  /* Received file position */
long    Txpos;                  /* Transmitted file position */
int     Txfcs32;                /* TURE means send binary frames with 32 bit FCS */
int     Crc32t;                 /* Display flag indicating 32 bit CRC being sent */
                                /* 1= CRC 32    2 = CRC 32 + RLE */
int     Crc32;                  /* Display flag indicating 32 bit CRC being received */
int     Znulls;                 /* Number of nulls to send at beginning of ZDATA hdr */
char    Attn[ZATTNLEN+1];       /* Attention string rx sends to tx on err */
short   do_send;                /* TRUE si on emet - c'est pour mes routines */
                                /* d'affichage dans les ressources */

int     Rxtimeout=100;          /* Tenths of seconds to wait for something */

/* Globals used by ZMODEM functions new release */

int Rxhlen;		/* Length of header received */

int Crc32r;		/* Indicates/controls 32 bit CRC being received */
			/* 0 == CRC16,  1 == CRC32,  2 == CRC32 + RLE */
int Usevhdrs;		/* Use variable length headers */
char Attn[ZATTNLEN+1];	/* Attention string rx sends to tx on err */
char *Altcan;		/* Alternate canit string */

static lastsent;	/* Last char we sent */
static Not8bit;		/* Seven bits seen on header */



/* Variables used for Xmodem transfers */

short   DoXmodem;               /* <>0 = Xmodem transfert */
char    XmodFile[80];
long    total_oct;              /* Taille du fichier                     */
long    Time_Start;             /* Debut transfert pour vitesse          */
long    Recover;                /* Taile deja recue en crash recovery    */







                /******* TABLES DE CRC *******/

/* crctab calculated by Mark G. Mendel, Network Systems Corporation */
unsigned short crctab[256] = {
    0x0000,  0x1021,  0x2042,  0x3063,  0x4084,  0x50a5,  0x60c6,  0x70e7,
    0x8108,  0x9129,  0xa14a,  0xb16b,  0xc18c,  0xd1ad,  0xe1ce,  0xf1ef,
    0x1231,  0x0210,  0x3273,  0x2252,  0x52b5,  0x4294,  0x72f7,  0x62d6,
    0x9339,  0x8318,  0xb37b,  0xa35a,  0xd3bd,  0xc39c,  0xf3ff,  0xe3de,
    0x2462,  0x3443,  0x0420,  0x1401,  0x64e6,  0x74c7,  0x44a4,  0x5485,
    0xa56a,  0xb54b,  0x8528,  0x9509,  0xe5ee,  0xf5cf,  0xc5ac,  0xd58d,
    0x3653,  0x2672,  0x1611,  0x0630,  0x76d7,  0x66f6,  0x5695,  0x46b4,
    0xb75b,  0xa77a,  0x9719,  0x8738,  0xf7df,  0xe7fe,  0xd79d,  0xc7bc,
    0x48c4,  0x58e5,  0x6886,  0x78a7,  0x0840,  0x1861,  0x2802,  0x3823,
    0xc9cc,  0xd9ed,  0xe98e,  0xf9af,  0x8948,  0x9969,  0xa90a,  0xb92b,
    0x5af5,  0x4ad4,  0x7ab7,  0x6a96,  0x1a71,  0x0a50,  0x3a33,  0x2a12,
    0xdbfd,  0xcbdc,  0xfbbf,  0xeb9e,  0x9b79,  0x8b58,  0xbb3b,  0xab1a,
    0x6ca6,  0x7c87,  0x4ce4,  0x5cc5,  0x2c22,  0x3c03,  0x0c60,  0x1c41,
    0xedae,  0xfd8f,  0xcdec,  0xddcd,  0xad2a,  0xbd0b,  0x8d68,  0x9d49,
    0x7e97,  0x6eb6,  0x5ed5,  0x4ef4,  0x3e13,  0x2e32,  0x1e51,  0x0e70,
    0xff9f,  0xefbe,  0xdfdd,  0xcffc,  0xbf1b,  0xaf3a,  0x9f59,  0x8f78,
    0x9188,  0x81a9,  0xb1ca,  0xa1eb,  0xd10c,  0xc12d,  0xf14e,  0xe16f,
    0x1080,  0x00a1,  0x30c2,  0x20e3,  0x5004,  0x4025,  0x7046,  0x6067,
    0x83b9,  0x9398,  0xa3fb,  0xb3da,  0xc33d,  0xd31c,  0xe37f,  0xf35e,
    0x02b1,  0x1290,  0x22f3,  0x32d2,  0x4235,  0x5214,  0x6277,  0x7256,
    0xb5ea,  0xa5cb,  0x95a8,  0x8589,  0xf56e,  0xe54f,  0xd52c,  0xc50d,
    0x34e2,  0x24c3,  0x14a0,  0x0481,  0x7466,  0x6447,  0x5424,  0x4405,
    0xa7db,  0xb7fa,  0x8799,  0x97b8,  0xe75f,  0xf77e,  0xc71d,  0xd73c,
    0x26d3,  0x36f2,  0x0691,  0x16b0,  0x6657,  0x7676,  0x4615,  0x5634,
    0xd94c,  0xc96d,  0xf90e,  0xe92f,  0x99c8,  0x89e9,  0xb98a,  0xa9ab,
    0x5844,  0x4865,  0x7806,  0x6827,  0x18c0,  0x08e1,  0x3882,  0x28a3,
    0xcb7d,  0xdb5c,  0xeb3f,  0xfb1e,  0x8bf9,  0x9bd8,  0xabbb,  0xbb9a,
    0x4a75,  0x5a54,  0x6a37,  0x7a16,  0x0af1,  0x1ad0,  0x2ab3,  0x3a92,
    0xfd2e,  0xed0f,  0xdd6c,  0xcd4d,  0xbdaa,  0xad8b,  0x9de8,  0x8dc9,
    0x7c26,  0x6c07,  0x5c64,  0x4c45,  0x3ca2,  0x2c83,  0x1ce0,  0x0cc1,
    0xef1f,  0xff3e,  0xcf5d,  0xdf7c,  0xaf9b,  0xbfba,  0x8fd9,  0x9ff8,
    0x6e17,  0x7e36,  0x4e55,  0x5e74,  0x2e93,  0x3eb2,  0x0ed1,  0x1ef0
};


unsigned  long cr3tab[] = {             /* CRC polynomial 0xedb88320 */
0x00000000, 0x77073096, 0xee0e612c, 0x990951ba, 0x076dc419, 0x706af48f, 0xe963a535, 0x9e6495a3,
0x0edb8832, 0x79dcb8a4, 0xe0d5e91e, 0x97d2d988, 0x09b64c2b, 0x7eb17cbd, 0xe7b82d07, 0x90bf1d91,
0x1db71064, 0x6ab020f2, 0xf3b97148, 0x84be41de, 0x1adad47d, 0x6ddde4eb, 0xf4d4b551, 0x83d385c7,
0x136c9856, 0x646ba8c0, 0xfd62f97a, 0x8a65c9ec, 0x14015c4f, 0x63066cd9, 0xfa0f3d63, 0x8d080df5,
0x3b6e20c8, 0x4c69105e, 0xd56041e4, 0xa2677172, 0x3c03e4d1, 0x4b04d447, 0xd20d85fd, 0xa50ab56b,
0x35b5a8fa, 0x42b2986c, 0xdbbbc9d6, 0xacbcf940, 0x32d86ce3, 0x45df5c75, 0xdcd60dcf, 0xabd13d59,
0x26d930ac, 0x51de003a, 0xc8d75180, 0xbfd06116, 0x21b4f4b5, 0x56b3c423, 0xcfba9599, 0xb8bda50f,
0x2802b89e, 0x5f058808, 0xc60cd9b2, 0xb10be924, 0x2f6f7c87, 0x58684c11, 0xc1611dab, 0xb6662d3d,
0x76dc4190, 0x01db7106, 0x98d220bc, 0xefd5102a, 0x71b18589, 0x06b6b51f, 0x9fbfe4a5, 0xe8b8d433,
0x7807c9a2, 0x0f00f934, 0x9609a88e, 0xe10e9818, 0x7f6a0dbb, 0x086d3d2d, 0x91646c97, 0xe6635c01,
0x6b6b51f4, 0x1c6c6162, 0x856530d8, 0xf262004e, 0x6c0695ed, 0x1b01a57b, 0x8208f4c1, 0xf50fc457,
0x65b0d9c6, 0x12b7e950, 0x8bbeb8ea, 0xfcb9887c, 0x62dd1ddf, 0x15da2d49, 0x8cd37cf3, 0xfbd44c65,
0x4db26158, 0x3ab551ce, 0xa3bc0074, 0xd4bb30e2, 0x4adfa541, 0x3dd895d7, 0xa4d1c46d, 0xd3d6f4fb,
0x4369e96a, 0x346ed9fc, 0xad678846, 0xda60b8d0, 0x44042d73, 0x33031de5, 0xaa0a4c5f, 0xdd0d7cc9,
0x5005713c, 0x270241aa, 0xbe0b1010, 0xc90c2086, 0x5768b525, 0x206f85b3, 0xb966d409, 0xce61e49f,
0x5edef90e, 0x29d9c998, 0xb0d09822, 0xc7d7a8b4, 0x59b33d17, 0x2eb40d81, 0xb7bd5c3b, 0xc0ba6cad,
0xedb88320, 0x9abfb3b6, 0x03b6e20c, 0x74b1d29a, 0xead54739, 0x9dd277af, 0x04db2615, 0x73dc1683,
0xe3630b12, 0x94643b84, 0x0d6d6a3e, 0x7a6a5aa8, 0xe40ecf0b, 0x9309ff9d, 0x0a00ae27, 0x7d079eb1,
0xf00f9344, 0x8708a3d2, 0x1e01f268, 0x6906c2fe, 0xf762575d, 0x806567cb, 0x196c3671, 0x6e6b06e7,
0xfed41b76, 0x89d32be0, 0x10da7a5a, 0x67dd4acc, 0xf9b9df6f, 0x8ebeeff9, 0x17b7be43, 0x60b08ed5,
0xd6d6a3e8, 0xa1d1937e, 0x38d8c2c4, 0x4fdff252, 0xd1bb67f1, 0xa6bc5767, 0x3fb506dd, 0x48b2364b,
0xd80d2bda, 0xaf0a1b4c, 0x36034af6, 0x41047a60, 0xdf60efc3, 0xa867df55, 0x316e8eef, 0x4669be79,
0xcb61b38c, 0xbc66831a, 0x256fd2a0, 0x5268e236, 0xcc0c7795, 0xbb0b4703, 0x220216b9, 0x5505262f,
0xc5ba3bbe, 0xb2bd0b28, 0x2bb45a92, 0x5cb36a04, 0xc2d7ffa7, 0xb5d0cf31, 0x2cd99e8b, 0x5bdeae1d,
0x9b64c2b0, 0xec63f226, 0x756aa39c, 0x026d930a, 0x9c0906a9, 0xeb0e363f, 0x72076785, 0x05005713,
0x95bf4a82, 0xe2b87a14, 0x7bb12bae, 0x0cb61b38, 0x92d28e9b, 0xe5d5be0d, 0x7cdcefb7, 0x0bdbdf21,
0x86d3d2d4, 0xf1d4e242, 0x68ddb3f8, 0x1fda836e, 0x81be16cd, 0xf6b9265b, 0x6fb077e1, 0x18b74777,
0x88085ae6, 0xff0f6a70, 0x66063bca, 0x11010b5c, 0x8f659eff, 0xf862ae69, 0x616bffd3, 0x166ccf45,
0xa00ae278, 0xd70dd2ee, 0x4e048354, 0x3903b3c2, 0xa7672661, 0xd06016f7, 0x4969474d, 0x3e6e77db,
0xaed16a4a, 0xd9d65adc, 0x40df0b66, 0x37d83bf0, 0xa9bcae53, 0xdebb9ec5, 0x47b2cf7f, 0x30b5ffe9,
0xbdbdf21c, 0xcabac28a, 0x53b39330, 0x24b4a3a6, 0xbad03605, 0xcdd70693, 0x54de5729, 0x23d967bf,
0xb3667a2e, 0xc4614ab8, 0x5d681b02, 0x2a6f2b94, 0xb40bbe37, 0xc30c8ea1, 0x5a05df1b, 0x2d02ef8d
};

/* End of crctab.c */


/* ------------------------------------------------ */


static char *frametypes[] = {
        "Plus de porteuse",/* -3 */
        "TIMEOUT",      /* -2 */
        "ERREUR",       /* -1 */
#define FTOFFSET 3
        "ZRQINIT",
        "ZRINIT",
        "ZSINIT",
        "ZACK",
        "ZFILE",
        "ZSKIP",
        "ZNAK",
        "ZABORT",
        "ZFIN",
        "ZRPOS",
        "ZDATA",
        "ZEOF",
        "ZFERR",
        "ZCRC",
        "ZCHALLENGE",
        "ZCOMPL",
        "ZCAN",
        "ZFREECNT",
        "ZCOMMAND",
        "ZSTDERR",
        "xxxxx"
#define FRTYPES 22      /* Total number of frame types in this array */
                        /*  not including psuedo negative entries */
};



/*---------------------------------------------------------------------------*/
/*
 rdchk(fd) : retourne Non-Zero si un char est  lire sur le fichier fd.
             Ici c'est le port srie, je laisse toutefois pour pas trop
             casser le code de Forsberg le fd non u tilise.
*/

int rdchk(int fd)
{
 if (PortReady(NumPort) ) return(1);
 else                     return(0);
}



/*--------------------------------------------------------------------------*/

/*
 * ZSBHDR: Send ZMODEM binary header hdr of type type
 * --------------------------------------------------
 */

/* Send ZMODEM binary header hdr of type type */
zsbhdr(len, type, hdr)
register char *hdr;
{
	register int n;
	register unsigned short crc;

	if (type == ZDATA)
		for (n = Znulls; --n >=0; )
			xsendline(0);

	xsendline(ZPAD);
        xsendline(ZDLE);

	switch (Crc32t=Txfcs32) {
	case 2:
		zsbh32(len, hdr, type, Usevhdrs?ZVBINR32:ZBINR32);
		break;
	case 1:
		zsbh32(len, hdr, type, Usevhdrs?ZVBIN32:ZBIN32);  break;
	default:
		if (Usevhdrs) {
			xsendline(ZVBIN);
			zsendline(len);
		}
		else
			xsendline(ZBIN);
		zsendline(type);
		crc = updcrc(type, 0);

		for (n=len; --n >= 0; ++hdr) {
			zsendline(*hdr);
			crc = updcrc((0377& *hdr), crc);
		}
		crc = updcrc(0,updcrc(0,crc));
		zsendline(crc>>8);
		zsendline(crc);
	}
	/* if (type != ZDATA)
		flushmo(); */
}




/*
 * ZSBH32: Send ZMODEM binary header hdr of type type
 * --------------------------------------------------
 */

zsbh32(len, hdr, type, flavour)
register char *hdr;
{
	register int n;
	register unsigned long crc;

	xsendline(flavour);
	if (Usevhdrs)
		zsendline(len);
	zsendline(type);
	crc = 0xFFFFFFFFL; crc = UPDC32(type, crc);

	for (n=len; --n >= 0; ++hdr) {
		crc = UPDC32((0377 & *hdr), crc);
		zsendline(*hdr);
	}
	crc = ~crc;
	for (n=4; --n >= 0;) {
		zsendline((int)crc);
		crc >>= 8;
	}
}







/*
 * ZSHHDR: Send ZMODEM HEX header hdr of type type
 * -----------------------------------------------
 */

zshhdr(len, type, hdr)
register char *hdr;
{
	register int n;
	register unsigned short crc;

	sendline(ZPAD);
        sendline(ZPAD);
        sendline(ZDLE);

	if (Usevhdrs) {
		sendline(ZVHEX);
		zputhex(len);
	}
	else
		sendline(ZHEX);
	zputhex(type);
	Crc32t = 0;

	crc = updcrc(type, 0);
	for (n=len; --n >= 0; ++hdr) {
		zputhex(*hdr); crc = updcrc((0377 & *hdr), crc);
	}
	crc = updcrc(0,updcrc(0,crc));
	zputhex(crc>>8); zputhex(crc);

	/* Make it printable on remote machine */
	sendline(015); sendline(0212);
	/*
	 * Uncork the remote in case a fake XOFF has stopped data flow
	 */
	if (type != ZFIN && type != ZACK)
		sendline(021);
}




/*
 * ZSDATA: Send binary array buf of length length,
 * with ending ZDLE sequence frameend
 * -----------------------------------------------
 */

zsdata(buf, length, frameend)
register char *buf;
{
	register unsigned short crc;

	switch (Crc32t)
        {
	case 1:
		zsda32(buf, length, frameend);  break;
	case 2:
		zsdar32(buf, length, frameend);  break;
	default:
		crc = 0;
		for (;--length >= 0; ++buf)
                {
			zsendline(*buf);
                        crc = updcrc((0377 & *buf), crc);
		}
		xsendline(ZDLE); xsendline(frameend);
		crc = updcrc(frameend, crc);

		crc = updcrc(0,updcrc(0,crc));
		zsendline(crc>>8); zsendline(crc);
	}
	if (frameend == ZCRCW)
        {
		xsendline(XON);
	}
}




/*
 * ZSDA32: idem mais en CRC-32
 * ---------------------------
 */

zsda32(buf, length, frameend)
register char *buf;
{
	register int c;
	unsigned long crc;

	crc = 0xFFFFFFFFL;
	for (;--length >= 0; ++buf) {
		c = *buf & 0377;
		if (c & 0140)
			xsendline(lastsent = c);
		else
			zsendline(c);
		crc = UPDC32(c, crc);
	}
	xsendline(ZDLE); xsendline(frameend);
	crc = UPDC32(frameend, crc);

	crc = ~crc;
	for (c=4; --c >= 0;)
        {
		zsendline((int)crc);
                crc >>= 8;
	}
}




/*
 * ZRDATA: Receive array buf of max length with ending ZDLE sequence
 * and CRC.  Returns the ending character or error code.
 * NB: On errors may store length+1 bytes!
 * -----------------------------------------------------------------
 */

zrdata(buf, length)
register char *buf;
{
	register int c;
	register unsigned short crc;
	register char *end;
	register int d;

	switch (Crc32r)
        {
	case 1:
		return zrdat32(buf, length);
	case 2:
		return zrdatr32(buf, length);
	}

	crc = Rxcount = 0;  end = buf + length;
	while (buf <= end) {
		if ((c = zdlread()) & ~0377) {
crcfoo:
			switch (c) {
			case GOTCRCE:
			case GOTCRCG:
			case GOTCRCQ:
			case GOTCRCW:
				crc = updcrc((d=c)&0377, crc);
				if ((c = zdlread()) & ~0377)
					goto crcfoo;
				crc = updcrc(c, crc);
				if ((c = zdlread()) & ~0377)
					goto crcfoo;
				crc = updcrc(c, crc);
				if (crc & 0xFFFF) {
					ZmodemMsg("  Mauvais CRC");
					return ERROR;
				}
				Rxcount = length - (end - buf);
				return d;
			case GOTCAN:
				ZmodemMsg("Transfert Interrompu.");
				return ZCAN;
			case TIMEOUT:
				ZmodemMsg("   TIME-OUT");
				return c;
			default:
				ZmodemMsg("Mauvais sous-Paquet");
                                return c;
			}
		}
		*buf++ = c;
		crc = updcrc(c, crc);
	}
	ZmodemMsg("Sous-Paquet trop long");
	return ERROR;
}





/*
 * ZRDAT32: idem mais en CRC-32
 * ----------------------------
 */

zrdat32(buf, length)
register char *buf;
{
	register int c;
	unsigned long crc;
	register char *end;
	register int d;

	crc = 0xFFFFFFFFL;  Rxcount = 0;  end = buf + length;
	while (buf <= end) {
		if ((c = zdlread()) & ~0377) {
crcfoo:
			switch (c) {
			case GOTCRCE:
			case GOTCRCG:
			case GOTCRCQ:
			case GOTCRCW:
				d = c;  c &= 0377;
				crc = UPDC32(c, crc);
				if ((c = zdlread()) & ~0377)
					goto crcfoo;
				crc = UPDC32(c, crc);
				if ((c = zdlread()) & ~0377)
					goto crcfoo;
				crc = UPDC32(c, crc);
				if ((c = zdlread()) & ~0377)
					goto crcfoo;
				crc = UPDC32(c, crc);
				if ((c = zdlread()) & ~0377)
					goto crcfoo;
				crc = UPDC32(c, crc);
				if (crc != 0xDEBB20E3)
                                {
					ZmodemMsg("   Mauvais CRC");
      					return ERROR;
				}
				Rxcount = length - (end - buf);
				return d;
			case GOTCAN:
				ZmodemMsg("Transfert Interrompu.");
				return ZCAN;
			case TIMEOUT:
				ZmodemMsg("  TIME-OUT");
				return c;
			default:
				ZmodemMsg("Mauvais Sous-Paquet.");
                                return c;
			}
		}
		*buf++ = c;
		crc = UPDC32(c, crc);
	}
	ZmodemMsg("Sous-Paquet trop long");
	return ERROR;
}





/*
 * File: zmr.c 07-30-1989
 * Copyright 1988, 1989 Omen Technology Inc All Rights Reserved
 *
 *
 *
 * This module implements ZMODEM Run Length Encoding, an
 * extension that was not funded by the original Telenet
 * development contract.
 *
 * This software may be freely used for non commercial and
 * educational (didactic only) purposes.  This software may also
 * be freely used to support file transfer operations to or from
 * licensed Omen Technology products.  Any programs which use
 * part or all of this software must be provided in source form
 * with this notice intact except by written permission from Omen
 * Technology Incorporated.
 *
 * Use of this software for commercial or administrative purposes
 * except when exclusively limited to interfacing Omen Technology
 * products requires a per port license payment of $20.00 US per
 * port (less in quantity).  Use of this code by inclusion,
 * decompilation, reverse engineering or any other means
 * constitutes agreement to these conditions and acceptance of
 * liability to license the materials and payment of reasonable
 * legal costs necessary to enforce this license agreement.
 *
 *
 *		Omen Technology Inc		FAX: 503-621-3745
 *		Post Office Box 4681
 *		Portland OR 97208
 *
 *	This code is made available in the hope it will be useful,
 *	BUT WITHOUT ANY WARRANTY OF ANY KIND OR LIABILITY FOR ANY
 *	DAMAGES OF ANY KIND.
 *
 *	ZMODEM RLE compression and decompression functions
 */

/* Send data subpacket RLE encoded with 32 bit FCS */
zsdar32(buf, length, frameend)
char *buf;
{
	register int c, l, n;
	unsigned long crc;

	crc = 0xFFFFFFFFL;  l = *buf++ & 0377;
	if (length == 1)
        {
		zsendline(l); crc = UPDC32(l, crc);
		if (l == ZRESC)
                {
			zsendline(1); crc = UPDC32(1, crc);
		}
	}
        else
        {
		for (n = 0; --length >= 0; ++buf) {
			if ((c = *buf & 0377) == l && n < 126 && length>0)
                        {
				++n;
                                continue;
			}
			switch (n)
                        {
			case 0:
				zsendline(l);
				crc = UPDC32(l, crc);
				if (l == ZRESC)
                                {
					zsendline(0100); crc = UPDC32(0100, crc);
				}
				l = c; break;
			case 1:
				if (l != ZRESC)
                                {
					zsendline(l); zsendline(l);
					crc = UPDC32(l, crc);
					crc = UPDC32(l, crc);
					n = 0; l = c; break;
				}
				/* **** FALL THRU TO **** */
			default:
				zsendline(ZRESC); crc = UPDC32(ZRESC, crc);
				if (l == 040 && n < 34)
                                {
					n += 036;
					zsendline(n);
                                        crc = UPDC32(n, crc);
				}
				else
                                {
					n += 0101;
					zsendline(n); crc = UPDC32(n, crc);
					zsendline(l); crc = UPDC32(l, crc);
				}
				n = 0; l = c; break;
			}
		}
	}
	xsendline(ZDLE); xsendline(frameend);
	crc = UPDC32(frameend, crc);

	crc = ~crc;
	for (length=4; --length >= 0;)
        {
		zsendline((int)crc);
                crc >>= 8;
	}
}


/* Receive data subpacket RLE encoded with 32 bit FCS */
zrdatr32(buf, length)
register char *buf;
{
	register int c;
	unsigned long crc;
	register char *end;
	register int d;

	crc = 0xFFFFFFFFL;  Rxcount = 0;  end = buf + length;
	d = 0;	/* Use for RLE decoder state */
	while (buf <= end)
        {
		if ((c = zdlread()) & ~0377)
                {
crcfoo:
			switch (c)
                        {
			case GOTCRCE:
			case GOTCRCG:
			case GOTCRCQ:
			case GOTCRCW:
				d = c;  c &= 0377;
				crc = UPDC32(c, crc);
				if ((c = zdlread()) & ~0377)
					goto crcfoo;
				crc = UPDC32(c, crc);
				if ((c = zdlread()) & ~0377)
					goto crcfoo;
				crc = UPDC32(c, crc);
				if ((c = zdlread()) & ~0377)
					goto crcfoo;
				crc = UPDC32(c, crc);
				if ((c = zdlread()) & ~0377)
					goto crcfoo;
				crc = UPDC32(c, crc);
				if (crc != 0xDEBB20E3)
                                {
					ZmodemMsg("  RLE: Mauvais Crc");
					return ERROR;
				}
				Rxcount = length - (end - buf);
				return d;
			case GOTCAN:
				ZmodemMsg(" Annul par le serveur");
				return ZCAN;
			case TIMEOUT:
				ZmodemMsg("TIME-OUT");
				return c;
			default:
				ZmodemMsg("Mauvais sous-paquet");
				return c;
			}
		}
		crc = UPDC32(c, crc);
		switch (d)
                {
		case 0:
			if (c == ZRESC)
                        {
				d = -1;  continue;
			}
			*buf++ = c;  continue;
		case -1:
			if (c >= 040 && c < 0100)
                        {
				d = c - 035; c = 040;  goto spaces;
			}
			if (c == 0100)
                        {
				d = 0;
				*buf++ = ZRESC;  continue;
			}
			d = c;  continue;
		default:
			d -= 0100;
			if (d < 1)
				goto badpkt;
spaces:
			if ((buf + d) > end)
				goto badpkt;
			while ( --d >= 0)
				*buf++ = c;
			d = 0;  continue;
		}
	}
badpkt:
	ZmodemMsg("Sous Paquet trop long.");
	return ERROR;
}
/*-------------------------- fin du RLE -----------------------------------*/




/*
 * ZGETHDR: Read a ZMODEM header to hdr, either binary or hex.
 *   On success, set Zmodem to 1, set Rxpos and return type of header.
 *   Otherwise return negative on error.
 *   Return ERROR instantly if ZCRCW sequence, for fast error recovery.
 * --------------------------------------------------------------------

 *  eflag controls local display of non zmodem characters:
 *	0:  no display
 *	1:  display printing characters only
 *	2:  display all non ZMODEM characters
 *
 *   Set Rxhlen to size of header (default 4) (valid iff good hdr)
 *  On success, set Zmodem to 1, set Rxpos and return type of header.
 *   Otherwise return negative on error.
 *   Return ERROR instantly if ZCRCW sequence, for fast error recovery.
 */
zgethdr(hdr, eflag)
char *hdr;
{
	register int c, n, cancount;

	n = Zrwindow + BaudRate;	/* Max bytes before start of frame */
	Rxframeind = Rxtype = 0;

startover:
	cancount = 5;
again:
	/* Return immediate ERROR if ZCRCW sequence seen */
	switch (c = readline(Rxtimeout)) {
	case 021: case 0221:
		goto again;
	case RCDO:
	case TIMEOUT:
		goto fifi;
	case CAN:
gotcan:
		if (--cancount <= 0) {
			c = ZCAN; goto fifi;
		}
		switch (c = readline(1)) {
		case TIMEOUT:
			goto again;
		case ZCRCW:
			switch (readline(1)) {
			case TIMEOUT:
				c = ERROR; goto fifi;
			case RCDO:
				goto fifi;
			default:
				goto agn2;
			}
		case RCDO:
			goto fifi;
		default:
			break;
		case CAN:
			if (--cancount <= 0) {
				c = ZCAN; goto fifi;
			}
			goto again;
		}
	/* **** FALL THRU TO **** */
	default:
agn2:
		if ( --n == 0)
                {
			c = GCOUNT;  goto fifi;
		}

		/* if (eflag && ((c &= 0177) & 0140))
			bttyout(c);
		else if (eflag > 1)
			bttyout(c); */
		goto startover;
	case ZPAD|0200:		/* This is what we want. */
		Not8bit = c;
	case ZPAD:		/* This is what we want. */
		break;
	}
	cancount = 5;
splat:
	switch (c = noxrd7())
        {
	case ZPAD:
		goto splat;
	case RCDO:
	case TIMEOUT:
		goto fifi;
	default:
		goto agn2;
	case ZDLE:		/* This is what we want. */
		break;
	}


	Rxhlen = 4;		/* Set default length */
	Rxframeind = c = noxrd7();
	switch (c)
        {
	case ZVBIN32:
		if ((Rxhlen = c = zdlread()) < 0)
			goto fifi;
		if (c > ZMAXHLEN)
			goto agn2;
		Crc32r = 1;  c = zrbhd32(hdr); break;
	case ZBIN32:
		if (Usevhdrs)
			goto agn2;
		Crc32r = 1;  c = zrbhd32(hdr); break;
	case ZVBINR32:
		if ((Rxhlen = c = zdlread()) < 0)
			goto fifi;
		if (c > ZMAXHLEN)
			goto agn2;
		Crc32r = 2;  c = zrbhd32(hdr); break;
	case ZBINR32:
		if (Usevhdrs)
			goto agn2;
		Crc32r = 2;  c = zrbhd32(hdr); break;
	case RCDO:
	case TIMEOUT:
		goto fifi;
	case ZVBIN:
		if ((Rxhlen = c = zdlread()) < 0)
			goto fifi;
		if (c > ZMAXHLEN)
			goto agn2;
		Crc32r = 0;  c = zrbhdr(hdr); break;
	case ZBIN:
		if (Usevhdrs)
			goto agn2;
		Crc32r = 0;  c = zrbhdr(hdr); break;
	case ZVHEX:
		if ((Rxhlen = c = zgethex()) < 0)
			goto fifi;
		if (c > ZMAXHLEN)
			goto agn2;
		Crc32r = 0;  c = zrhhdr(hdr); break;
	case ZHEX:
		if (Usevhdrs)
			goto agn2;
		Crc32r = 0;  c = zrhhdr(hdr); break;
	case CAN:
		goto gotcan;
	default:
		goto agn2;
	}
	for (n = Rxhlen; ++n < ZMAXHLEN; )	/* Clear unused hdr bytes */
		hdr[n] = 0;
	Rxpos = hdr[ZP3] & 0377;
	Rxpos = (Rxpos<<8) + (hdr[ZP2] & 0377);
	Rxpos = (Rxpos<<8) + (hdr[ZP1] & 0377);
	Rxpos = (Rxpos<<8) + (hdr[ZP0] & 0377);
fifi:
	switch (c)
        {
	case GOTCAN:
		c = ZCAN;
	/* **** FALL THRU TO **** */
	case ZNAK:
	case ZCAN:
	case ERROR:
	case TIMEOUT:
	case RCDO:
	case GCOUNT:
		ZmodemMsg(frametypes[c+FTOFFSET]);
	}
	/* Use variable length headers if we got one */
	if (c >= 0 && c <= FRTYPES && Rxframeind & 040)
		Usevhdrs = 1;
	return c;
}










/*
 * ZRBHDR: Receive a binary style header (type and position)
 * ---------------------------------------------------------
 */

zrbhdr(hdr)
register char *hdr;
{
	register int c, n;
	register unsigned short crc;

	if ((c = zdlread()) & ~0377)
		return c;
	Rxtype = c;
	crc = updcrc(c, 0);

	for (n=Rxhlen; --n >= 0; ++hdr)
        {
		if ((c = zdlread()) & ~0377)
			return c;
		crc = updcrc(c, crc);
		*hdr = c;
	}
	if ((c = zdlread()) & ~0377)
		return c;
	crc = updcrc(c, crc);
	if ((c = zdlread()) & ~0377)
		return c;
	crc = updcrc(c, crc);
	if (crc & 0xFFFF) {
		ZmodemMsg("   Bad CRC ");
		return ERROR;
	}
	Zmodem = 1;
	return Rxtype;
}



/*
 * ZRBHDR32: Receive a binary style header (type and position) with 32 bit FCS
 * ---------------------------------------------------------------------------
 */

zrbhd32(hdr)
register char *hdr;
{
	register int c, n;
	register unsigned long crc;

	if ((c = zdlread()) & ~0377)
		return c;
	Rxtype = c;
	crc = 0xFFFFFFFFL; crc = UPDC32(c, crc);

	for (n=Rxhlen; --n >= 0; ++hdr) {
		if ((c = zdlread()) & ~0377)
			return c;
		crc = UPDC32(c, crc);
		*hdr = c;
	}
	for (n=4; --n >= 0;)
        {
		if ((c = zdlread()) & ~0377)
			return c;
		crc = UPDC32(c, crc);
	}
	if (crc != 0xDEBB20E3) {
		ZmodemMsg(" Mauvais CRC !");
		return ERROR;
	}
	Zmodem = 1;
	return Rxtype;
}





/*
 * ZRHHDR: Receive a hex style header (type and position)
 * ------------------------------------------------------
 */


zrhhdr(hdr)
char *hdr;
{
	register int c;
	register unsigned short crc;
	register int n;

	if ((c = zgethex()) < 0)
		return c;
	Rxtype = c;
	crc = updcrc(c, 0);

	for (n=Rxhlen; --n >= 0; ++hdr) {
		if ((c = zgethex()) < 0)
			return c;
		crc = updcrc(c, crc);
		*hdr = c;
	}
	if ((c = zgethex()) < 0)
		return c;
	crc = updcrc(c, crc);
	if ((c = zgethex()) < 0)
		return c;
	crc = updcrc(c, crc);
	if (crc & 0xFFFF)
        {
		ZmodemMsg(" Mauvais CRC");
                return ERROR;
	}
	switch ( c = readline(2)) {
	case 0215:
		Not8bit = c;
		/* **** FALL THRU TO **** */
	case 015:
	 	/* Throw away possible cr/lf */
		switch (c = readline(2)) {
		case 012:
			Not8bit |= c;
		}
	}
	Zmodem = 1;
	if (c < 0)
		return c;
	return Rxtype;
}




/*
 * ZPUTHEX: Send a byte as two hex digits
 * --------------------------------------
 */
void zputhex(c)
register unsigned char c;
{
        static char     digits[]        = "0123456789abcdef";

        sendline(digits[(c&0xF0)>>4]);
        sendline(digits[(c)&0xF]);
}




/*
 * ZSENDLINE: Send character c with ZMODEM escape sequence encoding.
 * Escape XON, XOFF. Escape CR following @ (Telenet net escape)
 * -----------------------------------------------------------------
 */


zsendline(c)
{

	/* Quick check for non control characters */
	if (c & 0140)
		xsendline(lastsent = c);
	else {
		switch (c &= 0377) {
		case ZDLE:
			xsendline(ZDLE);
			xsendline (lastsent = (c ^= 0100));
			break;
		case 015:
		case 0215:
			if (!Zctlesc && (lastsent & 0177) != '@')
				goto sendit;
		/* **** FALL THRU TO **** */
		case 020:
		case 021:
		case 023:
		case 0220:
		case 0221:
		case 0223:
			xsendline(ZDLE);
			c ^= 0100;
	sendit:
			xsendline(lastsent = c);
			break;
		default:
			if (Zctlesc && ! (c & 0140)) {
				xsendline(ZDLE);
				c ^= 0100;
			}
			xsendline(lastsent = c);
		}
	}
}





/*
 * ZGETHEX: Decode two lower case hex digits into an 8 bit byte value
 * ------------------------------------------------------------------
 */
zgethex()
{
	register int c;

	c = zgeth1();
	return c;
}
zgeth1()
{
	register int c, n;

	if ((c = noxrd7()) < 0)
		return c;
	n = c - '0';
	if (n > 9)
		n -= ('a' - ':');
	if (n & ~0xF)
		return ERROR;
	if ((c = noxrd7()) < 0)
		return c;
	c -= '0';
	if (c > 9)
		c -= ('a' - ':');
	if (c & ~0xF)
		return ERROR;
	c += (n<<4);
	return c;
}





/*
 * ZDLREAD: Read a byte, checking for ZMODEM escape encoding
 * including CAN*5 which represents a quick abort
 * ---------------------------------------------------------
 */

zdlread()
{
	register int c;

again:
	/* Quick check for non control characters */
	if ((c = readline(Rxtimeout)) & 0140)
		return c;
	switch (c)
        {
	case ZDLE:
		break;
	case 023:
	case 0223:
	case 021:
	case 0221:
		goto again;
	default:
		if (Zctlesc && !(c & 0140))
                {
			goto again;
		}
		return c;
	}
again2:
	if ((c = readline(Rxtimeout)) < 0)
		return c;
	if (c == CAN && (c = readline(Rxtimeout)) < 0)
		return c;
	if (c == CAN && (c = readline(Rxtimeout)) < 0)
		return c;
	if (c == CAN && (c = readline(Rxtimeout)) < 0)
		return c;
	switch (c)
        {
	case CAN:
		return GOTCAN;
	case ZCRCE:
	case ZCRCG:
	case ZCRCQ:
	case ZCRCW:
		return (c | GOTOR);
	case ZRUB0:
		return 0177;
	case ZRUB1:
		return 0377;
	case 023:
	case 0223:
	case 021:
	case 0221:
		goto again2;
	default:
		if (Zctlesc && ! (c & 0140))
                {
			goto again2;
		}
		if ((c & 0140) ==  0100)
			return (c ^ 0100);
		break;
	}
 	ZmodemMsg("Mauvaise squence Escape.");
	return ERROR;
}




/*
 * NOXRD7: Read a character from the modem line with timeout.
 * Eat parity, XON and XOFF characters.
 * ----------------------------------------------------------
 */

noxrd7(void)
{
        register short c;

        for (;;)
        {
                if ((c = readline(Rxtimeout)) < 0)
                        return c;
                switch (c &= 0177)
                {
                case XON:
                case XOFF:
                        continue;
                default:
                        if (Zctlesc && !(c & 0140))
                                continue;
                case '\r':
                case '\n':
                case ZDLE:
                        return c;
                }
        }
}



/*
 * STOHDR: Store long integer pos in Txhdr
 * ---------------------------------------
 */
void stohdr(pos)
unsigned long pos;
{
        Txhdr[ZP0] = pos;
        Txhdr[ZP1] = pos >> 8;
        Txhdr[ZP2] = pos >> 16;
        Txhdr[ZP3] = pos >> 24;
}


/*
 * RCLHDR: Recover a long integer from a header
 * --------------------------------------------
 */
long
rclhdr(hdr)
register char *hdr;
{
	register long l;

	l = (hdr[ZP3] & 0377);
	l = (l << 8) | (hdr[ZP2] & 0377);
	l = (l << 8) | (hdr[ZP1] & 0377);
	l = (l << 8) | (hdr[ZP0] & 0377);
	return l;
}


/*--------------------------------------------------------------------------*/



/*
 * Send a string to the modem, processing for \336 (sleep 1 sec)
 * and \335 (break signal)
 * -------------------------------------------------------------
 */
void zmputs(s)
char *s;
{
        register short c;

        while (*s)
        {
                switch (c = *s++)
                {
                case '\336':            /* attendre 1 seconde */
                        delay(1000);
                        continue;

                case '\335':
                        SendBreak(NumPort);
                        continue;
                default:
                        sendline(c);
                }
        }
}



/*
 * READY_NEXT: se prepare a un eventuel transfert suivant (batch)
 * pour Ymodem et Zmodem
 * --------------------------------------------------------------
 */
void ready_next()
{
        if( do_send==TRUE )
                ZmodemMsg("  Prt  envoyer...");
        else
                ZmodemMsg("  Prt  Recevoir...");


        rxbytes = 0;
        txbytes = 0;
        tot_errors = 0;
        bytcnt  = 0;
}


/*
 * Send a character to modem.  Small is beautiful.
 * -----------------------------------------------
 */
void sendline(c)
unsigned char c;                               /* Oblige de ne pas passer  */
{                                              /* par le buffer d'emission */
        while(XFree(NumPort) < OUTPUTSIZE - 5);/* Sinon tout merde,ca part */
        Send(NumPort,c);                       /* d'un coup et les routines*/
}                                              /* se trompent...           */


/*---------------------------------------------------------------------------*/
/*
     Readline pour Bbth, la fonction get_ticks se trouve dans system.c.
     Ca etre tout de meme plus precis que prendre heure, n'est il pas ?
*/
readline(int maxtemps)   /* en 1/10 de secondes */
{
 long tic1,tic2;
 long temps;
 int ch;

 tic1=get_ticks();
 temps = maxtemps * 2;
 while(1)
      {
       if( kbhit())
         {
          ch=getch();
          if(ch == 24)
            {
              longjmp(abrtjmp,1); /* Tire-toi camarade */
            }
         }

       if(PortReady(NumPort) )
          {
            ch=Receive(NumPort);
            return(ch);
          }

       tic2 = get_ticks();
       if( tic2 - tic1 > temps)
         {
           return(TIMEOUT);
         }
      }
}
/*--------------------------------------------------------------------------*/



/*-------------------------------------------------------------------------*/
/*     Affichage de la fenetre de transfert Zmodem- Ymodem batch           */
/*-------------------------------------------------------------------------*/
void ZmodemBox(void)
{
 static char NomFichier[20]="";

   box(22,8,57,21,Cyan_vert);

   mwrite(27,10,"Fichier:"                ,Jaune_vert);
   mwrite(27,11,"Taille :          Octets",Jaune_vert);
   mwrite(27,12,"Reste  :          Octets",Jaune_vert);
   mwrite(27,13,"Vitesse:          Cps"   ,Jaune_vert);
   mwrite(27,14,"Erreurs:"                ,Jaune_vert);

   mwrite(29,17," Dernier Message: ",Inverse);
   mwrite(35,10,NomFichier,Blanc_vert);
}
                 /*-----------------------------*/

void ZmodemMsg(char *texte) /* message affich dans la fenetre */
{
  mwrite(24,19,"                               ",Blanc_vert);/* efface ancien message */
  mwrite(24,19,texte,Blanc_vert);
}
/*-------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/*
    Is_Compressed: Tente d'aprs l'extension d'un nom de fichier de nous
                   dire si il est compact.
                   Ca permet de ne pas demander la compression de zmodem
                   lorsque c'est inutile, on gagne 2 cps sur ma machine :-)
*/
Is_Compressed(char *Fname)
{
  if( strstr(Fname,".arc") !=NULL)  return(TRUE);
  if( strstr(Fname,".zip") !=NULL)  return(TRUE);
  if( strstr(Fname,".pak") !=NULL)  return(TRUE);
  if( strstr(Fname,".zoo") !=NULL)  return(TRUE);
  if( strstr(Fname,".lzh") !=NULL)  return(TRUE);

 return(FALSE);
}
/*--------------------------------------------------------------------------*/
