/* depart reception auto:   *^XB00         */

/*
  ͻ
                                                                         
             DOMAINE     IBM-PC   MS-DOS(3.x+)       
                            PUBLIC                                 
                 Ren   Le protocole de Transfert BBT  
                          Cougnenc est de Jean-Claude Michot.     
                1989   La librairie de Comm.est de    
                                          Jean-Pierre Parisy & R.Gillmann
  Ķ
                                                                          
                    MODULE: ZMRECEP : Rception Z-Modem                   
                    -----------------------------------                   
                                                                          
      Rception de fichiers (Batch) sous Zmodem ou Ymodem Batch.          
                                                                          
      Sources de Zmodem-90 de Chuck Forsberg,Profondment adaptes pour   
      Le PC et BBTH ! (Fonctions en moins et en plus !)                   
                                                                          
      Comprend la gestion des Variable Length Headers et du Run Length    
      Encoding des sous paquets.                                          
                                                                          
      Un Grand merci  Florent Pillet qui a port les sources de la ver-  
      sion 1987 sur Atari, ce qui m'a permis de piger plein de trucs :-)  
                                                                          
   Compilation: modle mmoire LARGE                                      
  Ķ
                                                                          
   Ces sources ne sont plus dans le domaine public,vu le boulot faudrait  
   pas dconner.                                                          
                                                                          
   Ceux qui voudraient un zmodem  eux n'ont qu' aller chercher les      
   sources unix de Forsberg et se taper tout le boulot comme les copains! 
                                                                          
  ͼ
  Ŀ
   BbtH 1.2 
  
*/
/*--------------------------------------------------------*/
#ifndef __TURBOC__   /* Borland Turbo-c 1.5               */
#ifndef MSDOS        /* Microsoft C                       */
#error Mfiance ! je ne connais pas ce compilateur l...
#endif
#endif
/*--------------------------------------------------------*/


/*  RZ.C   Chuck Forsberg      #define VERSION "3.02 6-04-89"            */
/*-----------------------------------------------------------------------*
 *
 *  Unix is a trademark of Western Electric Company
 *
 * A program for Unix to receive files and commands from computers running
 *  Professional-YAM, PowerCom, YAM, IMP, or programs supporting XMODEM.
 *  rz uses Unix buffered input to reduce wasted CPU time.
 *
 *
 *	This version implements numerous enhancements including ZMODEM
 *	Run Length Encoding and variable length headers.  These
 *	features were not funded by the original Telenet development
 *	contract.
 *
 * This software may be freely used for non commercial and
 * educational (didactic only) purposes.  This software may also
 * be freely used to support file transfer operations to or from
 * licensed Omen Technology products.  Any programs which use
 * part or all of this software must be provided in source form
 * with this notice intact except by written permission from Omen
 * Technology Incorporated.
 *
 * Use of this software for commercial or administrative purposes
 * except when exclusively limited to interfacing Omen Technology
 * products requires a per port license payment of $20.00 US per
 * port (less in quantity).  Use of this code by inclusion,
 * decompilation, reverse engineering or any other means
 * constitutes agreement to these conditions and acceptance of
 * liability to license the materials and payment of reasonable
 * legal costs necessary to enforce this license agreement.
 *
 *
 *		Omen Technology Inc		FAX: 503-621-3745
 *		Post Office Box 4681
 *		Portland OR 97208
 *
 *	This code is made available in the hope it will be useful,
 *	BUT WITHOUT ANY WARRANTY OF ANY KIND OR LIABILITY FOR ANY
 *	DAMAGES OF ANY KIND.
 *
 *
 *
 * Iff the program is invoked by rzCOMMAND, output is piped to
 * "COMMAND filename"  (Unix only)
 *
 *  Some systems (Venix, Coherent, Regulus) may not support tty raw mode
 *  read(2) the same way as Unix. ONEREAD must be defined to force one
 *  character reads for these systems. Added 7-01-84 CAF
 *
 *  Alarm signal handling changed to work with 4.2 BSD 7-15-84 CAF
 *
 *  BIX added 6-30-87 to support BIX(TM) upload protocol used by the
 *  Byte Information Exchange.
 *
 *  NFGVMIN Updated 2-18-87 CAF for Xenix systems where c_cc[VMIN]
 *  doesn't work properly (even though it compiles without error!),
 *
 *  SEGMENTS=n added 2-21-88 as a model for CP/M programs
 *    for CP/M-80 systems that cannot overlap modem and disk I/O.
 *
 *  VMS flavor hacks begin with rz version 2.00
 *
 *  -DMD may be added to compiler command line to compile in
 *    Directory-creating routines from Public Domain TAR by John Gilmore
 *
 *  HOWMANY may be tuned for best performance
 *
 *  USG UNIX (3.0) ioctl conventions courtesy  Jeff Martin
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <setjmp.h>
#include <time.h>
#include <dos.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include <io.h>
#include "bbth.h"
#include "zmodem.h"
#include "couleurs.h"
#include "config.h"


byte ZZ_START[5] ={42,24,66,48,48}; /* Chaine de depart Zmodem auto   */
byte ZmodemScanTmp[10]="\0";        /* Pour scanner chaine de depart  */
byte ZmodemScanIdx = 0;             /* position la dedans             */
byte Start_lenZ    = 5;             /* Taille de cette chaine         */


int Readnum =1; /* Number to ask for... I don't remember... :-) */

/*--------------------------------------------------------------------------*/
/*
 * DORZ: fonction principale, appelle wcreceive apres avoir mis
 * a jour les parametres indispensables
 * ------------------------------------------------------------
 */
void dorz(type)
short type;                             /* 0=Zmodem, 1=Ymodem, 2=Xmodem */
{
        short exitcode;

        do_send = FALSE;                /* indicateur pour mes routines */

        switch(type)
        {
                case 0:                  /* ----- ZMODEM ---------*/
                        DoXmodem = FALSE;
                        Nozmodem = FALSE;
                        Batch    = TRUE;
                        Crcflg   = TRUE;
                        Zrwindow = 1400;  /* fenetre de reception de paquets */
                        Rxbinary = TRUE;  /* Transfert Binaire only nous ici.*/
                        Rxascii  = FALSE;
                        if(Config.ZmodemReprise)
                             Lzmanag  = ZCRESUM;   /* reprise transfert ?*/
                        else Lzmanag  = 0;

                        Txfcs32 = TRUE ;     /* On veut FCS 32 bits */

                        ZmodemBox();
                        mwrite(28,8," RECEPTION Z-MODEM ",Inverse);
                        break;

                case 1:                  /*------ YMODEM batch -----*/
                        DoXmodem = FALSE;
                        Nozmodem = TRUE;
                        Batch    = TRUE;
                        Crcflg   = TRUE;
                        Rxbinary = TRUE;
                        Rxascii  = FALSE;
                        Lzmanag  = 0;
                        Recover  = 0L; /* on n'a jamais rien recu deja:-) */
                        ZmodemBox();
                        mwrite(30,8," RECEPTION Y-MODEM Batch ",Inverse);
                        break;

#ifdef __XMODEM__
                case 2:                  /* XMODEM */

                        if(Crcflg) printf("CRC-16\n");
                         else printf("CHecksum");

                        strcpy(XmodFile, path_name);
                        DoXmodem = TRUE;
                        Batch = FALSE;
                        Nozmodem = FALSE;       /* eh oui... */
                        Lzmanag = ZMPROT;       /* pour les tests... */
                        break;
#endif
        }


        /* mise a jour des diverses variables */

        exitcode = 0;                   /* pas (encore) d'erreur            */
        Rxtimeout = 100;                /* 10 secondes                      */
        Wcsmask = 0xff;                 /* masque de reception des car.     */
        zmanag = 0;                     /* sera mis a jour plus loin        */
        Zmodem = 0;                     /* sera intialise dans ZM.C         */
        Zctlesc = 0;
        Crcflg = TRUE;                  /* On utilise pas de checksum...    */
        tryzhdrtype = ZRINIT;           /* Header type to send corresponding to Last rx close */
        tot_errors = 0;                 /* compte le nombre total d'erreurs */
        rxbytes = 0;
        errors = 0;
        Lleft = 0;
        fout = NULL;
        Blklen = SECSIZ;
        Znulls = 0;                    /* number of 0 to send at beginning of ZRDATA frame */
        Zrwindow = 1400;
        Pathname[0] = '\0';

        /* abrtjmp sert pour arreter le transfert par CNTRL-X */
        if( (exitcode = setjmp(abrtjmp))!=0 )
        {
                ZmodemMsg("Arrt par l'utilisateur.");
                canit();                /* interruption transfert */
                /*RFlush(NumPort); */       /* On se vire le caca     */
                /*XFlush(NumPort); */
                goto enderr;
        }

        if( wcreceive()==ERROR )
        {
                exitcode = 0200;
                canit();
        }


        if (exitcode && !Zmodem)        /* bellow again with all thy might. */
                canit();


enderr: if( fout )
                fclose(fout);

        switch( type )      /* Message de fin dans la boiboite */
        {
                case 0:   /* Zmodem */
                  ZmodemMsg("Transfert Z-Modem Termin .");
                break;

                case 1:   /* Ymodem batch */
                   ZmodemMsg("Transfert Y-Modem Batch Termin .");
                break;

                case 2:   /* Xmodem */
                         puts("Y'A Pus X modem !\n");
                break;
        }

        beep(3);
        return;
}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*
 * WCRECEIVE: fonction principale de reception
 * -------------------------------------------
 */
 wcreceive()
{
        register short c;

        if( Batch || DoXmodem==FALSE )          /* Zmodem ou Ymodem */
        {
                Crcflg = (Wcsmask==0377);
                ZmodemMsg("   Prt  Recevoir...");
                if( (c=tryz())!=0 )             /* reception Zmodem */
                {
                        if( c==ZCOMPL )
                                return OK;
                        if( c==ERROR )
                                goto fubar;
                        c = rzfiles();          /* on a recu un bon header */
                        if( c )
                                goto fubar;
                }
                else for (;;)                   /* reception Ymodem */
                {
                        if( wcrxpn(secbuf)==ERROR )
                                goto fubar;
                        if( secbuf[0]==0 )
                                return OK;
                        if( procheader(secbuf)==ERROR )
                                goto fubar;
                        if( wcrx()==ERROR )
                                goto fubar;
                }
        }
        else                                    /* reception Xmodem */
        {
#ifdef __XMODEM__
                Bytesleft = DEFBYTL;
                Filemode = 0;
                Modtime = 0;

                procheader("");
                strcpy(Pathname, XmodFile);
                xmr_err();                   /* affiche le nombre d'erreurs */
                xmr_oct();                   /* et le nombre d'octets recus */
                ZmodemMsg("Prt  Recevoir...");
                if( (fout=fopen(Pathname,"wb"))==NULL )
                        return ERROR;
                if( wcrx()==ERROR )
                        goto fubar;
#endif
        }
        return OK;

fubar:
        canit();
        if( fout )
                fclose(fout);
        if( Pathname[0] && Nozmodem)  /* On le garde en zmodem le bout...*/
        {
                ZmodemMsg("Suppression fichier Incomplet");
                unlink(Pathname);
        }
        return ERROR;
}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*
 * WCRXPN: Fetch a pathname from the other end as a C ctyle ASCIZ string.
 * Length is indeterminate as long as less than Blklen
 * A null string represents no more files (YMODEM)
 * ----------------------------------------------------------------------
 */
wcrxpn(rpn)
char *rpn;      /* receive a pathname */
{
        register c;

        XFlush(NumPort);
        RFlush(NumPort);

et_tu:
        Firstsec = TRUE;
        Eofseen = FALSE;
        sendline( Crcflg ? WANTCRC : NAK );
        Lleft = 0;                  /* Do read next time ... */
        while( (c=wcgetsec(rpn, 100))!=0 )
        {
                if( c==WCEOT )
                {
                                /* "Pathname fetch returned EOT" */
                        ZmodemMsg("<EOT> sur un Entte .");
                        sendline(ACK);
                        Lleft = 0;      /* Do read next time ... */
                        readline(1);
                        goto et_tu;
                }
                return ERROR;
        }
        sendline(ACK);
        return OK;
}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*
 * WCRX: Adapted from CMODEM13.C, written by
 * Jack M. Wierda and Roderick W. Hart
 *
 * Reception d'un paquet type X modem, ne passe pas en checksum ici en cas
 * de time out car on ne traite que du Ymodem batch.
 * ---------------------------------------------------------------------
 */
wcrx()
{
        register int sectnum, sectcurr;
        register char sendchar;
        int cblklen;        /* bytes to dump this block */

        Firstsec = TRUE;
        sectnum = 0;
        Eofseen = FALSE;
        sendchar = Crcflg ? WANTCRC : NAK;

        for (;;)
        {
                sendline(sendchar);             /* send it now, we're ready! */
                Lleft = 0;                      /* Do read next time ... */
                sectcurr = wcgetsec(secbuf, (sectnum&0177) ? 50 : 130);
                if( sectcurr==((sectnum+1) & Wcsmask) )
                {
                        sectnum++;
                        cblklen = Bytesleft>Blklen ? Blklen : Bytesleft;
                        rxbytes += cblklen;
                        if( putsec(secbuf, cblklen)==ERROR )
                                return ERROR;
                        if( (Bytesleft-=cblklen)<0 )
                                Bytesleft = 0;
                        sendchar = ACK;
                        if( DoXmodem )          /* Xmodem */
                        {
                           /* printf("Dugenou affiche :%d\n",sectnum); */
                           /*xmr_oct(); */      /* nbre d'octets recus */
                           /* if( sectnum==1 )  */      /* 1er paquet  */
                           /* ZmodemMsg("Rception en cours...");      */
                        }
                }
                else if( sectcurr==(sectnum&Wcsmask) )
                {
                        ZmodemMsg("Bloc dj reu.");
                        sendchar = ACK;
                }
                else if( sectcurr==WCEOT )
                {
                        if( closeit() )
                                return ERROR;
                        sendline(ACK);
                        Lleft = 0;          /* Do read next time ... */
                        return OK;
                }
                else if( sectcurr==ERROR )
                        return ERROR;
                else
                {
                        ZmodemMsg("Erreur de synchronisation.");
                        return ERROR;
                }
        }
}
/*--------------------------------------------------------------------------*/




/*--------------------------------------------------------------------------*/
/*
 * WCGETSEC fetches a Ward Christensen type sector.
 * Returns sector number encountered or ERROR if valid sector not received,
 * or CAN CAN received
 * or WCEOT if eot sector
 * time is timeout for first char, set to 4 seconds thereafter
 ***************** NO ACK IS SENT IF SECTOR IS RECEIVED OK **************
 *    (Caller must do that when he is good and ready to get next sector)
 * ------------------------------------------------------------------------
 */
wcgetsec(rxbuf, maxtime)
char *rxbuf;
int maxtime;
{
        register short checksum, wcj, firstch;
        register unsigned short oldcrc;
        register char *p;
        int sectcurr;

        for(Lastrx = errors = 0; errors<RETRYMAX; errors++)
        {
                if( errors )
                {
                 tot_errors++;
                         /*  if( DoXmodem ) xmr_err(); */
                        /*   else                      */
                 zmr_err();
                }

                if( (firstch=readline(maxtime))==STX )
                {
                        Blklen = KSIZE;
                        goto get2;
                }

                if( firstch==SOH )
                {
                        Blklen = SECSIZ;
get2:
                        sectcurr = readline(1);
                        if( (sectcurr + (oldcrc=readline(1))) == Wcsmask )
                        {
                                oldcrc = 0;
                                checksum = 0;
                                for(p=rxbuf, wcj=Blklen; --wcj>=0; )
                                {
                                        if( (firstch=readline(1)) < 0 )
                                                goto bilge;
                                        oldcrc = updcrc(firstch, oldcrc);
                                        checksum += (*p++ = firstch);
                                }
                                if( (firstch=readline(1)) < 0 )
                                        goto bilge;
                                if( Crcflg )
                                {
                                        oldcrc = updcrc(firstch, oldcrc);
                                        if( (firstch=readline(1))<0 )
                                                goto bilge;
                                        oldcrc = updcrc(firstch, oldcrc);
                                        if( oldcrc & 0xFFFF )
                                           ZmodemMsg("Mauvais CRC");
                                        else
                                        {
                                                Firstsec = FALSE;
                                                return sectcurr;
                                        }
                                }
                                else if( ((checksum-firstch)&Wcsmask)==0 )
                                {
                                        Firstsec = FALSE;
                                        return sectcurr;
                                }
                                else
                                {
                                        ZmodemMsg("Mauvais CheckSum");
                                        ++tot_errors;
                                }
                        }
                        else
                        {
                                 /* "Sector number garbled" */
                                ZmodemMsg("Numro de bloc perdu.");
                                ++tot_errors;
                        }
                }

                /* make sure eot really is eot and not just mixmash */
                else if( firstch==EOT && Lleft==0 )
                        return WCEOT;

                else if( firstch==CAN )
                {
                        if( Lastrx==CAN )
                        {
                                 /* "Sender CANcelled" */
                                ZmodemMsg("Interrompu par le serveur");
                                ++tot_errors;
                                return ERROR;
                        }
                        else
                        {
                                Lastrx = CAN;
                                continue;
                        }
                }
                else if( firstch==TIMEOUT )
                {
                        if( Firstsec )
                                goto humbug;
bilge:
                                /* "TIMEOUT" */
                        ZmodemMsg(" Time out");
                        ++tot_errors;
                }
                else
                {
                                /* "Got %02x sector header" */
                        ZmodemMsg("Mauvais Entte de Bloc");
                        ++tot_errors;
                }

humbug:
                Lastrx = 0;
                while( readline(1)!=TIMEOUT );
                if( Firstsec )
                {
                        sendline( Crcflg ? WANTCRC : NAK );
                        Lleft = 0;      /* Do read next time ... */
                }
                else
                {
                        maxtime = 40;
                        sendline(NAK);
                        Lleft = 0;      /* Do read next time ... */
                }
        }
        /* try to stop the bubble machine. */
        canit();
        return ERROR;
}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*
 * PROCHEADER: Process incoming file information header
 * [fp]: convert to valid ST/IBM file/path name
 * ----------------------------------------------------
 */
procheader(name)
char *name;
{
        register char *openmode, *p, *q;
        register short dot;
        char BufTxt[80]; /* pour affichage nombres*/

        /* convert to ST/IBM style path names */
        p = q = name;
        while( (p=strchr(p, '/'))!=NULL )
        {
                *p = '\\';
                q = p;
        }
        p = q;

        /* pick out the last extenson in the filename in each part of path */
        while(p > name)
        {
                dot = 0;
                --p;
                while((p > name) && (*p != '\\'))
                {
                        if(*p == '.')
                                if( !dot )
                                        dot = 1;
                                else
                                        /* replace all but the last dot with '_' */
                                        *p = '_';
                        p--;
                }
        }



        /* ATARI ST NOTE:
         *      We will not accept rooted paths ie. paths that begin in '\' or '.\'
         *      If the incoming filename is rooted, we skip the beginning
         *      '\'   '.\'  or  '..\'
         */
        if( (name[0] == '\\') || (name[0] == '.')  )
        {
                /* skip over the leading stuff */
                if(name[0] == '\\')
                        name = &name[1];
                else
                {
                        if(name[1] == '.')
                                name = &name[3];  /* Skip the "..\" */
                        else
                                name = &name[2];  /* Skip the ".\"  */
                }
        }

        /* set default parameters and overrides */
        Thisbinary = (!Rxascii) || Rxbinary;
        if( Lzmanag )
                zmanag = Lzmanag;

        /* Process ZMODEM remote file management requests */
        if (!Rxbinary && zconv == ZCNL)         /* Remote ASCII override */
                Thisbinary = 0;
        if ( zconv == ZCBIN )                   /* Remote Binary override */
                Thisbinary = TRUE;

        /* cree le mode d'acces au fichier */
        if( Thisbinary )
        {
                if (zmanag == ZMAPND)
                        openmode = "a+b";
                else
                        openmode = "wb";
        }
        else if (zmanag == ZMAPND)              /* Append to existing file */
                openmode = "a+";
        else
                openmode = "w";



        Bytesleft = DEFBYTL;
        Filemode = 0;
        Modtime = 0;

        if( name[0] )         /* if file name <> "" */
        {
                p = name + 1 + strlen(name);
                if( *p )                /* file coming from Unix or DOS system */
                        sscanf(p, "%ld%lo%o", &Bytesleft, &Modtime, &Filemode);
                else                    /* File coming from CP/M system */
                {
                        for(p=name; *p; ++p)    /* change / to _ */
                                if ( *p == '/')
                                        *p = '_';
                        if( *--p=='.' )  /* zap trailing period */
                                *p = 0;
                }
        }

        /* RC:                                                         */
        /* Ici je considere que fullname = 0 pour nous toujours donc   */
        /* ON dirige le fichier dans le repertoire download de BBTH    */

        strcpy(Pathname,Config.DownDir);
        strcat(Pathname, name);

        /* ZMPROT check for existing file */
        if( zmanag==ZMPROT && name[0] )
        {
                if( (fout=fopen(Pathname, "rb"))!=NULL )
                {
                        fclose(fout);

                        ZmodemMsg("ZMPROT: Le fichier existe dj.");
                                return ERROR;
                }
        }

       /*------  Rajout du crash Recovery qui n'y etait pas.   [R.C] -----*/
       mwrite(27,16,  "                             ",Cyan_vert);
               /* Efface eventuel message de reprise */
      if( Lzmanag==ZCRESUM && name[0] )
        {
                if( (fout=fopen(Pathname, "rb"))!=NULL )
                {
                 fseek(fout,0L,SEEK_END);
                 rxbytes = ftell(fout);
                 Recover = rxbytes;
                 sprintf(BufTxt,"Reprise  %ld Octets",rxbytes);
                 mwrite(27,16,BufTxt,Cyan_vert);
                 fclose(fout);
                 openmode = "a+b" ; /* On ecrit derriere */
                }
        }

      if(Lzmanag != ZCRESUM)  /* Pas de crash recovery */
      {
        if(access(Pathname,0)==0) /* le fichier existe */
          {
           RenameFile(Pathname);
           ZmodemMsg("Ancien fichier renomm.");
           delay(1000);
          }
        openmode = "wb";
        Recover  = 0L  ;
        rxbytes  = 0L  ;
      }
     /*------------------------------------------------------[R.C] -----*/

        if( (fout=fopen(Pathname, openmode))==NULL )
                return ERROR;
        setvbuf(fout,NULL,_IOFBF,10240);        /*Tente de bufferiser 10ko  */
        total_oct = Bytesleft;                  /* variable pour calculs    */
        time(&Time_Start);                      /* Hop je prends l'heure    */
        mwrite(36,10,"                    ",Blanc_vert); /* efface nom      */
        mwrite(36,11,"        ",Blanc_vert);             /* efface taille   */
        mwrite(36,10,name,Blanc_vert);         /* Affiche le nom sans path  */
        ltoa(Bytesleft,BufTxt,10);             /* et la taille */
        mwrite(36,11,BufTxt,Blanc_vert);
        if( NotPlace((long) (Bytesleft - Recover)) )
          {
            ZmodemMsg("  PAS DE PLACE DISQUE !!!");
            beep(2);
            return(ERROR);
          }
        return OK;
}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*
 * PUTSEC writes the n characters of buf to receive file fout.
 * If not in binary mode, carriage returns, and all characters
 * starting with CPMEOF are discarded.
 * -----------------------------------------------------------
 */
putsec(buf, n)
char *buf;
register short n;
{
        register unsigned char *p;

        if (Thisbinary)
        {
                for (p=buf; --n>=0; )
                        putc( *p++, fout);
        }
        else
        {
                if( Eofseen )
                        return OK;
                for (p=buf; --n>=0;)
                {
                        if ( *p == '\r')
                                continue;
                        if (*p == CPMEOF)
                        {
                                Eofseen=TRUE;
                                return OK;
                        }
                        fputc(*p++ ,fout);
                }
        }

        if( ferror(fout) )
        {
                ZmodemMsg("Erreur d'criture disque");
                return ERROR;
        }

        /* mise a jour du nombre de blocs & octets recus ecrits sur disk */
        /* if( !DoXmodem ) */
                zmr_err();
        return OK;
}
/*--------------------------------------------------------------------------*/




/*--------------------------------------------------------------------------*/
/*
 * IsAnyLower returns TRUE if string s has lower case letters.
 * -----------------------------------------------------------
 */
IsAnyLower(s)
register char *s;
{
        for ( ; *s; ++s)
                if (islower(*s))
                        return TRUE;
        return FALSE;
}
/*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/*
 * CANIT: send cancel string to get the other end to shut up
 * ---------------------------------------------------------
 */
void canit(void)
{
        static char
           canistr[] = { 24,24,24,24,24,24,24,24,24,24,8,8,8,8,8,8,8,8,8,8,0 };
        register char *p = canistr;

        while( *p )
                sendline( *p++ );
        Lleft = 0;                    /* Do read next time ... */
}
/*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/*
 * TRYZ: Initialize for Zmodem receive attempt, try to activate Zmodem sender
 * Handles      ZSINIT frame
 * Return       ZFILE if Zmodem filename received, -1 on error,
 *              ZCOMPL if transaction finished,  else 0
 * --------------------------------------------------------------------------
 */
tryz()
{
	register c, n;
	register cmdzack1flg;

	if (Nozmodem)		/* Check for "rb" program name */
		return 0;


	for (n=Zmodem?15:5; --n>=0; ) {
		/* Set buffer length (0) and capability flags */
		stohdr(0L);
#ifdef CANBREAK
		Txhdr[ZF0] = CANFC32|CANFDX|CANOVIO|CANBRK;
#else
		Txhdr[ZF0] = CANFC32|CANFDX|CANOVIO;
#endif
		if (Zctlesc)
			Txhdr[ZF0] |= TESCCTL;
		Txhdr[ZF0] |= CANRLE;
		Txhdr[ZF1] = CANVHDR;
		/* tryzhdrtype may == ZRINIT */
		zshhdr(4,tryzhdrtype, Txhdr);
		if (tryzhdrtype == ZSKIP)	/* Don't skip too far */
			tryzhdrtype = ZRINIT;	/* CAF 8-21-87 */
again:
		switch (zgethdr(Rxhdr, 0))
                {
		case ZRQINIT:
			if (Rxhdr[ZF3] & 0x80)
				Usevhdrs = 1;	/* we can var header */
			continue;
		case ZEOF:
			continue;
		case TIMEOUT:
			continue;
		case ZFILE:
			zconv = Rxhdr[ZF0];
			zmanag = Rxhdr[ZF1];
			ztrans = Rxhdr[ZF2];
			if (Rxhdr[ZF3] & ZCANVHDR)
				Usevhdrs = TRUE;
			tryzhdrtype = ZRINIT;
			c = zrdata(secbuf, 1024);
			if (c == GOTCRCW)
				return ZFILE;
			zshhdr(4,ZNAK, Txhdr);
			goto again;
		case ZSINIT:
			Zctlesc = TESCCTL & Rxhdr[ZF0];
			if (zrdata(Attn, ZATTNLEN) == GOTCRCW)
                        {
				stohdr(1L);
				zshhdr(4,ZACK, Txhdr);
				goto again;
			}
			zshhdr(4,ZNAK, Txhdr);
			goto again;
		case ZFREECNT:
			/* stohdr(getfree());*/
                        stohdr(~0L); /* Razjouter espace libre disque plutot*/
			zshhdr(4,ZACK, Txhdr);
			goto again;
		case ZCOMMAND:
			cmdzack1flg = Rxhdr[ZF0];
			if (zrdata(secbuf, 1024) == GOTCRCW)
                         {
				if (cmdzack1flg & ZCACK1)
					stohdr(0L);
				else
					stohdr((long)sys2(secbuf));
				/*purgeline();*//* dump impatient questions */
				do {
					zshhdr(4,ZCOMPL, Txhdr);
				}
				while (++errors<20 && zgethdr(Rxhdr,1) != ZFIN);
				ackbibi();

				/* if (cmdzack1flg & ZCACK1) */
				/*	exec2(secbuf);       */
                                /* Faut pas deconner !       */
				return ZCOMPL;
			}
			zshhdr(4,ZNAK, Txhdr); goto again;
		case ZCOMPL:
			goto again;
		default:
			continue;
		case ZFIN:
			ackbibi(); return ZCOMPL;
		case ZCAN:
			return ERROR;
		}
	}
	return 0;
}
/*--------------------------------------------------------------------------*/




/*--------------------------------------------------------------------------*/
/*
 * RZFILES: Receive 1 or more files with ZMODEM protocol
 * -----------------------------------------------------
 */
rzfiles()
{
        register c;

        for (;;)
        {
                switch( c=rzfile() )
                {
                case ZEOF:
                case ZSKIP:
                        switch( tryz() )
                        {
                        case ZCOMPL:
                                return OK;
                        default:
                                return ERROR;
                        case ZFILE:
                                break;
                        }
                        continue;
                default:
                        return c;
                case ERROR:
                        return ERROR;
                }
        }
}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*
 * RZFILE: Receive a file with ZMODEM protocol
 * Assumes file name frame is in secbuf
 * -------------------------------------------
 */
rzfile()
{
	register c, n;
        char BufTxt[50];  /* Pour sprintf */

        Eofseen = FALSE;
        rxbytes = 0L;

        Recover = 0L;
        if( procheader(secbuf)==ERROR )
                return (tryzhdrtype = ZSKIP);

        time(&Time_Start);              /* Prend l'heure du debut transfert  */
        zmr_err();                      /* Affiche les statistiques          */

        n = 20;                         /* nombre d'erreurs maxi. pour 1 bloc */
        total_oct = Bytesleft;
        ZmodemMsg("Rception Z-Modem en cours.");


	for (;;) {
		stohdr(rxbytes);
		zshhdr(4,ZRPOS, Txhdr);
nxthdr:
		switch (c = zgethdr(Rxhdr, 0))
                {
		default:
                        ZmodemMsg("Erreur...");
			return ERROR;
		case ZNAK:
		case TIMEOUT:
			if ( --n < 0)
                        {
                                ZmodemMsg("  Time-out");
				return ERROR;
			}
		case ZFILE:
			zrdata(secbuf, 1024);
			continue;
		case ZEOF:
			if (rclhdr(Rxhdr) != rxbytes)
                        {
				/*
				 * Ignore eof if it's at wrong place - force
				 *  a timeout because the eof might have gone
				 *  out before we sent our zrpos.
				 */
				errors = 0;  goto nxthdr;
			}
			if (closeit())
                        {
				tryzhdrtype = ZFERR;
				return ERROR;
			}
			return c;
		case ERROR:	/* Too much garbage in header search error */
			if ( --n < 0)
                        {
                                ZmodemMsg("Il y a du garbage dans l'air...");
				return ERROR;
			}
			zmputs(Attn);
			continue;
		case ZSKIP:
			closeit();
                        ZmodemMsg("Le serveur a Saut le Fichier.");
			return c;
		case ZDATA:
			if (rclhdr(Rxhdr) != rxbytes)
                        {
				if ( --n < 0)
                                {
					return ERROR;
				}
				zmputs(Attn);  continue;
			}
moredata:                        /* --- Affiche le type de transmission --*/

#ifdef BBTH
                        switch(Crc32r)
                        {
                           case 0:
                            sprintf(BufTxt,"CRC-16");
                           break;
                           case 1:
                            sprintf(BufTxt,"CRC-32");
                           break;
                           case 2:
                            sprintf(BufTxt,"CRC-32+RLE");
                           break;
                        }
                        mwrite(40,21,BufTxt,Cyan_vert);
                 if(Usevhdrs)
                       mwrite(35,21,"VHDR+",Cyan_vert);
#else
                        switch(Crc32r)
                        {
                           case 0:
                            sprintf(BufTxt,"CRC-16");
                           break;
                           case 1:
                            sprintf(BufTxt,"CRC-32");
                           break;
                           case 2:
                            sprintf(BufTxt,"CRC-32+RLE");
                           break;
                        }
                        mwrite(40,21,BufTxt,Cyan_vert);
                 if(Usevhdrs)
                       mwrite(35,21,"VHDR+",Cyan_vert);
#endif
                        zmr_err(); /* Affiche le compte ou on en est */
			switch (c = zrdata(secbuf, 1024))
			{
			case ZCAN:
				return ERROR;
			case ERROR:	/* CRC error */
                                tot_errors++;
                                zmr_err();
				if ( --n < 0)
					return ERROR;
				zmputs(Attn);
				continue;
			case TIMEOUT:
                                tot_errors++;
                                zmr_err();
				if ( --n < 0)
					return ERROR;
				continue;
			case GOTCRCW:
				n = 20;
				putsec(secbuf, Rxcount);
				rxbytes += Rxcount;
				stohdr(rxbytes);
				zshhdr(4,ZACK, Txhdr);
				sendline(XON);
				goto nxthdr;
			case GOTCRCQ:
				n = 20;
				putsec(secbuf, Rxcount);
				rxbytes += Rxcount;
				stohdr(rxbytes);
				zshhdr(4,ZACK, Txhdr);
				goto moredata;
			case GOTCRCG:
				n = 20;
				putsec(secbuf, Rxcount);
				rxbytes += Rxcount;
				goto moredata;
			case GOTCRCE:
				n = 20;
				putsec(secbuf, Rxcount);
				rxbytes += Rxcount;
				goto nxthdr;
			}
		}
	}
}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*
 * Close the receive dataset, return OK or ERROR
 * ---------------------------------------------
 */
closeit()
{
 int fichier;

        ZmodemMsg("Rception Termine.");


        if( fclose(fout)==ERROR )
        {
                ZmodemMsg("Erreur fermeture fichier");
                return ERROR;
        }

      if( Modtime != 0L)    /* Mise a la date. Ma fonction attend un handle */
        {                   /* et fileno met la taille a zero :-)           */
                fichier = open(Pathname,O_RDWR,S_IREAD|S_IWRITE);
                SetUnixTime(fichier, Modtime);
                close(fichier);
        }



        /* gestion du 'read only' (a revoir pour le PC ?) */
        /* Non! Tu est fou Florent :-)                    */
        /* On va se faire accuser de coller un virus !    */
/*
        if( Filemode )
        {
        }
        if( !DoXmodem )
*/
        ready_next();   /* pret pour un transfert suivant */
        return OK;
}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*
 * Ack a ZFIN packet, let byegones be byegones
 * -------------------------------------------
 */

void ackbibi(void)
{
	register n;

	Readnum = 1;
	stohdr(0L);
	for (n=3; --n>=0; )
        {
		/* purgeline(); */
                XFlush(NumPort);
                RFlush(NumPort);
		zshhdr(4,ZFIN, Txhdr);
		switch (readline(100))
                {
		case 'O':
			readline(1);	/* Discard 2nd 'O' */
			/* vfile("ackbibi complete");*/
			return;
		case RCDO:
			return;
		case TIMEOUT:
		default:
			break;
		}
	}
}
/*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/*
 * SYS2: Strip leading ! if present, do shell escape.
 * --------------------------------------------------
 */
sys2(s)
register char *s;
{
        if (*s == '!')
                ++s;
        if( system( NULL ) )
                return system(s);
        return(0);
}
/*--------------------------------------------------------------------------*/




/*--------------------------------------------------------------------------*/
/*
 * XMR_ERR: mise a jour du nombre d'erreurs en reception Xmodem
 * ------------------------------------------------------------
 */
void xmr_err()
{
}
/*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*/
/*
 * XMR_OCT: affiche le nombre d'octets recus xmodem
 * ------------------------------------------------
 */
void xmr_oct()
{
}
/*--------------------------------------------------------------------------*/




/*--------------------------------------------------------------------------*/
/*
 * ZMR_ERR: affiche le nombre d'erreurs
 * (avec le nombre d'octets recus, et tout le tremblement)
 * -------------------------------------------------------------------------
 */
void zmr_err()
{
 char BufTxt[40];
long Heure,
     vitesse,
     bytes,
     reste;


 time(&Heure);
 Heure = Heure - Time_Start;

 if(Nozmodem)    bytes = txbytes;
 else            bytes = bytcnt;

 if(do_send)     reste = total_oct - bytes;
 else            reste = total_oct - rxbytes;

 if(do_send)
   {
    if (bytes < Recover)
       {
        Recover = 0L;
        mwrite(27,16,"                             ",Cyan_vert);
        ZmodemMsg("Le Rcepteur demande du dbut.");
       }
   }

 if( Heure !=0L)                         /* Divide error tu connais ? :-) */
   {
    if(Heure < 3L)                       /* En cas de fichier trop court, */
    {                                    /* J'affiche '!!!' plutot que la */
      sprintf(BufTxt,"!!! ");            /* valeur 9999 de dsz !          */
    }
    else /* Cas normal */
    {
     if(do_send)
       vitesse = (bytes - Recover)/ Heure;
     else
       vitesse =( rxbytes - Recover)/ Heure;
     sprintf(BufTxt,"%d  ",vitesse);
    }

     if (reste >= 0L)
     mwrite(36,13,BufTxt,Blanc_vert);    /* Affiche la vitesse            */
   }

 itoa(tot_errors,BufTxt,10);             /* Affiche le nombre d'erreurs   */
 mwrite(36,14,BufTxt,Blanc_vert);

 sprintf(BufTxt,"%ld",reste);

 mwrite(36,12,"       ",Blanc_vert);      /* efface */
 if(reste >=0L)
 mwrite(36,12,BufTxt,Blanc_vert);        /* Et ce qu'il reste  recevoir  */

}
/*--------------------------------------------------------------------------*/




/*-------------------------------------------------------------------------*/
/*     Recherche  chaque caractere entr sur le port d'un dpart Zmodem   */
/*-------------------------------------------------------------------------*/
/*
   Ce qui fera un transfert automatique command par le serveur.
*/

void ZmodemScan(byte ch)
   {
   if( (ch == 42)&&(ZmodemScanIdx <2) ) /* Pour tenir compte du fait qu'il  */
              {                      /* Peut y avoir plusieurs '*' avant */
               ZmodemScanIdx=1;
               return;
              }
   if(ch==*(ZZ_START+ZmodemScanIdx))ZmodemScanIdx++;
   else
      {
        ZmodemScanIdx=0;
        return;
      }
   if(ZmodemScanIdx==Start_lenZ)
      {
       ZmodemScanIdx=0;          /* Pour le prochain coup */
        sauvecran();
        curseur(0);
        dorz(0);              /* Hop,au travail Zmodem !  */
        curseur(1);
      rendecran();
      }
   }
/*-------------------------------------------------------------------------*/

/* End of rz.c */

