 /*
  ͻ
                                                                         
             DOMAINE     IBM-PC   MS-DOS(3.x+)       
                            PUBLIC                                 
                 Ren   Le protocole de Transfert BBT  
                          Cougnenc est de Jean-Claude Michot.     
                1989   La librairie de Comm.est de    
                                          Jean-Pierre Parisy & R.Gillmann
  Ķ
                                                                          
                    MODULE: BACKVIEW.C                                    
                    ------------------                                    
                                                                          
       Gestion de la fonction Scroll-Back dans la session.                
                                                                          
   Compilation: modle mmoire LARGE                                      
  Ķ
   Vous pouvez distribuer  ce  programme et  ses sources  qui bon vous   
   semble,  condition de ne sparer aucun des modules qui le composent   
   et de le faire GRATUITEMENT.                                           
                                                                          
   Si vous demandez plus que le prix d'une disquette vierge pour fournir  
   ce programme  quelqu'un,vous tes un vil exploiteur  qui se rit des   
   nombreuses heures de travail BENEVOLE de plusieurs personnes,et mme   
   le gigantesque repas que vous devrez offrir   tous  nos  copains     
   La Tour D'Argent ne saura vous faire pardonner de votre bassesse.      
  ͼ
  Ŀ
   BbtH 1.1 
  
*/

/*--------------------------------------------------------*/
#ifndef __TURBOC__   /* Borland Turbo-c 1.5               */
#ifndef MSDOS        /* Microsoft C                       */
#error Mfiance ! je ne connais pas ce compilateur l...
#endif
#endif
/*--------------------------------------------------------*/


#include "bbth.h"
#include "touches.h"
#include "couleurs.h"
#include "config.h"
#include "clavecra.h"
#include "souris.h"
#include "backview.h"
#include <string.h>

#include <stdio.h>
#ifdef __TURBOC__
#include <alloc.h>
#else
#include <malloc.h>
#include <sys/types.h>
#define farmalloc _fmalloc
#define farfree   _ffree
#endif

#include <sys/stat.h>
#include  <fcntl.h >

byte far *BackBuff;
unsigned  StartData,
          EndData,
          BackCount;

unsigned  SizeBackBuff=20000; /* taille du buffer backlog */


struct LigneType
           {
            byte Texte[82];
            struct LigneType far *Avant;
            struct LigneType far *Apres;
           };

struct LigneType far *LigneDeb,*LigneFin,*LignePred;

/*
         Bon, en gros...
         Les modules terminal_machin remplissent un tampon circulaire
         avec  peu prs ce qui arrive a l'cran.

         Pour visualiser facilement ce tampon,je cre une liste chaine
         de lignes,ces lignes tant extraites du tampon en considrant
         comme fin de ligne: un CR/LF, un CR tout seul ou un LF tout
         seul. Une ligne plus longue que l'cran  est aussi coupe en
         deux.

         Ca bouffe peut tre de la mmoire mais pour faire le viewer
         c'etait bien plus simple.

         Par contre pour la sauvegarde sur disque, c'est le tampon
         lui mme qui est utilis.
         Le fichier est ouvert en mode append; ca peut rendre service.

         La taille max du tampon est un int, meme si c'est des unsigneds
         qui sont utiliss, c'est plus simple a cause du write et de
         toutes faons  hein...
*/



/*--------------------------------------------------------------------------*/
/*          Initialisation du buffer de backlog.                            */

int AllocBackBuff(void)
{
   if(SizeBackBuff >32700) SizeBackBuff=32700;
                                                     /* Tout de meme, on ne */
                                                     /* va pas se crr des */
                                                     /* ennuis non...?      */
   BackBuff=(byte far *)farmalloc(SizeBackBuff +1 );
     if(BackBuff==NULL) return(0);

   memset((byte far *)BackBuff,0,SizeBackBuff +1 );
   StartData = 0;
   EndData   = 0;
   BackCount = 0;
   return(1);
}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*  Mise en place d'un caractere dans le tampon de backlog.                 */

void BackPutc(byte *ch)
{
   if(BackCount < SizeBackBuff)
     {
       BackBuff[EndData]=*ch;
       EndData++;
       BackCount++;
     }
   else
     {
      BackCount=SizeBackBuff;       /* pour etre peinard */
      StartData++;
      if(StartData >SizeBackBuff)
        {
          StartData=0;
        }

      EndData++;
      if(EndData >SizeBackBuff)
        {
          EndData=0;
        }
      BackBuff[EndData]=*ch;
     }
}
/*--------------------------------------------------------------------------*/




/*--------------------------------------------------------------------------*/
/*  Suppression du dernier caractere (del) dans le tampon de backlog.       */

void BackDelc(void)
{
if(EndData<1) EndData=SizeBackBuff;
else EndData--;

if(BackCount < SizeBackBuff) BackCount--;

}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/* Pour simplifier,incrementation dans le tampon.                           */

unsigned SuccBuff(unsigned position)
{
  if(position==SizeBackBuff)return(0);
  return(position+1);
}
/*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/*            Rcupre une ligne,normalement de gauche  droite.            */
/*--------------------------------------------------------------------------*/
/*
        La Fin de ligne est soit un toujours le 0x0D,soit un 0x0A.
        Si il y a les deux,c'est le 0x0A qui est pris en compte.

        Un 0x0D seul compte aussi comme nouvelle ligne, et une ligne
        trop longue sera wrappee a la position MaxX.

        La fonction renvoie le nouveau dplacement correspondant au
        premier caractre de la prochaine ligne dans le buffer.
*/
unsigned GetLine(byte far *tampon,unsigned CurPos)
{
unsigned int i,j;

i=CurPos;
j=0;

memset(tampon,0,MaxX+1);               /* nettoie la place... */
while(1)
     {
     if(i==EndData)break;
     if(BackBuff[i]==0x0A)             /* LF seul */
         return(SuccBuff(i));
     if(BackBuff[i]==0x0D)             /* CR LF ou CR SEUL */
       {
         i=SuccBuff(i);
         if(i==EndData)break;
         if(BackBuff[i]==0x0A)
           return(SuccBuff(i));
         else return(i);
       }
     tampon[j]=BackBuff[i];
     j++;
     if(j > MaxX)break;                /* trop long... nouvelle ligne.*/
     i=SuccBuff(i);
     }
return(i);
}
/*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/*           Ecriture du tampon sur disque                                  */
/*--------------------------------------------------------------------------*/

void SauveTampon(void)
{
 int SaveFile;
 byte SaveName[64];

      box(5,10,70,13,blanc_bleu);
      mwrite(10,10," Sauver ce Tampon dans le fichier: ",Inverse);
      if((saisie(6,12,SaveName,blanc_bleu,63,NEW)==ESC)||(!*SaveName))
         {
           return;  /* pas de nom ou saisie abandonne */
         }

     SaveFile=open(SaveName,O_RDWR|O_BINARY|O_CREAT|O_APPEND,S_IREAD|S_IWRITE);
     if(SaveFile==-1)
      {
        beep(2);
        mwrite(10,11,"Impossible d'ouvrir ce fichier!",Blanc_bleu + BLINK);
        delay(1500);
        return;
      }

      box(10,9,30,14,Jaune_vert);
      mwrite(15,11,"Ecriture...",Blanc_vert);

     if(StartData==0)      /* La, c'est simple... */
       {
         write(SaveFile,BackBuff,EndData);
       }
     else                  /* Moins vident...    */
       {
         write(SaveFile,&BackBuff[StartData],SizeBackBuff-StartData);
           if(EndData)   /* Pourrait etre nul...*/
         write(SaveFile,BackBuff,EndData);
       }

    close(SaveFile);
}
/*--------------------------------------------------------------------------*/





/*--------------------------------------------------------------------------*/
/*                        libration mmoire de la liste.                   */
/*--------------------------------------------------------------------------*/

void FreeListe(int nombre)
{
 struct LigneType far *Ptr;
 int nb=nombre;

if(nb<1)return;
Ptr=LigneDeb;
while(nb)
     {
       Ptr=Ptr->Apres;
       farfree(Ptr->Avant);
       nb--;
     }
}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*             Cree une liste chainee des lignes du tampon                  */
/*
                   Retourne le nombre de lignes trouves, ou -2 si
                   l'allocation mmoire n'a pu tre ralise.
*/
int CreListe(void)
{
unsigned Deb;
register int i;
struct LigneType far *Ptr;

Deb=StartData;
i=0;

LigneDeb=(struct LigneType *)farmalloc(sizeof( *LigneDeb));
if(LigneDeb==NULL) return(-2);
LignePred=LigneFin=LigneDeb;

while(1)
     {
        if(Deb==EndData)break;
        Ptr=LigneFin;
        Deb=GetLine(Ptr->Texte,Deb);
        i++;

        LigneFin=(struct LigneType *)farmalloc(sizeof( *LigneFin));
        if(LigneFin==NULL)
          {
            if(i>1) FreeListe(i-1);
            return(-2);
          }

        Ptr->Avant=LignePred;
        Ptr->Apres=LigneFin;
        LignePred=Ptr;
    }
return(i-1);
}
/*--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------*/
/*
      Affiche la ligne du haut de l'ecran, en fonction de la presence ou
      non de la souris.
*/
void Ligne_Haut(void)
{
register int i;
byte Couleur;

 if(EcranMono) Couleur = Inverse; else Couleur = Blanc_bleu;

 for(i=MinX;i<=MaxX;i++)mwrite(i,MinY," ",Couleur);
 if(Souris)
   {
    sourisoff();
    mwrite( 5,MinY," Dbut  ",Inverse);
    mwrite(15,MinY,"  Fin   ",Inverse);
    mwrite(25,MinY,"  PgUp  ",Inverse);
    mwrite(35,MinY,"  PgDn  ",Inverse);
    mwrite(45,MinY,"  Haut  ",Inverse);
    mwrite(55,MinY,"  Bas   ",Inverse);
    mwrite(65,MinY,"  Exit  ",Inverse);
    sourison();
   }
 else
   {
    mwrite(31,MinY," Bbth  Replay... ",Couleur);
   }
}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*             Visualisation du contenu du buffer BackBuff...               */
/*--------------------------------------------------------------------------*/
/*
                Ceci est le 'lister' proprement dit.
*/

void BackView(void)
{
static byte Fleches[]={24,25,0};
static byte DebTxt[] ="* Dbut du Tampon *";
static byte FinTxt[] ="* Fin  du  Tampon *";
static byte Gomme[]  ="                   ";
 byte Attribut= cyan;     /* couleur d'criture */
 byte Couleur;
 byte Putain_de_Bordel,Et_Merde;
 int NbLignes,
     PosCur,
     xs,ys,
     i,j,ch;

 struct LigneType far *Ptr,
       *Last,
       *DebEcran,
       *FinEcran;

   Putain_de_Bordel=QnxScrollAttr; /* on Scrolle en NOir bon sang. */
   QnxScrollAttr=Normal;           /* Font chier avec leur machin ! */
   Et_Merde = CurAttr;
   CurAttr  = Normal;
  if(EcranMono) Couleur = Inverse; else Couleur = Blanc_bleu;

                       /* Ecriture ligne de statut */

   sauvecran();
   cls_win(Attribut);
   for(i=MinX;i<=MaxX;i++)mwrite(i,MaxY," " ,Couleur);
   mwrite(MinX,   MaxY,   " ESC : Sortie  ",Couleur);
   mwrite(MinX+16,MaxY,   "PgUp,PgDn,"      ,Couleur);
   mwrite(MinX+26,MaxY,    Fleches          ,Couleur);
   mwrite(MinX+29,MaxY,   ",Home,End"      ,Couleur);
   mwrite(MinX+58,MaxY,   "S:Sauve en fichier",Couleur);

   mwrite(15,15," Ca vient,a vient, je mouline... ",Normal);

NbLignes=CreListe();
if(NbLignes==-2)
   {
    mwrite(10,10,"Manque de mmoire ! Appui touche...",Inverse);
    getch();
    rendecran();
    QnxScrollAttr=Putain_de_Bordel;
    CurAttr = Et_Merde;
    if(Souris) sourison();
    return;
   }

Ptr=LigneDeb;                            /* va au bout de la liste */
for(i=0;i < NbLignes;i++)Ptr=Ptr->Apres;
Last=Ptr;

cls_win(Attribut);                      /* efface message patience */
for(i=1;i< MaxY-1;i++)                  /* Premier affichage       */
   {
     if(i > NbLignes)break;
     mwrite(0,MaxY-1-i,Ptr->Texte,Attribut);
     Ptr=Ptr->Avant;
   }

Ligne_Haut();        /* Affiche la ligne du haut */

FinEcran=Last;
DebEcran=Ptr;
PosCur=NbLignes;
curseur(0);
while(1)
       {
       ch = 0;
       if(kbhit()) ch = touche();

       if(Souris)                    /*----- gestion a la souris du scroll,*/
         {                           /* et reprise de bloc texte           */
          if(bouton(RIGHT))
            {
              FreeListe(NbLignes);
              rendecran();
              QnxScrollAttr=Putain_de_Bordel;
              CurAttr = Et_Merde;
              curseur(1);
              return;
            }

          if(bouton(LEFT) )
            {
             xs = wherexs();
             ys = whereys();
             if(ys == MinY)         /* Donc on est dans la ligne menu    */
               {
                 if( (xs >= 45) && (xs <= 52) ) ch= HAUT  ;
                 else
                 if( (xs >= 55) && (xs <= 62) ) ch= BAS   ;
                 else
                 while( bouton(LEFT));
                 xs = wherexs();
                 ys = whereys();
                 if(ys == MinY)
                   {
                    if( (xs >= 5 ) && (xs <= 12) ) ch= HOME  ;
                    if( (xs >= 15) && (xs <= 22) ) ch= END   ;
                    if( (xs >= 25) && (xs <= 32) ) ch= PGUP  ;
                    if( (xs >= 35) && (xs <= 42) ) ch= PGDN  ;
                    if( (xs >= 65) && (xs <= 72) ) ch= ESC   ;
                   }
               }
             else                  /* Cas general, donc marquage bloc    */
               {
                if(MarqueBloc())
                  {
                    FreeListe(NbLignes);
                    rendecran();
                    QnxScrollAttr=Putain_de_Bordel;
                    CurAttr = Et_Merde;
                    curseur(1);
                    Ou_Le_Mettre();
                    return;
                  }
               }
            }

         }

       switch(ch)                    /* Gestion au clavier du scroll    */
             {
                case ESC:
                   FreeListe(NbLignes);
                   rendecran();
                   QnxScrollAttr=Putain_de_Bordel;
                   CurAttr = Et_Merde;
                   curseur(1);
                   if(Printing) Printing=0; /* Pas me casser avec sauvecran...*/
                return;

                case 'S':
                case 's':
                   SauveTampon();
                   FreeListe(NbLignes);
                   rendecran();
                   QnxScrollAttr=Putain_de_Bordel;
                   CurAttr = Et_Merde;
                   curseur(1);
                return;


                case HAUT:
                  if(PosCur-(MaxY-1) <= 0 )
                     {
                       mwrite(39,MaxY,DebTxt,Inverse);
                     }
                   else
                     {
                       mwrite(39,MaxY,Gomme,Blanc_bleu);
                       DebEcran=DebEcran->Avant;
                       FinEcran=FinEcran->Avant;
                       Scroll_down(1,MinX,MinY+1,MaxX,MaxY-1);
                       mwrite(MinX,MinY+1,DebEcran->Texte,Attribut);
                       PosCur--;
                     }
                break;

                case BAS:
                   if(PosCur >=NbLignes)
                     {
                       mwrite(39,MaxY,FinTxt,Inverse);
                     }
                   else
                     {
                       mwrite(39,MaxY,Gomme,Blanc_bleu);
                       DebEcran=DebEcran->Apres;
                       FinEcran=FinEcran->Apres;
                       Scroll_up(1,MinX,MinY+1,MaxX,MaxY-1);
                       mwrite(MinX,MaxY-1,FinEcran->Texte,Attribut);
                       PosCur++;
                     }
                break;

                case HOME:
                  cls_win(Attribut);
                  Ligne_Haut();
                  curseur(0);
                  Ptr=LigneDeb;
                  for(i=1;i< MaxY-1;i++)
                     {
                       if(i > NbLignes)break;
                        mwrite(0,i,Ptr->Texte,Attribut);
                       Ptr=Ptr->Apres;
                     }
                  FinEcran=Ptr;
                  DebEcran=LigneDeb;
                  PosCur=i;
                  mwrite(39,MaxY,DebTxt,Inverse);
                break;


                case END:  /* Meme cas que le premier affichage.*/
                  cls_win(Attribut);
                  curseur(0);
                  Ligne_Haut();
                  Ptr=Last;
                  for(i=1;i< MaxY-1;i++)
                     {
                       if(i > NbLignes)break;
                        mwrite(0,MaxY-1-i,Ptr->Texte,Attribut);
                       Ptr=Ptr->Avant;
                     }
                  FinEcran=Last;
                  DebEcran=Ptr;
                  PosCur=NbLignes;
                  mwrite(39,MaxY,FinTxt,Inverse);
                break;


                case PGUP:  /* Je fais autant de fois "HAUT" */
                 for(j=0;j<MaxY-2;j++)
                     {
                      if(PosCur-(MaxY-1) <= 0 )
                         {
                           mwrite(39,MaxY,DebTxt,Inverse);
                         }
                       else
                         {
                           mwrite(39,MaxY,Gomme,Blanc_bleu);
                           DebEcran=DebEcran->Avant;
                           FinEcran=FinEcran->Avant;
                           Scroll_down(1,MinX,MinY+1,MaxX,MaxY-1);
                           mwrite(MinX,MinY+1,DebEcran->Texte,Attribut);
                           PosCur--;
                         }
                     }
                break;

                case PGDN: /* Je fais autant de fois "BAS" */
                  for(j=0;j< MaxY-2;j++)
                     {
                       if(PosCur >=NbLignes)
                         {
                           mwrite(39,MaxY,FinTxt,Inverse);
                         }
                       else
                         {
                           mwrite(39,MaxY,Gomme,Blanc_bleu);
                           DebEcran=DebEcran->Apres;
                           FinEcran=FinEcran->Apres;
                           Scroll_up(1,MinX,MinY+1,MaxX,MaxY-1);
                           mwrite(MinX,MaxY-1,FinEcran->Texte,Attribut);
                           PosCur++;
                         }
                     }
                break;

             }
       }
}
/*--------------------------------------------------------------------------*/


