/*
  ͻ
                                                                          
             DOMAINE     IBM-PC   MS-DOS (3.x+)       
                            PUBLIC                                  
                 Ren    Le protocole de Transfert BBT  
                          Cougnenc  est de Jean-Claude Michot.     
                1989    La librairie de Comm.est de    
                                           Jean-Pierre Parisy & R.Gillmann
  Ķ
                                                                           
                    MODULE: MINITEL.C                                      
                    -----------------                                      
                                                                           
    Simulation d'un petit terminal videotex 40 colonnes, clavier et ecran, 
    en mode texte.                                                         
    Cette mulation est totalement approximative, ne gere pas la couleur,  
    ni certaines squences.                                                
    Elle est uniquement destine  raliser une connexion  un serveur     
    via Teletel.                                                           
    Une squence spciale est scanne, si elle est trouve le soft identi  
    fiera le serveur QBBS et passera automatiquement en ANsi-BBS.          
                                                                           
   Compilation: modle mmoire LARGE                                       
  Ķ
   Vous pouvez distribuer  ce  programme et  ses sources  qui bon vous    
   semble,  condition de ne sparer aucun des modules qui le composent    
   et de le faire GRATUITEMENT.                                            
                                                                           
   Si vous demandez plus que le prix d'une disquette vierge pour fournir   
   ce programme  quelqu'un, vous tes un vil exploiteur  qui se rit des   
   nombreuses heures de travail BENEVOLE de plusieurs personnes, et mme   
   le gigantesque repas que vous devrez offrir   tous  nos  copains      
   La Tour D'Argent ne saura vous faire pardonner de votre bassesse.       
  ͼ

  Module revu et amlior Par Jean-Pierre Parisy et Jean-Claude Michot

 Ŀ
  BbtH 1.2 
 
*/

/*

ATTENTION: Ce module n'est pas acheve !

Reste a faire (entre autre) :

- Gerer le scroll dans la table des inversions video.
- Gerer les codes M1B pour avoir les insertions et
  suppression ligne/car etc...
- Revoir les fonds sur des caracteres double hauteur.
- Revoir les scrolls... ca fait pas la meme chose que
  sur l'ecran du PC sur un vrai minitel...

  [jcm] le 18 Mars 1991

*/

/*#define DEBUG_VTX*/

/*--------------------------------------------------------*/
#ifndef __TURBOC__   /* Borland Turbo-c 1.5               */
#ifndef MSDOS        /* Microsoft C                       */
#error Mfiance ! je ne connais pas ce compilateur l...
#endif
#endif
/*--------------------------------------------------------*/


#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <dos.h>
#include "bbth.h"
#include "touches.h"
#include "couleurs.h"
#include "config.h"
#include "clavecra.h"
#include "minitel.h"
#include "fonction.h"
#include "commpkg.h"


/*
#define Scroll_down(n,x1,y1,x2,y2)	Scroll_down_Min(n,x1,y1,x2,y2)
#define Scroll_up(n,x1,y1,x2,y2)	Scroll_up_Min(n,x1,y1,x2,y2)
*/

byte VtxPos[30];               /* Stockage sequence position      */
byte VtxCount = 0;             /* index pour ci-dessus            */
byte CountVtx;                 /* compteur                        */
byte VtxSaveX, VtxSaveY;       /* sauvegarde curseur pour ligne 0 */
byte OldHauteur, OldLargeur;
byte OldFond, OldForme;
byte OldAttrib, OldInverse;
byte VtxSeq = 0;               /* Flag si dans une sequence vtx   */
byte Blink = 0;                /* Flag si clignotement.           */
int val1, val2;                /* Valeurs de la seq.position      */
byte oldchar = 0;              /* Le denier caractere affiche     */

byte Double_H = 0;             /* Flag double hauteur             */
byte Double_L = 0;             /* Flag double largeur             */
byte Mosaique = 0;             /* Flag caracteres graphiques      */
byte ModePage = 1;             /* Scroll ou pas scroll...         */
byte Inversion = 0;            /* Couleurs pas inverses          */
int  LigneZero = 0;            /* Flag si on est en ligne zero    */
#ifdef BBTH
int  VtxHigh   = 0;            /* Le minitel sera en surintensite */
                               /* si VtxHigh = 8 attention !      */
#else
int  VtxHigh   = 8;            /* Le minitel sera en surintensite */
                               /* si VtxHigh = 8 attention !      */
#endif

byte MaxVtX = 58;              /* definition d'un ecran de 40x25  */
byte MaxVtY = 24;              /* au centre de l'cran IBM        */
byte MinVtX = 19;
byte MinVtY = 0;

byte VtxForme = 7,
VtxFond = 0,                   /* Couleurs videotex par defaut    */
FondLatent = 255,
FondText = 7,
FondMosaique = 7;

byte vdxinv[ 26 ] [ 41 ];  /* Matrice d'inversion video */

#ifdef DEBUG_VTX
byte VdxLog = 0;	   /* Visualisation de page en local */
char Vdxname[80];
FILE *fpl;
#endif


/*  Table des couleurs des diffrents attributs vidotex*/

/*     Couleurs de forme:    */
   byte VtxTable[] = {
   0x00,     /*  Noir                     */
   0x04,     /*  Rouge                    */
   0x02,     /*  Vert                     */
   0x06,     /*  Jaune                    */
   0x01,     /*  Bleu                     */
   0x05,     /*  Magenta                  */
   0x03,     /*  Cyan                     */
   0x07,     /*  Blanc                    */
   /*     Couleurs de fond      */
   0x00,     /*  Noir          @          */
   0x40,     /*  Rouge         A          */
   0x20,     /*  Vert          B          */
   0x60,     /*  Jaune         C          */
   0x10,     /*  Bleu          D          */
   0x50,     /*  Magenta       E          */
   0x30,     /*  Cyan          F          */
   0x70   }; /*  Blanc         G          */

   byte TableVtx[] = {   /*  Inverse de la table precedente!  */
   0x00,
   0x04,
   0x02,
   0x06,
   0x01,
   0x05,
   0x03,
   0x07 };




/*--------------------------------------------------------------------------*/
/*          en cours de developpement                                       */
/*--------------------------------------------------------------------------*/

#ifdef DEBUG_VTX
int step=0;
#endif

void Terminal_VTX (void)
{
   /* Affichage du petit voyant de porteuse en haut a droite   */
    if (OnLine )
    {
        if (mgetc(MaxVtX -1, MinVtY) != 'C' )
               mwrite (MaxVtX - 1, MinVtY, "C", Inverse);
    }
    else
    {
        if (mgetc(MaxVtX -1, MinVtY) != 'F' )
               mwrite (MaxVtX - 1, MinVtY, "F", Inverse);
    }

   if (kbhit ())
      {
      outchar = touche ();
      if (VtxFct (outchar))
         return; /* Touche fonction minitel traitee, ok */

#ifdef DEBUG_VTX
      /* Juste pour faire mon controle de flux pour avoir le
	 temps de lire les dumps/debug des pages videotex  */

      if ( VdxLog && outchar==0x1b )
	 {
         step=0;
         fclose( fpl );
         VdxLog=0;
	 }

      if ( (VdxLog && outchar=='+') || step ) /* CTRL-S */
	  {
          while ( !kbhit() );
          outchar = touche();
          if ( outchar == '+' )
              step=1;
	  else
              step=0;
	  outchar=0;
	  }

      if ( outchar==4 ) /* CTRL-D */
      {
        VdxLog=0;
        sauvecran();
        box(5,10,70,13,blanc_bleu);
        mwrite(10,10," Nom du fichier videotex a visualiser ? ",Inverse);
        saisie(6,12,Vdxname,blanc_bleu,63,NEW);
        rendecran();
        if ( (fpl=fopen( Vdxname, "rb" )) != NULL ) VdxLog=1;
      }

#endif /* DEBUG_VTX */

      if (outchar > 0xFF)
         {
           Fonctions (outchar);
           return;
         }
      else if (outchar < 128)
      {
         Send (NumPort, (byte)outchar);
         if (echo && outchar >= 32)
            vtx(outchar); /* half duplex */
         }
      }

#ifdef DEBUG_VTX
   if ( VdxLog && step==1 )
	{
	while ( !kbhit() );
	outchar = touche();
	if ( outchar == 0x1b )
	    {
            fclose( fpl );
            VdxLog=0;
            step=0;
	    }
	else
	if ( outchar == '+' )
	    step=1;
	else
	    step=0;
	outchar=0;
	}

   if ( VdxLog && feof( fpl ) )
	{
        VdxLog=0;
        fclose( fpl );
	}
   else
   if ( PortReady (NumPort) || VdxLog )
   {
      if ( !VdxLog )
          ch = (Receive (NumPort));
      else
	  {
          if (  (ch=getc( fpl )) == EOF )
             return;
          Send( NumPort, ch );
          delay( 6 );    /* Simulation de la lenteur d'un minitel ;-) */

	  /* Si l'on est en 43 lignes ou +, on met du debug dans les fenetres */
	  if (MaxY > 24) debugvdx( ch );
	  }

#else /* DEBUG_VTX */

   if ( PortReady (NumPort) )
      {
      ch = (Receive (NumPort));
#endif /* DEBUG_VTX */

      if (logtrace == 1)
         LogPutc (ch); /* Fichier log actif */
      if (ch < 5 )
         return; /* Nulls et autres a eliminer en minitel */
      QbbsScan (ch);
      BbtScan(ch);       /* Apres tout si un RTC veut utiliser BBT...*/
      ZmodemScan(ch);
      if (!VtxSeq)
         vtx (ch);
      else
	 /* on est dans une sequence videotex: */
         {
            switch (VtxSeq)
            {
               case VTXPOSITION:
                    VtxLocate (ch);
              break;
               case VTXACCENT:
                    VtxAccentue (ch);
               break;
               case VTXATTRIB:
                    VtxAttribut (ch);
               break;
               case VTXREPET:
                    VtxRepete (ch);
               break;
               case VTXSTATUS:
                    VtxStatus (ch);
               break;
               case VTXFILTRE:
                   VtxFiltre ();
               break;
               case VTXPRO1:
                   VtxPRO1 (ch);
               break;
               case VTX5B:
                    VtxG5b(ch);
               break;
            }
         }
      }

   }
/*---------------------------------------------------------------------------*/



#ifdef BBTH
/*---------------------------------------------------------------------------*/
/*                    Gestion du clavier minitel (pour BBTH )                */
/*---------------------------------------------------------------------------*/
/*
       Sont traites dans cette fonction les touches spciales du
       minitel, ainsi que certains caratres accentus.
       (pas tous, on va pas s'emmerder  se faire chier...)
*/

int VtxFct (int valeur)
   {
    int x,y;
    byte atr;

   switch (valeur)
      {
   case RETOUR:   /* Touche Envoi simule */
      Send (NumPort, 0x13);
      Send (NumPort, 0x41);
      return (1);

   case LF:       /* Touche Enter */
      Send (NumPort, CR);
      return (1);

   case HAUT:     /* Touche Retour Simulee */
      Send (NumPort, 0x13);
      Send (NumPort, 0x42);
      return (1);

   case BAS:     /* Touche Suite           */
      Send (NumPort, 0x13);
      Send (NumPort, 0x48);
      return (1);

   case HOME:    /* Touche Sommaire        */
      Send (NumPort, 0x13);
      Send (NumPort, 0x46);
      return (1);

   case GAUCHE:
   case BACK:    /* Touche Correction      */
      Send (NumPort, 0x13);
      Send (NumPort, 0x47);
      return (1);

   case DELETE:  /* Touche Annulation      */
      Send (NumPort, 0x13);
      Send (NumPort, 0x45);
      return (1);


   case F1:      /* Touche Guide           */
      Send (NumPort, 0x13);
      Send (NumPort, 0x44);
      return (1);

   case F2:      /* Touche Repetition       */
      Send (NumPort, 0x13);
      Send (NumPort, 0x43);
      return (1);

   case F3:      /* Bascule mode page/rouleau*/
      if (ModePage)
         ModePage = 0;
      else
         ModePage = 1;
      ligne_statut ();
      return (1);


   case F4:   /* Bascule HighLight 0 ou 1 */
     VtxHigh = VtxHigh ? 0 : 8;
     if(VtxHigh == 0)
       {
          CurAttr &=~8;
          for(y = MinVtY; y <= MaxVtY; y++)
          for(x = MinVtX; x <= MaxVtX; x++)
          {
            atr  = mgetcolor(x,y);
            atr &=~8;
            mputattr(x,y,atr);
          }
       }
     else
       {
        CurAttr |=8;
        for(y = MinVtY; y <= MaxVtY; y++)
        for(x = MinVtX; x <= MaxVtX; x++)
          {
            atr  = mgetcolor(x,y); /* No higlight sur du noir...*/
            if((atr & 1 ) || (atr & 2) || (atr & 4 ) )
            {
              atr |= 8;
              mputattr(x,y,atr);
            }
          }
       }
   return(1);

#ifdef DEBUG_VTX
   case F5:
      {
      FILE *dbg;
      int i,j;

      dbg=fopen("DEBUG.TXT","wt");
      for(i=0;i<25;i++)
	 {
	 for(j=0;j<40;j++)
	   fprintf( dbg, "%d", vdxinv[i][j] );
	 fprintf( dbg,"\n");
	 }
      fclose( dbg );
      return(1);
      }
#endif /* DEBUG_VTX */

   case F10:     /* Touche Connexion/FIN   */
      Send (NumPort, 0x13);
      Send (NumPort, 0x49);
      return (1);

   case 133:     /* A accent grave   */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x41);
      Send (NumPort, 97);
      return (1);

   case 131:     /* A accent circonflexe   */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x43);
      Send (NumPort, 97);
      return (1);

   case 132:     /* A Trema    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x48);
      Send (NumPort, 97);
      return (1);


   case 135:     /* C cedille    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x4B);
      Send (NumPort, 0x63);
      return (1);

   case 130:     /* E accent aigu    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x42);
      Send (NumPort, 101);
      return (1);

   case 138:     /* E accent grave    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x41);
      Send (NumPort, 101);
      return (1);

   case 136:     /* E accent circonflexe    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x43);
      Send (NumPort, 101);
      return (1);

   case 137:     /* E trema    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x48);
      Send (NumPort, 101);
      return (1);

   case 140:     /* I accent circonflexe    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x43);
      Send (NumPort, 105);
      return (1);

   case 139:     /* I trema    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x48);
      Send (NumPort, 105);
      return (1);

   case 147:     /* O accent circonflexe    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x43);
      Send (NumPort, 111);
      return (1);

   case 148:     /* O trema    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x48);
      Send (NumPort, 111);
      return (1);

   case 150:     /* U Accent circonflexe    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x43);
      Send (NumPort, 117);
      return (1);

   case 151:     /* U Accent grave    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x41);
      Send (NumPort, 117);
      return (1);


   case 171:     /*     */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x17);
      Send (NumPort, 0x3D);
      return (1);

   case 172:     /*    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x17);
      Send (NumPort, 0x3C);
      return (1);

   case 241:     /*    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x17);
      Send (NumPort, 0x31);
      return (1);

   case 246:     /* divis  */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x17);
      Send (NumPort, 0x38);
      return (1);

   case 248:     /*  */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x17);
      Send (NumPort, 0x30);
      return (1);

      }

   return (0); /* C'est pas une touche de fonction minitel, a. Et non. */
   }
/*---------------------------------------------------------------------------*/
#else
/*---------------------------------------------------------------------------*/
/*                    Gestion du clavier minitel (pour ALPHACOMH )           */
/*---------------------------------------------------------------------------*/
/*
       Sont traites dans cette fonction les touches spciales du
       minitel, ainsi que certains caratres accentus.
       (pas tous, on va pas s'emmerder  se faire chier...)
*/

int VtxFct (int valeur)
   {
    int x,y;
    byte atr;

   switch (valeur)
      {
   case RETOUR:   /* Touche Envoi simule */
      Send (NumPort, 0x13);
      Send (NumPort, 0x41);
      return (1);

   case LF:       /* Touche Enter */
      Send (NumPort, CR);
      return (1);

   case HAUT:     /* Touche Retour Simulee */
   case F2  :
      Send (NumPort, 0x13);
      Send (NumPort, 0x42);
      return (1);

   case BAS:     /* Touche Suite           */
   case F1 :
      Send (NumPort, 0x13);
      Send (NumPort, 0x48);
      return (1);

   case HOME:    /* Touche Sommaire        */
   case F6  :
      Send (NumPort, 0x13);
      Send (NumPort, 0x46);
      return (1);

   case GAUCHE:
   case BACK:    /* Touche Correction      */
   case F7  :
      Send (NumPort, 0x13);
      Send (NumPort, 0x47);
      return (1);

   case DELETE:  /* Touche Annulation      */
   case    F5 :
      Send (NumPort, 0x13);
      Send (NumPort, 0x45);
      return (1);


   case F4:      /* Touche Guide           */
      Send (NumPort, 0x13);
      Send (NumPort, 0x44);
      return (1);

   case F3:      /* Touche Repetition       */
      Send (NumPort, 0x13);
      Send (NumPort, 0x43);
      return (1);

   case SHIFT_F3:      /* Bascule mode page/rouleau*/
      if (ModePage)
         ModePage = 0;
      else
         ModePage = 1;
      ligne_statut ();
      return (1);


   case SHIFT_F4:   /* Bascule HighLight 0 ou 1 */
     VtxHigh = VtxHigh ? 0 : 8;
     if(VtxHigh == 0)
       {
          CurAttr &=~8;
          for(y = MinVtY; y <= MaxVtY; y++)
          for(x = MinVtX; x <= MaxVtX; x++)
          {
            atr  = mgetcolor(x,y);
            atr &=~8;
            mputattr(x,y,atr);
          }
       }
     else
       {
        CurAttr |=8;
        for(y = MinVtY; y <= MaxVtY; y++)
        for(x = MinVtX; x <= MaxVtX; x++)
          {
            atr  = mgetcolor(x,y); /* No higlight sur du noir...*/
            if((atr & 1 ) || (atr & 2) || (atr & 4 ) )
            {
              atr |= 8;
              mputattr(x,y,atr);
            }
          }
       }
   return(1);


   case F9:     /* Touche Connexion/FIN   */
      Send (NumPort, 0x13);
      Send (NumPort, 0x49);
      return (1);

   case 133:     /* A accent grave   */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x41);
      Send (NumPort, 97);
      return (1);

   case 131:     /* A accent circonflexe   */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x43);
      Send (NumPort, 97);
      return (1);

   case 132:     /* A Trema    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x48);
      Send (NumPort, 97);
      return (1);


   case 135:     /* C cedille    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x4B);
      Send (NumPort, 0x63);
      return (1);

   case 130:     /* E accent aigu    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x42);
      Send (NumPort, 101);
      return (1);

   case 138:     /* E accent grave    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x41);
      Send (NumPort, 101);
      return (1);

   case 136:     /* E accent circonflexe    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x43);
      Send (NumPort, 101);
      return (1);

   case 137:     /* E trema    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x48);
      Send (NumPort, 101);
      return (1);

   case 140:     /* I accent circonflexe    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x43);
      Send (NumPort, 105);
      return (1);

   case 139:     /* I trema    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x48);
      Send (NumPort, 105);
      return (1);

   case 147:     /* O accent circonflexe    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x43);
      Send (NumPort, 111);
      return (1);

   case 148:     /* O trema    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x48);
      Send (NumPort, 111);
      return (1);

   case 150:     /* U Accent circonflexe    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x43);
      Send (NumPort, 117);
      return (1);

   case 151:     /* U Accent grave    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x19);
      Send (NumPort, 0x41);
      Send (NumPort, 117);
      return (1);


   case 171:     /*     */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x17);
      Send (NumPort, 0x3D);
      return (1);

   case 172:     /*    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x17);
      Send (NumPort, 0x3C);
      return (1);

   case 241:     /*    */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x17);
      Send (NumPort, 0x31);
      return (1);

   case 246:     /* divis  */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x17);
      Send (NumPort, 0x38);
      return (1);

   case 248:     /*  */
      if (echo)
         mvputc(valeur); /* half duplex */
      Send (NumPort, 0x17);
      Send (NumPort, 0x30);
      return (1);

      }

   return (0); /* C'est pas une touche de fonction minitel, a. Et non. */
   }
/*---------------------------------------------------------------------------*/
#endif

/*--------------------------------------------------------------------------*/
/*            Simulation d'un ecran de terminal Videotex simple...          */
/*--------------------------------------------------------------------------*/

char tgraf[] = "                                                                 ";
/*              |               |                   |               |               |               |               |               |             |
                20              28                  30              38              60              68              70              78            5F */

void vtx (byte ch)
   {
   register int i;
   switch (ch)
      {

   case 0x07:     /* La cloche j'avais oubli ca !!! */
      beep (1);
      break;

   case 0x08:      /* Backspace */
         {
         if (CurX > MinVtX)
            {
            CurX--;
            locate (CurX, CurY);
            }
         else
            {
            if (CurY > MinVtY + 1)
               CurY--;
            else if (!LigneZero)
               {
               if (!ModePage)
                  {
                  Scroll_down (1, MinVtX, MinVtY + 1, MaxVtX, MaxVtY);
                  CurY = MinVtY + 1;
                  }
               else
                  CurY = MaxVtY;
               }
            CurX = MaxVtX;
            locate (CurX, CurY);
	    }

      /* On reprend l'attribut de fond de la colonne PRECEDENTE */
      /* SEULEMENT SI LE FOND PRECEDENT N'EST PAS UNE INVERSION VIDEO */
      if ( 	CurX > MinVtX && Inversion==0 &&
		vdxinv[ CurY-MinVtY ] [ CurX-MinVtX ] != 1 )
	 {
	 VtxFond = *(Ecran + (((CurY * 2 * (MaxX + 1)) + (CurX * 2)) - 1));
	 CurAttr =( (VtxFond & 0x70) | VtxForme ) ;
	 if(VtxForme)   CurAttr |= VtxHigh;
	 else           CurAttr &=~VtxHigh;
	 VtxFond = TableVtx[(VtxFond >> 4) & 0x07];
	 }

         }
      break;

   case 0x09: /* tabulation 1 horizontale*/
      CurX++;
      if (LigneZero && (CurX > MaxVtX))
         CurX = MaxVtX;
      else if (CurX > MaxVtX)
         {
         CurX = MinVtX;
         CurY++;
         if (CurY > MaxVtY)
            if (!ModePage)
               {
               Scroll_up (1, MinVtX, MinVtY + 1, MaxVtX, MaxVtY);
               CurY = MaxVtY;
               }
            else
               {
               CurX = MinVtX;
               CurY = MinVtY;
               }
	 }

      /* On reprend l'attribut de fond de la colonne PRECEDENTE */
      /* SEULEMENT SI LE FOND PRECEDENT N'EST PAS UNE INVERSION VIDEO */
      if ( 	CurX > MinVtX && Inversion==0 &&
		vdxinv[ CurY-MinVtY ] [ CurX-MinVtX ] != 1 )
	 {
	 VtxFond = *(Ecran + (((CurY * 2 * (MaxX + 1)) + (CurX * 2)) - 1));

	 CurAttr = (VtxFond & 0x70) | VtxForme;
	 if(VtxForme)   CurAttr |= VtxHigh;
	 else           CurAttr &=~VtxHigh;

	 VtxFond = TableVtx[(VtxFond >> 4) & 0x07];
	 }

      locate (CurX, CurY);
      break;  /* A voir ca... ?*/

   case 0x0A: /* Line-feed */
         {
         if (LigneZero)    /* cas particulier l...*/
            {              /* on remet contexte    */
            Double_H = OldHauteur;
            Double_L = OldLargeur;
            VtxFond = OldFond;
            VtxForme = OldForme;
            Inversion = OldInverse;
            CurAttr = OldAttrib;
            locate (VtxSaveX, VtxSaveY);
            LigneZero = 0;
            return;
            }              /* sinon cas normal     */
         CurY++;
         if (CurY > MaxVtY)
            {
            if (!ModePage)
               {
               Scroll_up (1, MinVtX, MinVtY + 1, MaxVtX, MaxVtY);
               CurY = MaxVtY;
               }
            else
               {
               CurX = MinVtX;
               CurY = MinVtY+1; /* ligne 1! */
               }
            }

      /* On reprend l'attribut de fond de la colonne PRECEDENTE */
      /* SEULEMENT SI LE FOND PRECEDENT N'EST PAS UNE INVERSION VIDEO */
      if (	CurX > MinVtX && Inversion==0 &&
		vdxinv[ CurY-MinVtY ] [ CurX-MinVtX ] != 1 )
	 {
	 VtxFond = *(Ecran + (((CurY * 2 * (MaxX + 1)) + (CurX * 2)) - 1));
	 CurAttr =( (VtxFond & 0x70) | VtxForme ) ;
	 if(VtxForme)   CurAttr |= VtxHigh;
	 else           CurAttr &=~VtxHigh;
	 VtxFond = TableVtx[(VtxFond >> 4) & 0x07];
	 }

	 locate (CurX, CurY);
         }
      break;


   case 0x0B: /* Vtab vers le haut */
      if (!LigneZero)
         {
         if (CurY > MinVtY + 1)
            CurY--;
         else
            {
            if (!ModePage)
               {
               Scroll_down (1, MinVtX, MinVtY + 1, MaxVtX, MaxVtY);
               CurY = MinVtY + 1;
               }
            else
               CurY = MaxVtY; /* ligne 24! */
	    }

      /* On reprend l'attribut de fond de la colonne PRECEDENTE */
      /* SEULEMENT SI LE FOND PRECEDENT N'EST PAS UNE INVERSION VIDEO */
      if (	CurX > MinVtX && Inversion==0 &&
		vdxinv[ CurY-MinVtY ] [ CurX-MinVtX ] != 1 )
	 {
	 VtxFond = *(Ecran + (((CurY * 2 * (MaxX + 1)) + (CurX * 2)) - 1));
	 CurAttr =( (VtxFond & 0x70) | VtxForme ) ;
	 if(VtxForme)   CurAttr |= VtxHigh;
	 else           CurAttr &=~VtxHigh;
	 VtxFond = TableVtx[(VtxFond >> 4) & 0x07];
	 }

	 locate (CurX, CurY);
         }
      break;

   case 0x0C: /* effacement ecran */
      cls_vtx ();
      LigneZero = 0;
      break;

   case 0x0D: /* Retour CHariot */
         {
         CurX = MinVtX;
         locate (CurX, CurY);
         }
      break;

   case 0x0E:    /* passage alphamosaique on */
      Mosaique = 1;
      Double_H = 0;
      Double_L = 0;
      Inversion = 0;
      SetVtxColor (VtxForme, VtxFond);
      break;

   case 0x0F:    /* passage alphamosaique off */
      Mosaique = 0;
      Double_H = 0;
      Double_L = 0;
      Inversion = 0;
      SetVtxColor (VtxForme, VtxFond);
      break;

   case 0x11: /* Demasquage curseur */
      curseur (1);
      return;

   case 0x12:
      VtxSeq = VTXREPET;
      VtxCount = 0;
      return;

   case 0x14: /* Masquage curseur */
      curseur (0);
      return;

   case 0x16:    /* idem dessous, pareil             */
   case 0x19:    /* Sequence d'accentuation minitel */
      VtxSeq = VTXACCENT;
      VtxCount = 0;
      return;

   case 0x18:    /* Remplit de spaces jusqu'a EoL   */
      for (i = CurX; i < MaxVtX + 1; i++)
	 {
	 vdxinv[ CurY-MinVtY ] [ i-MinVtX ] = Inversion;
	 mwrite (i, CurY, " ", CurAttr);
	 }
      if (Double_H && (CurY > MinVtY + 1))
         for (i = CurX; i < MaxVtX + 1; i++)
	    {
	    vdxinv[ CurY-MinVtY ] [ i-MinVtX ] = Inversion;
	    mwrite (i, CurY - 1, " ", CurAttr);
	    }
      return;

   case 0x1B:    /* Sequence Escape d'attributs minitel */
      VtxSeq = VTXATTRIB;
      VtxCount = 0;
      return;
 
   case 0x1E: /* retour ligne 1 colonne 0 je crois */
      locate (MinVtX, MinVtY+1);
      CurAttr  = 7 + VtxHigh ;
      VtxForme = 7;
      Inversion = 0;
      Double_H = 0;
      Double_L = 0;
      Mosaique = 0;
      LigneZero = 0;
      VtxFond = 0;
      SetVtxColor (VtxForme, VtxFond);
      return;

   case 0x1F:    /* Positionnement curseur videotex */
      VtxSeq = VTXPOSITION;
      VtxCount = 0;
      return;

   case 0x13:    /* On filtre ceci car c'est des aquitements que retourne
		    le minitel quand on l'utilise comme "modem".  */
      VtxSeq = VTXFILTRE;
      VtxCount=1;
      return;

   case 0x10:
   case 0x15:
   case 0x17:
   case 0x1A:
   case 0x1C:
   case 0x1D:
      return;
      /* NOP sur ces machins la pour nous. */


   default:
      if (Mosaique) {
         if (ch >= 32)
            ch -= 32;
         if (ch >= 64)
            ch -= 32;
         ch = tgraf[ch * 2];
         }
      mvputc (ch);
      }

   }
/*---------------------------------------------------------------------------*/


/*---------------------------------------------------------------------------*/
/*         effacement ecran videotex                                         */
/*---------------------------------------------------------------------------*/
void cls_vtx (void)
   {
   register int i,j;
   byte sour;

    if(cursouris)
    {
      sourisoff();
      sour=1;
    }
    else sour = 0;

   for (i = MinVtY + 1;i < MaxVtY+1;i++)
      mwrite (MinVtX, i,
      "                                        ", 7);
   /* 40 espaces pour effacer...           */
   locate (MinVtX, MinVtY+1); /* positionnement en ligne 1 et pas Zero! */
   CurAttr = 7+ VtxHigh;
   VtxForme = 7;
   VtxFond = 0;
   FondLatent = 0;
   FondText = 0;
   FondMosaique = 0;
   Double_H = 0;
   Double_L = 0;
   Mosaique = 0;
   Inversion = 0;

   /* Efface la matrice d'inversion video */
   for (i=0;i<26;i++)
      for(j=0;j<40;j++)
	vdxinv[i][j]=0;

   if(sour) sourison();
   ChangePalette();       /* Positionne des couleurs EGA mieux... */
   }
/*---------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*     Positionne un chr en mmoire video sur l'ecran minitel ( != mputc)   */
/*--------------------------------------------------------------------------*/
/*
     Ecrit un caractere en memoire video a la position courante et 
     l'attribut courant.
     Les attributs de taille sont traites comme suit:

       Double largeur: Un espace supplementaire a droite
       Double Hauteur: Un espace suppelmentaire au-dessus

     Incremente la position courante d'une unit, scrolle l'ecran en
     haut a partir de la derniere ligne si ModePage = 0, sinon retour en
     0, 0.

     Remise des attributs caractere par defaut  chaque changement de
     ligne.
*/
void mvputc (byte ch)
   {
   int i;
   byte sour;

   if (ch == 0x60)
      ch = 196;                 /* petites modifs pour affichage*/
   if (ch == 0x7F)
      ch = 219;                 /* un peu moins moche...        */
   if ((ch >= 123) && (ch <= 125))
      ch = 179;
   if (ch == 126)
      ch = 196;

    if((cursouris) && (CurY == whereys()) )
    {
      sourisoff();
      sour=1;
    }
    else sour = 0;

   oldchar = ch;                               /* Stocke le car si Repetition */
   i = (CurY * 2 * (MaxX + 1))+ (CurX * 2);    /* calcul coordonnes */
   *(Ecran + i) = ch;
   *(Ecran + i + 1) = CurAttr;

   /* Definition de la matrice d'inversion video */
   vdxinv[ CurY-MinVtY ] [ CurX-MinVtX ] = Inversion;

   if ((Double_H) && (CurY > MinVtY + 1))
      {
      if ( ch==179 )
	  {
	  char lv[5];
	  lv[0]=179; lv[1]=0;
	  mwrite (CurX, CurY - 1, lv, CurAttr);
	  }
      else
	  mwrite (CurX, CurY - 1, " ", CurAttr);
      }

   /* Gestion de Double hauteur si place au dessus  */
   if ((Double_L) && (CurX < MaxVtX))
      {
      /* gestion double largeur si on n'est pas en fin de ligne */
      mwrite (CurX + 1, CurY, " ", CurAttr);  /* espace de plus en double largeur   */
      if ((Double_H) && (CurY > MinVtY + 1))
         mwrite (CurX + 1, CurY - 1, " ", CurAttr);
      CurX++;                          /* gestion double taille si place dessus*/
      }
   CurX++;
   if (LigneZero && (CurX > MaxVtX))
      CurX = MaxVtX;
   else if (CurX > MaxVtX)
      {
      CurX = MinVtX;
      CurY++;
      if (Double_H)
         CurY++; /* encore un coup */
      if (CurY > MaxVtY)
         {
         if (!ModePage)
            {
            Scroll_up (CurY - MaxVtY, MinVtX, MinVtY + 1, MaxVtX, MaxVtY);
            CurY = MaxVtY;
            }
         else
            {
            CurX = MinVtX;
            CurY = MinVtY + (CurY - MaxVtY);
            }
         }
      }
   locate (CurX, CurY);
   if(sour) sourison();
   }
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*      gestion de la sequence de position curseur videotex                 */
/*--------------------------------------------------------------------------*/

void VtxLocate (byte ch)
   {
   if (!VtxCount)
      {
      val1 = ch;
      VtxCount++;
      return;
      }

   val2 = ch;
   VtxCount = 0;
   VtxSeq = 0;
   if (! LigneZero)
      {
      VtxSaveX = CurX;    /* au cas ou ligne zero appelee...*/
      VtxSaveY = CurY;    /* on sauve le contexte           */
      OldHauteur = Double_H;
      OldLargeur = Double_L;
      OldAttrib = CurAttr;
      OldFond = VtxFond;
      OldForme = VtxForme;
      OldInverse = Inversion;
      }

   switch (val1)
      {
   case 48:
   case 49:
   case 50: /* Debut de colonne des  lignes 0-24 dans ce cas */
      locate (MinVtX, MinVtY + ((val2 - 48) + ((val1 - 48) * 10)));
      break;


   default:      /* Cas general sinon */
      locate (MinVtX-1+val2-0x40, MinVtY+val1-0x40);
      }
   if (CurY == MinVtY)
      LigneZero = 1;
   else
       LigneZero = 0;
   /* perte de tous les attributs sauf le fond, excepte en colonne 0!!!  */
   VtxForme = 7;
   if (CurX == MinVtX)
   {
      CurAttr = VtxForme ;
      if(VtxForme) CurAttr |= VtxHigh;
      else         CurAttr &=~VtxHigh;
      VtxFond = 0;
   }
   else
      {
      /* On reprend l'attribut de fond de la colonne PRECEDENTE */
      /* SEULEMENT SI LE FOND PRECEDENT N'EST PAS UNE INVERSION VIDEO */

      if ( vdxinv[ CurY-MinVtY ] [ CurX-MinVtX ] != 1 )
	  {
	  VtxFond = *(Ecran + (((CurY * 2 * (MaxX + 1)) + (CurX * 2)) - 1));
	  CurAttr = ( (VtxFond & 0xf0) | VtxForme );
	  if(VtxForme)   CurAttr |= VtxHigh;
	  else           CurAttr &=~VtxHigh;
	  VtxFond = TableVtx[ (VtxFond >> 4) & 0x0f ];
	  }
      else
	  {
	  VtxFond = 0;
	  CurAttr = ( (VtxFond & 0xf0) | VtxForme );
	  if(VtxForme)   CurAttr |= VtxHigh;
	  else           CurAttr &=~VtxHigh;
	  }
      }
   Mosaique = 0;
   Inversion = 0;
   Double_H = 0;
   Double_L = 0;
   }
/*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/* Affichage des caracteres spciaux du minitel (19 Code dans G2         )  */
/*--------------------------------------------------------------------------*/
void VtxSpecial (byte ch)
   {
      static byte SpecRef[] = {
      35, 36, 38, 39, 44, 45, 46, 47, 48, 49, 56, 60, 61, 62, 106, 122, 0                                                            };
      static byte SpecCar[] = {
      156, 36, 35, 39, 27, 24, 26, 25, 248, 241, 246, 171, 171, 168, 168, 168, 0                                                            };
   /* Table de Ref des char speciaux obtenus par CNRTL-Y et leur equivalent */
   /* IBM s'il existe, un point d'interrog. l'envers sinon  le place.     */
   register int i = 0;

   while (SpecRef[i])
      {
      if (SpecRef[i] == ch)
         {
         mvputc (SpecCar[i]);
         return;
         }
      i++;
      }
   }
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/* Affichage des caracteres accentues videotex. (19 Code_accent Caractere)  */
/*--------------------------------------------------------------------------*/
/*
     Si le caractere n'existe pas dans le jeu IBM ou si il n'est pas
     trait par paresse, il est affich non-accentu.
*/

void VtxAccentue (byte ch)
   {
   if (!VtxCount)
      {
      val1 = ch;
      if ((val1 < 65)|| (val1 > 72)) /* Pas un accentu mais un special */
         {
         VtxSeq = 0;
         VtxSpecial (val1);
         return;
         }
      VtxCount++;  /* Code accent, on attend encore le caractere */
      return;
      }
   val2 = ch;  /* Et voila le caractere, on se lance...      */
   VtxCount = 0;
   VtxSeq = 0;

   if (val1 == 0x41) /* Accent grave */
      {
      switch (val2)
         {
      case 97:
         mvputc (133);
         return; /* a */
      case 101:
         mvputc (138);
         return; /* e */
      case 105:
         mvputc (141);
         return; /* i */
      case 111:
         mvputc (149);
         return; /* o */
      case 117:
         mvputc (151);
         return; /* u */
      default:
         UnReceive (NumPort, val2);
         return;
         }
      }


   if (val1 == 0x42) /* Accent aigu */
      {
      switch (val2)
         {
      case 97:
         mvputc (160);
         return; /* a */
      case 101:
         mvputc (130);
         return; /* e */
      case 105:
         mvputc (161);
         return; /* i */
      case 111:
         mvputc (162);
         return; /* o */
      case 117:
         mvputc (163);
         return; /* u */
      default:
         UnReceive (NumPort, val2);
         return;
         }
      }
 
   if (val1 == 0x43) /* Accent circonflexe */
      {
      switch (val2)
         {
      case 97:
         mvputc (131);
         return; /* a */
      case 101:
         mvputc (136);
         return; /* e */
      case 105:
         mvputc (140);
         return; /* i */
      case 111:
         mvputc (147);
         return; /* o */
      case 117:
         mvputc (150);
         return; /* u */
      default:
         UnReceive (NumPort, val2);
         return;
         }
      }
 
   if (val1 == 0x48) /* Trema */
      {
      switch (val2)
         {
      case 97:
         mvputc (132);
         return; /* a */
      case 101:
         mvputc (137);
         return; /* e */
      case 105:
         mvputc (139);
         return; /* i */
      case 111:
         mvputc (148);
         return; /* o */
      case 117:
         mvputc (154);
         return; /* u */
      default:
         UnReceive (NumPort, val2);
         return;
         }
      }
   }
/*--------------------------------------------------------------------------*/

 

/*--------------------------------------------------------------------------*/
/* Gestion des sequences ESCAPE (attribut caractere)                        */
/*--------------------------------------------------------------------------*/
/*
            Le gros delire par ici. Impossible de trouver une logique
            cohrente aux reactions d'un minitel, fonction horrible
            bricole par petit bout en fonction des dcouvertes...
*/
void VtxAttribut (byte ch)
   {
   val1 = ch;
   VtxCount = 0;

   /* La, je ne pige rien du tout...         */
   /* j'ai l'impression que les valeurs      */
   /* suivantes sont filtres, alors bricole */
   /* en attendant d'en savoir plus !!!      */

   /* Le dlire complet le minitel houlala !!! */
   /* Lu et approuve : le 10-Mar-91 [jcm] ;-)  */

   switch (val1)
      {
   case 0x20:
      CountVtx = 2;
      VtxSeq = VTXFILTRE;
      return;

   case 0x22:
      CountVtx = 1;
      VtxSeq = VTXFILTRE;
      return;

   case 0x23:
      CountVtx = 2;
      VtxSeq = VTXFILTRE;
      return;

   case 0x38:
      /* Alors on s'en balance c'est encore pour faire des changements
	 entre les jeux de caractere francais et US voir meme Vt100 */
      CountVtx = 2;
      VtxSeq = VTXFILTRE;
      return;

   case 0x2f:
      Fonctions (ALT_V);
      ModePage = 1;
      ligne_statut ();
      CountVtx = 1;
      VtxSeq = VTXFILTRE;
      return;

   case 0x35:
   case 0x36:
      CountVtx = 1;
      VtxSeq = VTXFILTRE;
      return;

   case 0x39:
      /* Ca, c'est des ennuis qui se preparent */
      VtxSeq = VTXPRO1;
      return;

   case 0x3A:
      /* Ca, c'est (peut etre) une sequence de config terminal */
	VtxSeq = VTXSTATUS;

      /* C'est pas le pied ca...
	 dans le coin il y a une gestion du mode page et du mode rouleau.
	 (ESC 3a 69 43) rouleau on   (ESC 3a 6a 43) rouleau off */
      /* Il y a aussi (ESC 3a 31 7d ) c'est tres utile ca passe le
	 minitel en 80col dans un mode ""presque"" vt100 ;-) */
      /* Tien encore un truc bizard... c'est quoi le mode 'mixte'
	 encore un mode 80col bizard ? (ESC 3a 32 7d) alors on a
	 son petit frere en sens inverse (ESC 3a 32 7e) */
      /* Ho et puis il y a des truc infame style eguillage dans tout
	 les sens entre clavier,ecran,modem,prise peri-info etc...
	 C'est des truc fait rien que pour aller a la poubelle */
      /* Finalement apres etude, il ya deja des trucs louche de
	 ce style qui sont traite dans VTXSTATUS donc j'y touche
	 pas comme je pensais le faire... */
	return;

   case 0x3B:
      /* Ca on s'en balance c'est pour la gestion des claviers de
	 merde des minitels... */
      CountVtx = 3;
      VtxSeq = VTXFILTRE;
      return;

   case 0x5B:
      /* C'est PLEIN de commande pour les M1b ici */
      CountVtx = 0;
      VtxSeq = VTX5B;
      return;
      }


   /* Bon, on a fini avec les trucs pas clairs, ce ne peut etre */
   /* qu'un attrib de forme ou autre...                         */

   VtxSeq = 0;

   if ((val1 > 0x4F) && (val1 < 0x58))     /* c'est une couleur de fonds  */
      {
#ifdef DEBUG_VTX
      VtxDebug( "Couleur Fond" );
#endif
      VtxFond = val1 - 0x50;
      SetVtxColor (VtxForme, VtxFond);
      return;
      }
   if ((val1 > 0x3F) && (val1 < 0x48 ))       /* c'est une couleur caractere  */
      {
#ifdef DEBUG_VTX
      VtxDebug( "Couleur Car" );
#endif
      VtxForme = val1-0x40;
      SetVtxColor (VtxForme, VtxFond);
      return;
      }

   switch (val1)
      {

   case 0x48:  /* Clignotement        */
      if (Blink)
         return;
      CurAttr = CurAttr | BLINK;
      Blink = 1;
      return;

   case 0x49:  /* Fin Clignotement      */
      if (!Blink)
         return;
      CurAttr = CurAttr - (CurAttr & BLINK);
      Blink = 0;
      return;

   case 76:    /* esc L; texte normal */
      Double_H = 0;
      Double_L = 0;
   return;

   case 77:    /* esc M;Double hauteur */
      if (!LigneZero)
         Double_H = 1;
         Double_L = 0;  /* A verifier mais casse moins les ecrans. */
   return;

   case 78:    /* esc N;Double largeur */
        Double_L = 1;
        Double_H = 0;  /* A verifier mais casse moins les ecrans. */
   return;

   case 79:    /* esc O;Double taille */
      Double_L = 1;
      if (!LigneZero)
	 Double_H = 1;
      return;

   case 92:    /* Inverse off         */
#ifdef DEBUG_VTX
      VtxDebug( "Inverse off" );
#endif
      Inversion = 0;
      SetVtxColor (VtxForme, VtxFond);
   return;

   case 93:    /* Inverse on          */
#ifdef DEBUG_VTX
      VtxDebug( "Inverse on" );
#endif
      Inversion = 1;
      SetVtxColor (VtxForme, VtxFond);
   return;
      }

   }
/*--------------------------------------------------------------------------*/

VtxG5b( char ch )
{
      if ( VtxCount==0 )
      switch( ch )
      {
      case 0x48: /* (1b 5b 48) Home */
	  VtxCount = 0;
	  VtxSeq = 0;
	  return;
      case 0x34: /* (1b 5b 34 6c) fin de mode d'insertion de caracteres */
		 /* (1b 5b 34 68) debut de mode d'insertion de caracteres */
	   break;
      case 0x3c: /* (1b 5b 3c 31 6c ) curseur on */
		 /* (1b 5b 3c 31 68 ) curseur off */
	   break;

      /* (1b 5b Pn 44) vers la gauche de n colones */
      /* (1b 5b Pn 43) vers la droite de n colones */
      /* (1b 5b Pn 42) vers le bas de n rangees */
      /* (1b 5b Pn 41) bers le haut de n rangees */
      /* (1b 5b Ps 4a) effacement en fonction de Ps :
	   Ps==0 Clear to end of page,
	   Ps==1 Clear from begin of page to current pos,  ;-)
	   Ps==2 Clear clear (pas de changement de pos) */
      /* (1b 5b Ps 4b) effacement en fonciton de Ps :
	   Ps==0 pos cur jusqu'en fin de la rangee
	   Ps==1 debut de ligne jusqu'en pos cur
	   Ps==2 efface toute la ligne (pas de modif de pos) */
      /* (1b 5b Pn 4c) insertion de Pn lignes */
      /* (1b 5b Pn 4d) suppression de Pn lignes */
      /* (1b 5b Pr 3b Pc 48) gotoxy() en rangee Pr et colonne Pc */
      }
}

/*--------------------------------------------------------------------------*/
/*        Gestion de la sequence REPetition caractere (0x12)                */
/*--------------------------------------------------------------------------*/
void VtxRepete (byte ch)
   {
   int i;

   val1 = ch - 0x40;
   VtxCount = 0;
   VtxSeq = 0;

   for (i = 0; i < val1; i++)
      mvputc (oldchar);
   }
/*--------------------------------------------------------------------------*/




/*--------------------------------------------------------------------------*/
/*        Gestion de la sequence Statut terminal (ESC 3A 6A/69 X             */
/*--------------------------------------------------------------------------*/
void VtxStatus (byte ch)
   {
   byte Switch;
   if (!VtxCount)
      {
      VtxCount++;
      val1 = ch;
      return;
      }

   val2 = ch;
   VtxSeq = 0;
   VtxCount = 0;
   if (val1 == 0x6A)
      Switch = 1;                    /* Switch "OFF" des machins */
   else
      if (val1 == 0x69)
         Switch = 0;                    /* Switch "ON"  des machins */
      else
	 if ((val1 == 0x32)|| (val1 == 0x31) )     /* passage mode 80 col, ici */
	    {                                      /* mal traite car provisoire*/
	    Fonctions (ALT_A);                     /* donc je mets juste ANSI..*/
            return;
            }

   else return;                    /* probablement une erreur de codage...*/

   if (val2 == 0x43)
      ModePage = Switch;
   ligne_statut ();                 /* Et on previent les gens...          */
   /* Le reste c'est pas pour nous:45h minuscules, 46h et 47h la loupe...*/
   /* On devrait renvoyer une sequence au serveur mais j'ai pas la doc, */
   /* alors... On fera sans.*/
   }
/*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/*        Sequence videotex vide pour filter ce que je ne comprends pas!    */
/*--------------------------------------------------------------------------*/
void VtxFiltre (void)    /* C'est du dlire a... Enfin a filtre ce qu'il  */
   {                     /* faut en fonction de la valeur de CountVtx...    */
   VtxCount++;
   if (VtxCount >= CountVtx)
      {
        VtxCount = 0;
        VtxSeq = 0;
      }
   }
/*--------------------------------------------------------------------------*/


/*--------------------------------------------------------------------------*/
/*        Sequence de protocole Videotex                                    */
/*--------------------------------------------------------------------------*/
void VtxPRO1 (ch)
char ch;

{
   VtxSeq = 0;
   switch( (int) ch)
         {
           case 'l' :                 /* Retournement modem */
                  Set_1200_75 ();
           break;

           case 0x7a :               /* Identification Ram2 */
            Send(NumPort, 0x01);
            Send(NumPort, 'B');     /* Je rponds BBTH !!! */
            Send(NumPort, 'B');
            Send(NumPort, 'T');
            Send(NumPort, 'H');
            Send(NumPort, 0x04);
           break;

           case 0x7b :               /* Identification ROM */
            Send(NumPort, 0x01);     /* Je rponds que je  */
            Send(NumPort, 'B');      /* suis une saloperie */
            Send(NumPort, 'r');      /* de minitel 1 simple*/
            Send(NumPort, '0');
            Send(NumPort, 0x04);
           break;

         }

}
/*--------------------------------------------------------------------------*/


#ifdef BBTH
/*--------------------------------------------------------------------------*/
/*        Affichage de l'ecran terminal videotex  (BBTH )                   */
/*--------------------------------------------------------------------------*/
 
void masque_vtx (void)
   {
      static byte flg[2] = { 27, 0  }; /* les petites fleches IBM */
      static byte flh[2] = { 24, 0  };
      static byte flb[2] = { 25, 0  };
      byte sour;

    if(cursouris)
    {
      sourisoff();
      sour=1;
    }
    else sour = 0;

   cls (Normal);
   box (MinX, MinY, MinVtX-1, MaxY, blanc_bleu);
   box (MaxVtX+1, MinY, MaxX, MaxY, blanc_bleu);

   mwrite (MinX+2, MinY+2, "ENVOI     :Enter", Blanc_bleu);
   mwrite (MinX+2, MinY+3, "GUIDE     :F1"  , Blanc_bleu);
   mwrite (MinX+2, MinY+4, "CONNEXION :F10" , Blanc_bleu);
   mwrite (MinX+2, MinY+5, "SOMMAIRE  :Home", Blanc_bleu);
   mwrite (MinX+2, MinY+6, "CORRECTION:" , Blanc_bleu);
   mwrite (MinX+13, MinY+6, flg, Blanc_bleu);/* fleche */
   mwrite (MinX+2, MinY+7, "ANNULATION:Del" , Blanc_bleu);
   mwrite (MinX+2, MinY+8, "REPETITION:F2"  , Blanc_bleu);
   mwrite (MinX+2, MinY+9, "RETOUR    :"    , Blanc_bleu);
   mwrite (MinX+13, MinY+9, flh, Blanc_bleu);/* fleche */

   mwrite (MinX+2, MinY+10, "SUITE     :"    , Blanc_bleu);
   mwrite (MinX+13, MinY+10, flb, Blanc_bleu);/*fleche */

   mwrite (MinX+2, MinY+15, "Mode Page/Scroll", Jaune_bleu);
   mwrite (MinX+2, MinY+16, "Bascule:      F3", Jaune_bleu);

   mwrite (MinX+2, MinY+18, "Intens. Couleur ", Jaune_bleu);
   mwrite (MinX+2, MinY+19, "              F4", Jaune_bleu);

   mwrite (MinX+2, MaxY-2, "Aide......ALT-Z", Jaune_bleu);

   mwrite (MaxVtX+3, MinY+2, "Terminal MINITEL", Jaune_bleu);
   mwrite (MaxVtX+3, MinY+3, "en   mode  texte", Jaune_bleu);

   mwrite (MaxVtX+3, MinY+5, "   -----------" , blanc_bleu);

#ifdef BBTH
   mwrite (MaxVtX+3, MinY+7,  "Ce mode  terminal", Cyan_bleu);
   mwrite (MaxVtX+3, MinY+8,  "est    simplement", Cyan_bleu);
   mwrite (MaxVtX+3, MinY+9,  "destin  tablir", Cyan_bleu);
   mwrite (MaxVtX+3, MinY+10, "une communication", Cyan_bleu);

   mwrite (MaxVtX+3, MinY+12, "N'en attendez pas", Cyan_bleu);
   mwrite (MaxVtX+3, MinY+13, "des  miracles !!!", Cyan_bleu);

   mwrite (MaxVtX+3, MinY+15, "   -----------" , blanc_bleu);
#else
   mwrite (MaxVtX+3, MinY+15, "Intensit Couleur", Jaune_bleu);
   mwrite (MaxVtX+3, MinY+16, "Normale/Haute: F4", Jaune_bleu);
#endif

#ifdef BBTH
   if (MaxY > 24) /* Donc on est en EGA 43 lignes ou +, on encadre l'ecran */
      {
        box (MinVtX, 0, MaxVtX, MinVtY-1, blanc_bleu);
        box (MinVtX, MaxVtY+1, MaxVtX, MaxY, blanc_bleu);
      }

#else
#include "boites.h"
   if (MaxY > 24) /* Donc on est en EGA 43 lignes ou +, on encadre l'ecran */
      {
        wt_draw_box (MinVtX-1, 0, MaxVtX+1, MinVtY-1,32,blanc_bleu,PLEIN);
        wt_draw_box (MinVtX-1, MaxVtY+1, MaxVtX+1, MaxY,32, blanc_bleu,PLEIN);
      }
#endif
   cls_vtx ();

   if(sour) sourison();
   }
/*--------------------------------------------------------------------------*/
#else
/*--------------------------------------------------------------------------*/
/*        Affichage de l'ecran terminal videotex  (ALPHACOM )               */
/*--------------------------------------------------------------------------*/
#include "boites.h"
void masque_vtx (void)
   {
      static byte flg[2] = { 27, 0  }; /* les petites fleches IBM */
      static byte flh[2] = { 24, 0  };
      static byte flb[2] = { 25, 0  };
      byte sour;

    if(cursouris)
    {
      sourisoff();
      sour=1;
    }
    else sour = 0;

   cls (Normal);
   box (MinX, MinY, MinVtX-1, MaxY, blanc_bleu);
   box (MaxVtX+1, MinY, MaxX, MaxY, blanc_bleu);

   mwrite (MinX+2, MinY+2, "ENVOI     :Enter", Blanc_bleu);
   mwrite (MinX+2, MinY+3, "SUITE     :F1"  , Blanc_bleu);
   mwrite (MinX+2, MinY+4, "RETOUR    :F2"  , Blanc_bleu);
   mwrite (MinX+2, MinY+5, "REPETITION:F3"  , Blanc_bleu);
   mwrite (MinX+2, MinY+6, "GUIDE     :F4"  , Blanc_bleu);
   mwrite (MinX+2, MinY+7, "ANNULATION:F5"  , Blanc_bleu);
   mwrite (MinX+2, MinY+8, "SOMMAIRE  :F6"  , Blanc_bleu);
   mwrite (MinX+2, MinY+9, "CORRECTION:F7"  , Blanc_bleu);
   mwrite (MinX+2, MinY+10,"CNX/FIN   :F9"  , Blanc_bleu);

   mwrite (MinX+2, MinY+15, "Mode Page/Scroll", Jaune_bleu);
   mwrite (MinX+2, MinY+16, "Bascule:SHIFT_F3", Jaune_bleu);

   mwrite (MinX+2, MaxY-2, "Aide......ALT-Z", Jaune_bleu);

   mwrite (MaxVtX+3, MinY+2, "Terminal MINITEL", Jaune_bleu);
   mwrite (MaxVtX+3, MinY+3, "en   mode  texte", Jaune_bleu);

   mwrite (MaxVtX+3, MinY+5, "   -----------" , blanc_bleu);

   mwrite (MaxVtX+3, MinY+15, "Intensit Couleur", Jaune_bleu);
   mwrite (MaxVtX+3, MinY+16, "    SHIFT_ F4", Jaune_bleu);

   if (MaxY > 24) /* Donc on est en EGA 43 lignes ou +, on encadre l'ecran */
      {
        wt_draw_box (MinVtX-1, 0, MaxVtX+1, MinVtY-1,32,blanc_bleu,PLEIN);
        wt_draw_box (MinVtX-1, MaxVtY+1, MaxVtX+1, MaxY,32, blanc_bleu,PLEIN);
      }
   cls_vtx ();

   if(sour) sourison();
   }
/*--------------------------------------------------------------------------*/
#endif

/*--------------------------------------------------------------------------*/
/*     Modif de l'attribut couleur videotex courant                         */
/*--------------------------------------------------------------------------*/
/*
*/

void SetVtxColor (byte forme, byte fond)
   {
   byte Coul1, Coul2;

   if ( !FlagCouleur ) return;

   if (Inversion)
	{
	Coul1 = fond;
	Coul2 = forme;
	}
   else
	{
	Coul1 = forme;
	Coul2 = fond;
	}

#ifdef DEBUG_VTX
   if ( Coul1 < 0 || Coul1 > 7 || Coul2 < 0 || Coul2 > 7 )
   {
   locate( 1, 1 );
   printf("Warning Bug: Coul1=%d Coul2=%d\n", Coul1, Coul2 );
   }
#endif

   /* Couleur caractere */
   CurAttr = VtxTable [ Coul1 ];

   /* Couleur du fond   */
   CurAttr |= VtxTable [ Coul2 + 8 ];

    if(Coul1)   CurAttr |= VtxHigh;    /* Surentensit, mais pas en noir*/
    else        CurAttr &=~VtxHigh;    /* sinon ca fait gris sale.      */
}
/*--------------------------------------------------------------------------*/

#ifdef DEBUG_VTX
/* Gros caca (Comme le minitel) pour voir les codes INFAME qu'il balance */
static char dbl[80] = "\0";
static char dbc[80] = "\0";
static int  dbn=0;

debugvdx( ch )
char ch;
{
   char tmp1[ 80 ];
   char tmp2[ 80 ];
   byte oattrib;

   if ( ch < 0 || ch > 128 ) return;

   sprintf( tmp1, "(%03d) $%02x '%c'", ch, ch, ch );
   mwrite ( MaxVtX+4, MaxVtY+2, tmp1, Jaune_bleu );
   sprintf( tmp1, "CurAttr = %02x", CurAttr );
   mwrite ( MaxVtX+4, MaxVtY+1, tmp1, Jaune_bleu );
   sprintf( tmp1, "VtxFond = %02x", VtxFond );
   mwrite ( MaxVtX+4, MaxVtY, tmp1, Jaune_bleu );
   sprintf( tmp1, "VtxForme= %02x", VtxForme );
   mwrite ( MaxVtX+4, MaxVtY-1, tmp1, Jaune_bleu );

   sprintf( tmp1, "%02x ", ch );
   sprintf( tmp2, "%c  ", ch );
   if ( dbn++ < 10 )
       {
       strcat( dbl, tmp1 );
       strcat( dbc, tmp2 );
       }
   else
       {
       dbn=0;
       strcpy( dbl, tmp1 );
       strcpy( dbc, tmp2 );
       oattrib = CurAttr;
       CurAttr = Jaune_bleu;
       Scroll_up ( 1, MinVtX+2, MinVtY-8, MaxVtX-2, MinVtY-2 );
       Scroll_up ( 1, MinVtX+2, MaxVtY+2, MaxVtX-2, MaxVtY+8 );
       CurAttr = oattrib;
       }

   mwrite( MinVtX+4, MaxVtY+8, dbl, Jaune_bleu );
   mwrite( MinVtX+4, MinVtY-2, dbc, Jaune_bleu );
}
/*--------------------------------------------------------------------------*/
VtxDebug( txt )
char *txt;
{
   char tmp[40];
   sprintf( tmp,"%-15.15s", txt );
   mwrite ( MaxVtX+4, MaxVtY-3, tmp, Jaune_bleu );
}
#endif /* DEBUG_VTX */
/*--------------------------------------------------------------------------*/
Scroll_down_Min(n,x1,y1,x2,y2)
{
 Scroll_down(n,x1,y1,x2,y2);
}
Scroll_up_Min(n,x1,y1,x2,y2)
{
 Scroll_up(n,x1,y1,x2,y2);
}
/*--------------------------------------------------------------------------*/
