/*
  ͻ
                                                                         
             DOMAINE      IBM-PC   MS-DOS(3.x+)      
                            PUBLIC                                 
                 Ren   Le protocole de Transfert BBT  
                          Cougnenc est de Jean-Claude Michot.     
                1989   La librairie de Comm.est de    
                                          Jean-Pierre Parisy & R.Gillmann
  Ķ
                                                                          
                    MODULE: XYMODEM.C                                     
                    -----------------                                     
                                                                          
       Emission et rception en Xmodem-Checksum, Xmodem-CRC  et           
       X-Modem 1K  (dit souvent Ymodem  tort...)                         
                                                                          
       (La difference d'indexation du buffer dans les 2 fonctions est     
       due au fait que le SOH n'est pas mis dans le buffer en mode        
       rception,alors qu'il est inclus dedans en mission... )           
                                                                          
   Compilation: modle mmoire LARGE                                      
  Ķ
   Vous pouvez distribuer  ce  programme et  ses sources  qui bon vous   
   semble,  condition de ne sparer aucun des modules qui le composent   
   et de le faire GRATUITEMENT.                                           
                                                                          
   Si vous demandez plus que le prix d'une disquette vierge pour fournir  
   ce programme  quelqu'un,vous tes un vil exploiteur  qui se rit des   
   nombreuses heures de travail BENEVOLE de plusieurs personnes,et mme   
   le gigantesque repas que vous devrez offrir   tous  nos  copains     
   La Tour D'Argent ne saura vous faire pardonner de votre bassesse.      
  ͼ
  Ŀ
   BbtH 1.1 
  
*/

/*--------------------------------------------------------*/
#ifndef __TURBOC__   /* Borland Turbo-c 1.5               */
#ifndef MSDOS        /* Microsoft C                       */
#error Mfiance ! je ne connais pas ce compilateur l...
#endif
#endif
/*--------------------------------------------------------*/


#ifndef __TURBOC__
#include <sys/types.h>
#include <memory.h>
#else
#include <mem.h>
#endif

#include<fcntl.h>
#include<sys/stat.h>
#include<time.h>


#include<io.h>

#include "bbth.h"
#include "config.h"
#include "commpkg.h"
#include "couleurs.h"
#include "clavecra.h"
#include "system.h"
#include "bbt.h"
#include "xymodem.h"




/*-------------------------------------------------------------------------*/
/*     Affichage de la fenetre de transfert X/Ymodem                       */
/*-------------------------------------------------------------------------*/
void XmodemBox(byte mode)
{
 static byte NomFichier[20]="";

   box(20,10,45,22,Cyan_vert);
   mwrite(22,12,"Fichier:"             ,Jaune_vert);
   mwrite(22,15,"Vitesse:0      Cps"   ,Jaune_vert);
   mwrite(22,17,"Erreurs:0"            ,Jaune_vert);

 if(mode==RECEPTION)
  {
   mwrite(23,10," RECEPTION   XMODEM "  ,Inverse);

   mwrite(22,14,"Reu   :0      Octets",Jaune_vert);
   mwrite(22,15,"Vitesse:0      Cps"   ,Jaune_vert);
   mwrite(22,16,"X-Modem:CRC"          ,Jaune_vert);
  }

 if(mode==EMISSION)
  {

   mwrite(23,10," EMISSION    XMODEM " ,Inverse);
   mwrite(22,13,"Taille :       Octets",Jaune_vert);
   mwrite(22,14,"Reste  :       Octets",Jaune_vert);

   mwrite(22,16,"X-Modem:Checksum"     ,Jaune_vert);

  }
   mwrite(24,19," Dernier Message: ",Inverse);
  filtre_filename(NomFichier,BbtFile);
 mwrite(30,12,NomFichier,Blanc_vert);
/* Auteur_Xmodem(); */
}
                 /*-----------------------------*/

void XmodemMsg(byte *texte) /* message affich dans la fenetre */
{
  mwrite(22,21,"                      ",Blanc_vert);/* efface ancien message */
  mwrite(22,21,texte,Blanc_vert);
}
/*-------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*        RecupChar: Lit le port serie et teste le clavier.

          Si maxdelay entre deux caracteres, une erreur compte.
          SI Maxerreurs atteint, retourne -1
          Si CNtrl=X frapp,retourne      -2

*/

int RecupChar(int maxdelay,int maxerreurs)
{
 long Time0,Time1;
 int erreurs = 0;
 byte     ch = 0;

 time(&Time0);

  while(!PortReady(NumPort))
       {
        if(kbhit())ch=getch();
        if(ch==24) return(-2);
        time(&Time1);
        if( (int) (Time1-Time0) >maxdelay)
          {
           erreurs++;
           time(&Time0);
          }
        if(erreurs >maxerreurs)return(-1);
       }
  ch=(byte)Receive(NumPort);
return((int)ch);
}
/*-------------------------------------------------------------------------*/


/*-------------------------------------------------------------------------*/
/*  Routine conseille par Forsberg: attend un time-out signifiant qu'il   */
/*  n'y a plus rien a recevoir sur la ligne.                               */

void PurgeLine(void)
{
 while(RecupChar(1,1)!=-1);
}
/*-------------------------------------------------------------------------*/




/*-------------------------------------------------------------------------*/
/*

      Calcul du crc:extrait de la documentation de Chuck Forsberg

         Figure 8.  Example of CRC Calculation written in C


    This function calculates the CRC used by the XMODEM/CRC Protocol
    The first argument is a pointer to the message block.
    The second argument is the number of bytes in the message block.
    The function returns an integer which contains the CRC.
    The low order 16 bits are the coefficients of the CRC.
*/

   int calcrc(char *ptr, int count)
   {
       int crc, i;

       crc = 0;
       while(--count >= 0)
           {
           crc = crc ^ (int)*ptr++ << 8;
           for(i = 0; i < 8; ++i)
               if(crc & 0x8000)
                   crc = crc << 1 ^ 0x1021;
               else
                   crc = crc << 1;
           }
       return (crc & 0xFFFF);
   }

/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*
        Rception Xmodem,Xmodem-CRC et Xmodem-1K (Y-MODEM)

      La foncton determine X ou Y modem en fonction du paramtre taillebloc:

         X-MODEM:taillebloc=128
         Y-MODEM:taillebloc:1024

     Toute autre valeur fera n'importe quoi...

     Selon les recommandations, si aucune rponse en temps voulu n'est recue
      la demande de CRC, le mode checksum est utilis.
*/

int Xmodem_Receive(int taillebloc, int fichier)
{
 byte buffer[1030];
 byte BufTxt[30];
 byte Somme,
      ChkRecu,
      ModeCrc    =1,
      NumBloc    =1,
      BlocRecu;

long  byte_cpt=0L,
      Time0,
      Time1;
int i,
    StartBloc,
    ch           = 0,
    car          = 0,
    Alire        = 0,
    erreurs      = 0,
    erreur_cpt   = 0,
    BadCrc       = 0,
    BadNumber    = 0,
    BlocSize;

unsigned  Crc,
          CrcRecu;


XmodemBox(RECEPTION);

 BlocSize=taillebloc;
 if  (BlocSize==1024)
     {
       mwrite(36,10,"Y",Inverse);      /* affiche Ymodem a la place de X */
       mwrite(30,16,"1 Ko",Blanc_vert);
       StartBloc=STX;
     }
     else StartBloc=SOH;



                  /*--------------------- Boucle d'attente entete  */

 while((ch !=StartBloc) && (ch != CAN)) /* ON commence a demander du CRC */
 {
  Send(NumPort,CAK);
   ch=RecupChar(1,3);                   /* avecun time-out de 3 secondes */
    if(ch==-2) ch=CAN;                  /* selon les recommandations     */
    if(ch==-1) Send(NumPort,CAK);
   erreurs++;
  if(erreurs >4)                        /* Si au bout de 10 secondes on  */
    {                                   /* n'a rien recu, on passe en    */
     if(StartBloc !=STX)                /* mode CheckSum, sauf si l'on   */
       {                                /* est en faux Ymodem            */
         ModeCrc=0;
         erreurs=0;
         mwrite(30,16,"CheckSum",Blanc_vert);
       }
     break;
    }
 }



 while ((ch != StartBloc) && (ch != CAN))
 {
   Send(NumPort,NAK);
     ch=RecupChar(1,5);
      if(ch==-2) ch=CAN;
      if(ch==-1) Send(NumPort,NAK);
    erreurs++;
   if(erreurs >5)
     {
      XmodemMsg(" Time out pour moi...");
       Send(NumPort,CAN);
        beep(3);
       delay(2000);
      return(0);
     }
 }



/* A partir d'ici ch=StartBLoc ou CAN ou EOT */

if (ch == CAN)
   {

    XmodemMsg("Abandon du Transfert");
     beep(3);
     delay(2000);
    return(0);
   }

  if(ModeCrc) Alire=BlocSize+4;
  else        Alire=BlocSize+3;

  time(&Time0);
  while(1) /*--------------------- Boucle de reception ------------------*/
   {
    switch(ch)
       {
        case SOH :
        case STX :

                  Somme    = NUL;
                  Crc      = NUL;
                  BlocSize = 128;                 /* Par defaut,bloc x-modem */
                  memset(buffer,0,sizeof(buffer));
                  if(ch==STX)BlocSize=1024;        /* On est en Ymodem        */
                  if(ModeCrc) Alire=BlocSize+4;
                  else        Alire=BlocSize+3;
                  for (i=0; i < Alire; i++)
                      {
                       car=RecupChar(WAIT_TIME,MAXERREURS);
                       if(car==-1)
                          {
                           XmodemMsg("    Time Out !!!");
                            beep(3);
                             PurgeLine();
                             Send(NumPort,CAN);
                            delay(2000);
                           return(0);
                          }
                       if(car==-2)
                          {
                           XmodemMsg("Abandon utilisateur !!!");
                            beep(3);
                             PurgeLine();
                             Send(NumPort,CAN);
                            delay(2000);
                           return(0);
                          }
                       buffer[i] =(byte)car;
                      }
                      BlocRecu= buffer[0];

                  if(ModeCrc)
                    {
                      CrcRecu = (buffer[BlocSize+2]*256)+buffer[BlocSize+3];
                      Crc=calcrc(buffer+2,BlocSize);
                    }
                  else
                    {
                     ChkRecu = buffer[BlocSize+2];
                     for(i=2;i<BlocSize+2;i++)Somme+=buffer[i];
                    }

                                          /* contrle CRC et numro bloc OK */

                    BadCrc=0;
                    if(ModeCrc)
                      {
                       if (CrcRecu !=Crc)    BadCrc=1;
                      }
                    else
                      {
                       if (ChkRecu != Somme) BadCrc=1;
                      }
                    BadNumber=0;
                    if (BlocRecu  > NumBloc) BadNumber=2;
                    if (BlocRecu  < NumBloc) BadNumber=1;




                  if((BadCrc)||( BadNumber==2))
                     {
                      erreur_cpt = erreur_cpt + 1;
                      if(erreur_cpt >MAXTOTERRORS)
                          {
                           XmodemMsg("  Trop d'erreurs !!!");
                            beep(3);
                             PurgeLine();
                             Send(NumPort,CAN);
                            delay(2000);
                           return(0);
                          }
                       erreurs = erreurs + 1;
                       if(erreurs >MAXBLOCERRORS)
                          {
                           XmodemMsg("Trop de Retries.Stop.");
                            beep(3);
                             PurgeLine();
                             Send(NumPort,CAN);
                            delay(2000);
                           return(0);
                          }
                        itoa(erreur_cpt,BufTxt,10);
                        mwrite(30,17,BufTxt,Blanc_vert);
                       Send(NumPort, NAK);
                      XmodemMsg("  Paquet redemand.");
                     }


                   if( (!BadCrc)&&(!BadNumber) ) /* Tout va bien */
                     {
                      time(&Time1);
                       erreurs = 0;
                        NumBloc++;
                         byte_cpt = byte_cpt + (long)BlocSize;
                          ltoa(byte_cpt,BufTxt,10);
                          mwrite(30,14,BufTxt,Blanc_vert);
                         TraSpeed(Time0,Time1,byte_cpt);
                        write(fichier,buffer+2,BlocSize);
                       Send (NumPort,ACK);
                      XmodemMsg("    Paquet Correct");
                     }


                   if( BadNumber==1 ) /* On a deja recu ce bloc la */
                     {
                       erreurs = 0;
                         Send(NumPort, ACK);
                       XmodemMsg(" Bloc dj reu.");
                     }



        break;

        case CAN :
                  PurgeLine();
                   Send(NumPort,CAN);
                    XmodemMsg(" Abandon par serveur");
                   beep(3);
                  delay(2000);
        return(0);


        case   EOT:
             Send(NumPort, ACK);
              XmodemMsg(" Rception Termine");
              beep(3);
             delay(2000);
        return(1);

        default:
              XmodemMsg("Rien compris.. Abandon.");
               beep(3);
              delay(2000);
        return(0);

       }
       ch=RecupChar(WAIT_TIME,MAXERREURS);   /* Attente du nouveau SOH */
       if(ch <0 || ch==CAN)
         {
          XmodemMsg(" Transfert abandonn");
           delay(2000);
           beep(3);
          return(0);
         }
   }
}
/*--------------------------------------------------------------------------*/



/*--------------------------------------------------------------------------*/
/*
        Emission  Xmodem,Xmodem-CRC et Xmodem-1K (Y-MODEM)

      La foncton determine X ou Y modem en fonction du paramtre taillebloc:

         X-MODEM:taillebloc=128
         Y-MODEM:taillebloc:1024

     Toute autre valeur fera n'importe quoi...

     Selon les recommandations, la fonction ne renvoie jamais d'elle mme
     un paquet, elle attend l'ordre du recepteur.

     En mode Ymodem,le dernier paquet peut tre de 128 octets, mais le
     bloc reste  1 Ko meme en cas de retries nombreux. (bof...)

*/

int Xmodem_Send(int taillebloc, int fichier)
{
 byte buffer[1030];
 byte BufTxt[30];
 byte Somme,
      ModeCrc    =1,
      NumBloc    =1;

long  byte_cpt=0L,
      FileSize,
      Time0,
      Time1;
int i,
    repete,
    StartBloc,
    ch           = 0,
    Alire        = 0,
    erreurs      = 0,
    erreur_cpt   = 0,
    BlocSize,
    BlocLu;

unsigned  Crc;


XmodemBox(EMISSION);

 FileSize=filelength(fichier);
 byte_cpt=FileSize;                    /* Affiche la taille du fichier    */
 ltoa(byte_cpt,BufTxt,10);
 mwrite(30,13,BufTxt,Blanc_vert);

 BlocSize=taillebloc;
 if  (BlocSize==1024)
     {
       mwrite(36,10,"Y",Inverse);      /* affiche Ymodem a la place de X */
       mwrite(30,16,"1 Ko    ",Blanc_vert);
       StartBloc=STX;
     }
     else StartBloc=SOH;


while ((ch != NAK) && (ch != CAK))   /* Attente acquittement recepteur  */
 {
  i=0;

     ch=RecupChar(1,5);

      if(ch==-1) erreurs++;

      if(ch==-2)
               {
                 XmodemMsg(" Abandon Utilisateur !");
                 i=1;
               }

    if(erreurs >5)
               {
                 XmodemMsg(" Time-out de mon ct");
                 i=1;
               }

     if(ch==CAN)
               {
                 XmodemMsg("Annul par le Serveur");
                 i=1;
               }

    if(i)
     {
       Send(NumPort,CAN);
         beep(3);
         delay(2000);
       return(0);
     }
 }

if(ch==NAK) ModeCrc=0;
if((ch==CAK)&&(taillebloc==128))
    mwrite(30,16,"CRC     ",Blanc_vert);



  if(ModeCrc) Alire=BlocSize+5;
  else        Alire=BlocSize+4;

time(&Time0);
repete=0;
while(1)                /*----------------- boucle d'mission ---------------*/
       {
        if(!repete)     /* Creation d'un paquet de donnes */
           {
            Somme= NUL;
            Crc  = NUL;
            memset(buffer,0x1A,sizeof(buffer)); /* Tradition en cas d'ascii */
            buffer[0]=StartBloc;
            buffer[1]=NumBloc;
            buffer[2]=0xFF-NumBloc;
            BlocLu=read(fichier,buffer+3,BlocSize);
                if(BlocLu ==-1)
                             {
                              XmodemMsg("Erreur Lecture fichier!");
                                Send(NumPort,CAN);
                                 beep(3);
                                delay(2000);
                              return(0);
                             }

                if(BlocLu==0)  /* Fin de fichier */
                            {
                              Send(NumPort,EOT);
                               ch=RecupChar(1,5);
                                if(ch !=ACK)
                                 Send(NumPort,EOT);
                                  ch=RecupChar(1,5);
                                 XmodemMsg("  Transfert Termin.");
                                beep(3);
                               delay(2000);
                              return(1);
                            }
               if(taillebloc==1024) /* le dernier paquet peut re court */
                                  {
                                   if(BlocLu <= 128)
                                     {
                                      BlocSize=128;
                                      buffer[0]=SOH;
                                     }
                                  }

               if(ModeCrc)
                 {
                   Crc=calcrc(buffer+3,BlocSize);
                   buffer[BlocSize+3]=(byte)(Crc/256);
                   buffer[BlocSize+4]=(byte) (Crc-(buffer[BlocSize+2]*256));
                 }
                 else
                    {
                      for(i=3;i<BlocSize+3;i++)Somme+=buffer[i];
                      buffer[BlocSize+3]=Somme;
                    }
           }

           for(i=0;i<Alire;i++)Send(NumPort,buffer[i]); /* Envoi Paquet */
           ch=RecupChar(1,5);
           switch(ch)
                  {
                   case -2 :
                       XmodemMsg("Abandon Utilisateur.");
                         Send(NumPort,CAN);
                         beep(3);
                       delay(2000);
                   return(0);

                   case NAK:    /* Le Recepteur redemande le paquet */
                       XmodemMsg("  Paquet redemand");
                       repete=1;
                       erreurs++;
                       erreur_cpt++;
                       itoa(erreur_cpt,BufTxt,10);
                       mwrite(30,17,BufTxt,Blanc_vert);
                       if((erreurs >MAXBLOCERRORS)||(erreur_cpt >MAXTOTERRORS))
                         {
                           XmodemMsg("Trop d'erreurs ! Stop.");
                            Send(NumPort,CAN);
                             beep(3);
                            delay(2000);
                           return(0);
                         }
                   break;

                   case ACK:              /* Paquet correctement acquit */
                        time(&Time1);
                         XmodemMsg("  Paquet bien reu");
                          repete=0;
                           NumBloc++;
                            byte_cpt-=(long)BlocSize;
                            ltoa(byte_cpt,BufTxt,10);
                          mwrite(30,14,"       ",Blanc_vert);
                         mwrite(30,14,BufTxt,Blanc_vert);
                        TraSpeed(Time0,Time1,FileSize-byte_cpt);
                   break;


                   default :    /* Le Recepteur envoie du caca */
                       XmodemMsg("  Paquet Rexpdi");
                       repete=1;
                       erreurs++;
                       erreur_cpt++;
                       itoa(erreur_cpt,BufTxt,10);
                       mwrite(30,17,BufTxt,Blanc_vert);
                       if((erreurs >MAXBLOCERRORS)||(erreur_cpt >MAXTOTERRORS))
                         {
                           XmodemMsg("Trop d'erreurs ! Stop.");
                            Send(NumPort,CAN);
                             beep(3);
                            delay(2000);
                           return(0);
                         }
                   break;
                  }
       }
}
/*---------------------------------------------------------------------------*/


#ifdef NONNON
/*-------------------------------------------------------------------------*/
   void Auteur_Xmodem(void)
   {
     mwrite(MaxX-24,"A propos",cyan_bleu);
     mwrite(MaxX-26 ,  MinY  ,"          Ŀ",blanc_bleu);
     mwrite(MaxX-26 ,  MinY+1," Le  protocole  X-MODEM ",blanc_bleu);
     mwrite(MaxX-26 ,  MinY+2," a t cr en 1977 par ",blanc_bleu);
     mwrite(MaxX-26 ,  MinY+3," Christensen &  Person. ",blanc_bleu);
     mwrite(MaxX-26 ,  MinY+4,"",blanc_bleu);
   }
/*-------------------------------------------------------------------------*/
#endif
